import { providers, Signer } from 'ethers';
import { AddressLike } from '@crestproject/crestproject';
import { Dispatcher, StandardToken } from '@melonproject/protocol';
import { ReleaseDeploymentConfig } from './deployment';
import mainnet from '../../mainnet.json';
declare type MainnetConfig = typeof mainnet;
declare type MainnetWhales = {
    [TKey in keyof MainnetConfig['whales']]: Signer;
};
declare type MainnetTokens = {
    [TKey in keyof MainnetConfig['tokens']]: StandardToken;
};
export interface ForkReleaseDeploymentConfig extends ReleaseDeploymentConfig {
    mainnet: MainnetConfig;
    tokens: MainnetTokens;
    whales: MainnetWhales;
}
export declare function configureForkRelease({ provider, deployer, mgm, dispatcher, accounts, }: {
    provider: providers.JsonRpcProvider;
    deployer: Signer;
    mgm: Signer;
    dispatcher: Dispatcher;
    accounts: Signer[];
}): Promise<ForkReleaseDeploymentConfig>;
export declare function makeEthRich(sender: Signer, receiver: AddressLike): Promise<providers.TransactionResponse>;
export declare function makeTokenRich(token: StandardToken, sender: Signer, receiver: AddressLike): Promise<void>;
export {};
