import { providers } from 'ethers';
export declare function defaultTestDeployment(provider: providers.JsonRpcProvider): Promise<{
    config: import("./deployment").ReleaseDeploymentConfig;
    accounts: providers.JsonRpcSigner[];
    deployment: {
        [x: string]: any;
        comptrollerLib: import("@melonproject/protocol").ComptrollerLib;
        fundDeployer: import("@melonproject/protocol").FundDeployer;
        fundLifecycleLib: import("@melonproject/protocol").FundLifecycleLib;
        permissionedVaultActionLib: import("@melonproject/protocol").PermissionedVaultActionLib;
        vaultLib: import("@melonproject/protocol").VaultLib;
        engine: import("@melonproject/protocol").Engine;
        valueInterpreter: import("@melonproject/protocol").ValueInterpreter;
        feeManager: import("@melonproject/protocol").FeeManager;
        integrationManager: import("@melonproject/protocol").IntegrationManager;
        policyManager: import("@melonproject/protocol").PolicyManager;
        chainlinkPriceFeed: import("@melonproject/protocol").ChainlinkPriceFeed;
        aggregatedDerivativePriceFeed: import("@melonproject/protocol").AggregatedDerivativePriceFeed;
        chaiPriceFeed: import("@melonproject/protocol").ChaiPriceFeed;
        chaiAdapter: import("@melonproject/protocol").ChaiAdapter;
        engineAdapter: import("@melonproject/protocol").EngineAdapter;
        kyberAdapter: import("@melonproject/protocol").KyberAdapter;
        trackedAssetsAdapter: import("@melonproject/protocol").TrackedAssetsAdapter;
        zeroExV2Adapter: import("@melonproject/protocol").ZeroExV2Adapter;
        entranceRateFee: import("@melonproject/protocol").EntranceRateFee;
        managementFee: import("@melonproject/protocol").ManagementFee;
        performanceFee: import("@melonproject/protocol").PerformanceFee;
        adapterBlacklist: import("@melonproject/protocol").AdapterBlacklist;
        adapterWhitelist: import("@melonproject/protocol").AdapterWhitelist;
        assetBlacklist: import("@melonproject/protocol").AssetBlacklist;
        assetWhitelist: import("@melonproject/protocol").AssetWhitelist;
        maxConcentration: import("@melonproject/protocol").MaxConcentration;
        investorWhitelist: import("@melonproject/protocol").InvestorWhitelist;
        fundCalculator: import("@melonproject/protocol").FundCalculator;
        dispatcher: import("@melonproject/protocol").Dispatcher;
        tokens: {
            weth: import("@melonproject/protocol").WETH;
            mln: import("@melonproject/protocol").MockToken;
            rep: import("@melonproject/protocol").MockToken;
            knc: import("@melonproject/protocol").MockToken;
            zrx: import("@melonproject/protocol").MockToken;
            dai: import("@melonproject/protocol").MockToken;
            ren: import("@melonproject/protocol").MockToken;
        };
        kyberIntegratee: import("@melonproject/protocol").MockKyberIntegratee;
        chaiIntegratee: import("@melonproject/protocol").MockChaiIntegratee;
        mockGenericAdapter: import("@melonproject/protocol").MockGenericAdapter;
        mockGenericIntegratee: import("@melonproject/protocol").MockGenericIntegratee;
        chainlinkEthUsdAggregator: import("@melonproject/protocol").MockChainlinkPriceSource;
        chainlinkAggregators: {
            mln: import("@melonproject/protocol").MockChainlinkPriceSource;
            rep: import("@melonproject/protocol").MockChainlinkPriceSource;
            knc: import("@melonproject/protocol").MockChainlinkPriceSource;
            zrx: import("@melonproject/protocol").MockChainlinkPriceSource;
            dai: import("@melonproject/protocol").MockChainlinkPriceSource;
            ren: import("@melonproject/protocol").MockChainlinkPriceSource;
        };
        chaiPriceSource: import("@melonproject/protocol").MockChaiPriceSource;
    };
}>;
export declare function defaultForkDeployment(provider: providers.JsonRpcProvider): Promise<{
    config: import("./fork").ForkReleaseDeploymentConfig;
    accounts: providers.JsonRpcSigner[];
    deployment: {
        [x: string]: any;
        comptrollerLib: import("@melonproject/protocol").ComptrollerLib;
        fundDeployer: import("@melonproject/protocol").FundDeployer;
        fundLifecycleLib: import("@melonproject/protocol").FundLifecycleLib;
        permissionedVaultActionLib: import("@melonproject/protocol").PermissionedVaultActionLib;
        vaultLib: import("@melonproject/protocol").VaultLib;
        engine: import("@melonproject/protocol").Engine;
        valueInterpreter: import("@melonproject/protocol").ValueInterpreter;
        feeManager: import("@melonproject/protocol").FeeManager;
        integrationManager: import("@melonproject/protocol").IntegrationManager;
        policyManager: import("@melonproject/protocol").PolicyManager;
        chainlinkPriceFeed: import("@melonproject/protocol").ChainlinkPriceFeed;
        aggregatedDerivativePriceFeed: import("@melonproject/protocol").AggregatedDerivativePriceFeed;
        chaiPriceFeed: import("@melonproject/protocol").ChaiPriceFeed;
        chaiAdapter: import("@melonproject/protocol").ChaiAdapter;
        engineAdapter: import("@melonproject/protocol").EngineAdapter;
        kyberAdapter: import("@melonproject/protocol").KyberAdapter;
        trackedAssetsAdapter: import("@melonproject/protocol").TrackedAssetsAdapter;
        zeroExV2Adapter: import("@melonproject/protocol").ZeroExV2Adapter;
        entranceRateFee: import("@melonproject/protocol").EntranceRateFee;
        managementFee: import("@melonproject/protocol").ManagementFee;
        performanceFee: import("@melonproject/protocol").PerformanceFee;
        adapterBlacklist: import("@melonproject/protocol").AdapterBlacklist;
        adapterWhitelist: import("@melonproject/protocol").AdapterWhitelist;
        assetBlacklist: import("@melonproject/protocol").AssetBlacklist;
        assetWhitelist: import("@melonproject/protocol").AssetWhitelist;
        maxConcentration: import("@melonproject/protocol").MaxConcentration;
        investorWhitelist: import("@melonproject/protocol").InvestorWhitelist;
        fundCalculator: import("@melonproject/protocol").FundCalculator;
        dispatcher: import("@melonproject/protocol").Dispatcher;
    };
}>;
