import { AddressLike } from '@crestproject/crestproject';
import { BigNumber, BigNumberish, Signer, utils } from 'ethers';
import { IFee, FeeManager } from '@melonproject/protocol';
export declare enum feeHooks {
    Continuous = 0,
    PreBuyShares = 1,
    PostBuyShares = 2,
    PreRedeemShares = 3
}
export declare enum feeManagerActionIds {
    SettleContinuousFees = 0
}
export declare enum feeSettlementTypes {
    None = 0,
    Direct = 1,
    Mint = 2,
    MintSharesOutstanding = 3,
    BurnSharesOutstanding = 4
}
export declare function generateFeeManagerConfigWithMockFees({ deployer, feeManager, }: {
    deployer: Signer;
    feeManager: FeeManager;
}): Promise<Uint8Array>;
export declare function generateRegisteredMockFees({ deployer, feeManager, }: {
    deployer: Signer;
    feeManager: FeeManager;
}): Promise<{
    mockContinuousFee1: import("@crestproject/crestproject").MockContract<IFee>;
    mockContinuousFee2: import("@crestproject/crestproject").MockContract<IFee>;
    mockPostBuySharesFee: import("@crestproject/crestproject").MockContract<IFee>;
}>;
export declare function settlePreBuySharesArgs({ buyer, investmentAmount, minSharesQuantity, gav, }: {
    buyer?: AddressLike;
    investmentAmount?: BigNumberish;
    minSharesQuantity?: BigNumberish;
    gav?: BigNumberish;
}): Promise<Uint8Array>;
export declare function settlePostBuySharesArgs({ buyer, investmentAmount, sharesBought, }: {
    buyer?: AddressLike;
    investmentAmount?: BigNumberish;
    sharesBought?: BigNumberish;
}): Promise<Uint8Array>;
export declare function sharesDueWithInflation({ rawSharesDue, sharesSupply, }: {
    rawSharesDue: BigNumber;
    sharesSupply: BigNumber;
}): 0 | BigNumber;
export declare const settleContinuousFeesFragment: utils.FunctionFragment;
export declare const settleContinuousFeesSelector: string;
