import { BigNumber, BigNumberish } from 'ethers';
import { feeHooks } from './common';
export declare function performanceFeeConfigArgs({ rate, period, }: {
    rate: BigNumberish;
    period: BigNumberish;
}): Promise<Uint8Array>;
export declare function performanceFeeSharesDue({ rate, totalSharesSupply, sharesOutstanding, gav, highWaterMark, prevSharePrice, prevAggregateValueDue, denominationAssetDecimals, feeHook, settlementInfo, }: {
    rate: BigNumberish;
    totalSharesSupply: BigNumberish;
    sharesOutstanding: BigNumberish;
    gav: BigNumberish;
    highWaterMark: BigNumberish;
    prevSharePrice: BigNumberish;
    prevAggregateValueDue: BigNumberish;
    denominationAssetDecimals?: BigNumberish;
    feeHook?: feeHooks;
    settlementInfo?: {
        buySharesInvestmentAmount?: BigNumberish;
        redeemSharesSharesAmount?: BigNumberish;
    };
}): {
    sharesDue: BigNumber;
    nextAggregateValueDue: BigNumber;
    nextSharePrice: BigNumber;
};
