import { BigNumberish, Signer, utils } from 'ethers';
import { ChaiAdapter, ComptrollerLib, IntegrationManager, VaultLib, StandardToken } from '@melonproject/protocol';
export declare function chaiLendArgs({ outgoingDaiAmount, expectedIncomingChaiAmount, }: {
    outgoingDaiAmount: BigNumberish;
    expectedIncomingChaiAmount: BigNumberish;
}): Promise<Uint8Array>;
export declare function chaiRedeemArgs({ outgoingChaiAmount, expectedIncomingDaiAmount, }: {
    outgoingChaiAmount: BigNumberish;
    expectedIncomingDaiAmount: BigNumberish;
}): Promise<Uint8Array>;
export declare function chaiLend({ comptrollerProxy, vaultProxy, integrationManager, fundOwner, chaiAdapter, dai, daiAmount, minChaiAmount, seedFund, }: {
    comptrollerProxy: ComptrollerLib;
    vaultProxy: VaultLib;
    integrationManager: IntegrationManager;
    fundOwner: Signer;
    chaiAdapter: ChaiAdapter;
    dai: StandardToken;
    daiAmount?: BigNumberish;
    minChaiAmount?: BigNumberish;
    seedFund?: boolean;
}): Promise<import("@crestproject/ethers").ContractReceipt<import("@crestproject/ethers").SendFunction<[_extension: import("@crestproject/ethers").AddressLike, _actionId: BigNumberish, _callArgs: string | utils.Bytes], void, ComptrollerLib>>>;
export declare function chaiRedeem({ comptrollerProxy, vaultProxy, integrationManager, fundOwner, chaiAdapter, chai, chaiAmount, minDaiAmount, seedFund, }: {
    comptrollerProxy: ComptrollerLib;
    vaultProxy: VaultLib;
    integrationManager: IntegrationManager;
    fundOwner: Signer;
    chaiAdapter: ChaiAdapter;
    chai: StandardToken;
    chaiAmount?: BigNumberish;
    minDaiAmount?: BigNumberish;
    seedFund?: boolean;
}): Promise<import("@crestproject/ethers").ContractReceipt<import("@crestproject/ethers").SendFunction<[_extension: import("@crestproject/ethers").AddressLike, _actionId: BigNumberish, _callArgs: string | utils.Bytes], void, ComptrollerLib>>>;
export declare function engineTakeOrderArgs(minNativeAssetAmount: BigNumberish, mlnTokenAmount: BigNumberish): Promise<Uint8Array>;
