import { BigNumber, BytesLike, utils } from 'ethers';
import { Call, Contract } from '@crestproject/crestproject';
export declare enum integrationManagerActionIds {
    CallOnIntegration = 0
}
export declare enum spendAssetsHandleTypes {
    None = 0,
    Approve = 1,
    Transfer = 2
}
export interface IntegrationAdapterInterface extends Contract {
    parseAssetsForMethod: Call<(_selector: BytesLike, _encodedCallArgs: BytesLike) => {
        spendAssets_: string[];
        spendAssetAmounts_: BigNumber[];
        incomingAssets_: string[];
        minIncomingAssetAmounts_: BigNumber[];
    }>;
}
export declare const callOnIntegrationFragment: utils.FunctionFragment;
export declare const addTrackedAssetsFragment: utils.FunctionFragment;
export declare const lendFragment: utils.FunctionFragment;
export declare const redeemFragment: utils.FunctionFragment;
export declare const takeOrderFragment: utils.FunctionFragment;
export declare const callOnIntegrationSelector: string;
export declare const addTrackedAssetsSelector: string;
export declare const takeOrderSelector: string;
export declare const redeemSelector: string;
export declare const lendSelector: string;
export declare function assetTransferArgs({ adapter, selector, encodedCallArgs, }: {
    adapter: IntegrationAdapterInterface;
    selector: BytesLike;
    encodedCallArgs: BytesLike;
}): Promise<Uint8Array>;
export declare function callOnIntegrationArgs({ adapter, selector, encodedCallArgs, }: {
    adapter: IntegrationAdapterInterface;
    selector: BytesLike;
    encodedCallArgs: BytesLike;
}): Promise<Uint8Array>;
