import { BigNumber, BigNumberish, Signer, utils } from 'ethers';
import { AddressLike, Call, Contract } from '@crestproject/crestproject';
import { StandardToken, ComptrollerLib, IntegrationManager, KyberAdapter, VaultLib } from '@melonproject/protocol';
export interface IKyberNetworkProxy extends Contract<IKyberNetworkProxy> {
    getExpectedRate: Call<(src: AddressLike, dest: AddressLike, srcQty: BigNumberish) => {
        expectedRate: BigNumber;
        worstRate: BigNumber;
    }, IKyberNetworkProxy>;
}
export declare const IKyberNetworkProxy: import("@crestproject/crestproject").ContractFactory<IKyberNetworkProxy, never>;
export declare function kyberTakeOrderArgs({ incomingAsset, minIncomingAssetAmount, outgoingAsset, outgoingAssetAmount, }: {
    incomingAsset: AddressLike;
    minIncomingAssetAmount: BigNumberish;
    outgoingAsset: AddressLike;
    outgoingAssetAmount: BigNumberish;
}): Promise<Uint8Array>;
export declare function kyberTakeOrder({ comptrollerProxy, vaultProxy, integrationManager, fundOwner, kyberAdapter, outgoingAsset, outgoingAssetAmount, incomingAsset, minIncomingAssetAmount, seedFund, }: {
    comptrollerProxy: ComptrollerLib;
    vaultProxy: VaultLib;
    integrationManager: IntegrationManager;
    fundOwner: Signer;
    kyberAdapter: KyberAdapter;
    outgoingAsset: StandardToken;
    outgoingAssetAmount?: BigNumberish;
    incomingAsset: StandardToken;
    minIncomingAssetAmount?: BigNumberish;
    seedFund?: boolean;
}): Promise<import("@crestproject/crestproject").ContractReceipt<import("@crestproject/crestproject").SendFunction<[_extension: AddressLike, _actionId: BigNumberish, _callArgs: string | utils.Bytes], void, ComptrollerLib>>>;
