import { BigNumberish, BytesLike, Signer, utils } from 'ethers';
import { AddressLike } from '@crestproject/crestproject';
import { ComptrollerLib, IntegrationManager, VaultLib, MockGenericAdapter, StandardToken } from '@melonproject/protocol';
export declare const mockGenericSwapASelector: string;
export declare const mockGenericSwapBSelector: string;
export declare const mockGenericSwapCSelector: string;
export declare function mockGenericSwapArgs({ spendAssets, spendAssetAmounts, incomingAssets, minIncomingAssetAmounts, incomingAssetAmounts, }: {
    spendAssets: AddressLike[];
    spendAssetAmounts: BigNumberish[];
    incomingAssets: AddressLike[];
    minIncomingAssetAmounts: BigNumberish[];
    incomingAssetAmounts: BigNumberish[];
}): Promise<Uint8Array>;
export declare function mockGenericSwap({ comptrollerProxy, vaultProxy, integrationManager, fundOwner, mockGenericAdapter, selector, spendAssets, spendAssetAmounts, incomingAssets, minIncomingAssetAmounts, actualIncomingAssetAmounts, seedFund, }: {
    comptrollerProxy: ComptrollerLib;
    vaultProxy: VaultLib;
    integrationManager: IntegrationManager;
    fundOwner: Signer;
    mockGenericAdapter: MockGenericAdapter;
    selector?: BytesLike;
    spendAssets?: StandardToken[];
    spendAssetAmounts?: BigNumberish[];
    incomingAssets?: StandardToken[];
    minIncomingAssetAmounts?: BigNumberish[];
    actualIncomingAssetAmounts?: BigNumberish[];
    seedFund?: boolean;
}): Promise<import("@crestproject/crestproject").ContractReceipt<import("@crestproject/crestproject").SendFunction<[_extension: AddressLike, _actionId: BigNumberish, _callArgs: string | utils.Bytes], void, ComptrollerLib>>>;
