import { BigNumberish, BytesLike, Signer } from 'ethers';
import { AddressLike } from '@crestproject/crestproject';
import { IPolicy, PolicyManager } from '@melonproject/protocol';
export declare enum policyHooks {
    PreBuyShares = 0,
    PostBuyShares = 1,
    PreCallOnIntegration = 2,
    PostCallOnIntegration = 3
}
export declare function generatePolicyManagerConfigWithMockPolicies({ deployer, policyManager, }: {
    deployer: Signer;
    policyManager: PolicyManager;
}): Promise<Uint8Array>;
export declare function generateRegisteredMockPolicies({ deployer, policyManager, }: {
    deployer: Signer;
    policyManager: PolicyManager;
}): Promise<{
    mockPreBuySharesPolicy: import("@crestproject/crestproject").MockContract<IPolicy>;
    mockPostBuySharesPolicy: import("@crestproject/crestproject").MockContract<IPolicy>;
    mockPreCoIPolicy: import("@crestproject/crestproject").MockContract<IPolicy>;
    mockPostCoIPolicy: import("@crestproject/crestproject").MockContract<IPolicy>;
}>;
export declare function policyManagerConfigArgs(policies: AddressLike[], settingsData: BytesLike[]): Promise<Uint8Array>;
export declare function validateRulePreBuySharesArgs({ buyer, investmentAmount, minSharesQuantity, gav, }: {
    buyer?: AddressLike;
    investmentAmount?: BigNumberish;
    minSharesQuantity?: BigNumberish;
    gav?: BigNumberish;
}): Promise<Uint8Array>;
export declare function validateRulePostBuySharesArgs(buyer: AddressLike, investmentAmount: BigNumberish, sharesBought: BigNumberish): Promise<Uint8Array>;
export declare function validateRulePreCoIArgs(adapter: AddressLike, selector: BytesLike): Promise<Uint8Array>;
export declare function validateRulePostCoIArgs(adapter: AddressLike, selector: BytesLike, incomingAssets: AddressLike[], incomingAssetAmounts: BigNumberish[], outgoingAssets: AddressLike[], outgoingAssetAmounts: BigNumberish[]): Promise<Uint8Array>;
export declare function adapterBlacklistArgs(adapters: AddressLike[]): Promise<Uint8Array>;
export declare function adapterWhitelistArgs(adapters: AddressLike[]): Promise<Uint8Array>;
export declare function assetBlacklistArgs(assets: AddressLike[]): Promise<Uint8Array>;
export declare function assetWhitelistArgs(assets: AddressLike[]): Promise<Uint8Array>;
export declare function buySharesPriceFeedToleranceArgs(tolerance: BigNumberish): Promise<Uint8Array>;
export declare function investorWhitelistArgs({ investorsToAdd, investorsToRemove, }: {
    investorsToAdd?: AddressLike[];
    investorsToRemove?: AddressLike[];
}): Promise<Uint8Array>;
export declare function maxConcentrationArgs(maxConcentration: BigNumberish): Promise<Uint8Array>;
