import { BigNumberish, Signer } from 'ethers';
import { AddressLike, Contract, Send } from '@crestproject/crestproject';
import { ComptrollerLib } from '@melonproject/protocol';
export interface DenominationAssetInterface extends Contract<any> {
    approve: Send<(spender: AddressLike, amount: BigNumberish) => boolean, any>;
}
export interface BuySharesParams {
    comptrollerProxy: ComptrollerLib;
    signer: Signer;
    buyer: AddressLike;
    denominationAsset: DenominationAssetInterface;
    amguValue?: BigNumberish;
    investmentAmount?: BigNumberish;
    minSharesAmount?: BigNumberish;
}
export interface RedeemSharesParams {
    comptrollerProxy: ComptrollerLib;
    signer: Signer;
    quantity?: BigNumberish;
    additionalAssets?: AddressLike[];
    assetsToSkip?: AddressLike[];
}
export declare function buyShares({ comptrollerProxy, signer, buyer, denominationAsset, amguValue, // TODO: get real estimated amgu cost?
investmentAmount, minSharesAmount, }: BuySharesParams): Promise<import("@crestproject/crestproject").ContractReceipt<import("@crestproject/crestproject").SendFunction<[_buyer: AddressLike, _investmentAmount: BigNumberish, _minSharesQuantity: BigNumberish], import("ethers").BigNumber, ComptrollerLib>>>;
export declare function redeemShares({ comptrollerProxy, signer, quantity, additionalAssets, assetsToSkip, }: RedeemSharesParams): Promise<import("@crestproject/crestproject").ContractReceipt<import("@crestproject/crestproject").SendFunction<[], void, ComptrollerLib>> | import("@crestproject/crestproject").ContractReceipt<import("@crestproject/crestproject").SendFunction<[_sharesQuantity: BigNumberish, _additionalAssets: AddressLike[], _assetsToSkip: AddressLike[]], void, ComptrollerLib>>>;
