declare type Resolved<T> = T extends Promise<infer R> ? R : T;
export declare type DeploymentHandler<TDeployment = any, TConfig = any, TOutput = any> = (config: TConfig, deployment: TDeployment) => TOutput;
export declare type DeploymentHandlers<TConfig, TDeployment> = {
    [TKey in keyof TDeployment]: DeploymentHandler<TDeployment, TConfig, TDeployment[TKey]>;
} & {
    [key: string]: DeploymentHandler<TDeployment, TConfig>;
};
export declare type Deployment<THandlers extends DeploymentHandlers<any, any>> = {
    [TKey in keyof THandlers]: Resolved<ReturnType<THandlers[TKey]>>;
};
export declare type DeploymentProxy<THandlers extends DeploymentHandlers<any, any>> = {
    [TKey in keyof THandlers]: ReturnType<THandlers[TKey]>;
};
export declare function createDeploymentProxy<THandlers extends DeploymentHandlers<any, any>, TConfig>(constructors: THandlers, config: TConfig): DeploymentProxy<THandlers>;
export declare function resolveDeploymentProxy<THandlers extends DeploymentHandlers<any, any>>(proxy: DeploymentProxy<THandlers>): Promise<Deployment<THandlers>>;
export declare function describeDeployment<TConfig, TOutput>(handlers: DeploymentHandlers<TConfig, TOutput>): (config: TConfig) => Promise<Deployment<DeploymentHandlers<TConfig, TOutput>>>;
export {};
