"use strict";

Object.defineProperty(exports, "__esModule", {
  value: !0
});

var protocol = require("@melonproject/protocol"), crestproject = require("@crestproject/crestproject"), ethers = require("ethers"), ethersEip712 = require("ethers-eip712");

function _defineProperty(obj, key, value) {
  return key in obj ? Object.defineProperty(obj, key, {
    value: value,
    enumerable: !0,
    configurable: !0,
    writable: !0
  }) : obj[key] = value, obj;
}

function ownKeys(object, enumerableOnly) {
  var keys = Object.keys(object);
  if (Object.getOwnPropertySymbols) {
    var symbols = Object.getOwnPropertySymbols(object);
    enumerableOnly && (symbols = symbols.filter((function(sym) {
      return Object.getOwnPropertyDescriptor(object, sym).enumerable;
    }))), keys.push.apply(keys, symbols);
  }
  return keys;
}

function _objectSpread2(target) {
  for (var i = 1; i < arguments.length; i++) {
    var source = null != arguments[i] ? arguments[i] : {};
    i % 2 ? ownKeys(Object(source), !0).forEach((function(key) {
      _defineProperty(target, key, source[key]);
    })) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach((function(key) {
      Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key));
    }));
  }
  return target;
}

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) {
  try {
    var info = gen[key](arg), value = info.value;
  } catch (error) {
    return void reject(error);
  }
  info.done ? resolve(value) : Promise.resolve(value).then(_next, _throw);
}

function _asyncToGenerator(fn) {
  return function() {
    var self = this, args = arguments;
    return new Promise((function(resolve, reject) {
      var gen = fn.apply(self, args);
      function _next(value) {
        asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value);
      }
      function _throw(err) {
        asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err);
      }
      _next(void 0);
    }));
  };
}

function createRecursionAwareProxy(constructors, config, state) {
  var prefix = arguments.length > 3 && void 0 !== arguments[3] ? arguments[3] : [];
  return new Proxy(state, {
    ownKeys: function() {
      return Object.keys(constructors);
    },
    get: function(target, prop, receiver) {
      if (!constructors.hasOwnProperty(prop)) return Reflect.get(target, prop, receiver);
      if (prefix.includes(prop)) {
        var joined = prefix.concat(prop).join(" => ");
        throw new Error("Recursive deployment dependency detected: ".concat(joined));
      }
      if (constructors.hasOwnProperty(prop) && !Reflect.has(target, prop)) {
        var path = prefix.concat(prop), proxy = createRecursionAwareProxy(constructors, config, state, path), promise = constructors[prop](config, proxy);
        Reflect.set(target, prop, promise, receiver);
      }
      return Reflect.get(target, prop, receiver);
    }
  });
}

function createDeploymentProxy(constructors, config) {
  return createRecursionAwareProxy(constructors, config, {});
}

function resolveDeploymentProxy(_x) {
  return _resolveDeploymentProxy.apply(this, arguments);
}

function _resolveDeploymentProxy() {
  return (_resolveDeploymentProxy = _asyncToGenerator(regeneratorRuntime.mark((function _callee2(proxy) {
    var keys;
    return regeneratorRuntime.wrap((function(_context2) {
      for (;;) switch (_context2.prev = _context2.next) {
       case 0:
        return keys = Object.getOwnPropertyNames(proxy), _context2.abrupt("return", keys.reduce(function() {
          var _ref = _asyncToGenerator(regeneratorRuntime.mark((function _callee(carry, current) {
            return regeneratorRuntime.wrap((function(_context) {
              for (;;) switch (_context.prev = _context.next) {
               case 0:
                return _context.t0 = _objectSpread2, _context.t1 = _objectSpread2, _context.t2 = {}, 
                _context.next = 5, carry;

               case 5:
                return _context.t3 = _context.sent, _context.t4 = (0, _context.t1)(_context.t2, _context.t3), 
                _context.t5 = {}, _context.t6 = _defineProperty, _context.t7 = {}, _context.t8 = current, 
                _context.next = 13, proxy[current];

               case 13:
                return _context.t9 = _context.sent, _context.t10 = (0, _context.t6)(_context.t7, _context.t8, _context.t9), 
                _context.abrupt("return", (0, _context.t0)(_context.t4, _context.t5, _context.t10));

               case 16:
               case "end":
                return _context.stop();
              }
            }), _callee);
          })));
          return function(_x2, _x3) {
            return _ref.apply(this, arguments);
          };
        }(), Promise.resolve({})));

       case 2:
       case "end":
        return _context2.stop();
      }
    }), _callee2);
  })))).apply(this, arguments);
}

function describeDeployment(handlers) {
  return function(config) {
    return resolveDeploymentProxy(createDeploymentProxy(handlers, config));
  };
}

function assertEvent(_x, _x2, _x3) {
  return _assertEvent.apply(this, arguments);
}

function _assertEvent() {
  return (_assertEvent = _asyncToGenerator(regeneratorRuntime.mark((function _callee(tx, event, match) {
    var _events$shift, receipt, events, args;
    return regeneratorRuntime.wrap((function(_context) {
      for (;;) switch (_context.prev = _context.next) {
       case 0:
        return _context.next = 2, tx;

       case 2:
        return receipt = _context.sent, events = crestproject.extractEvent(receipt, event), 
        expect(events.length).toBe(1), args = null === (_events$shift = events.shift()) || void 0 === _events$shift ? void 0 : _events$shift.args, 
        null != match && expect(args).toMatchObject(match), _context.abrupt("return", args);

       case 8:
       case "end":
        return _context.stop();
      }
    }), _callee);
  })))).apply(this, arguments);
}

function assertNoEvent(_x4, _x5) {
  return _assertNoEvent.apply(this, arguments);
}

function _assertNoEvent() {
  return (_assertNoEvent = _asyncToGenerator(regeneratorRuntime.mark((function _callee2(tx, event) {
    var receipt, events;
    return regeneratorRuntime.wrap((function(_context2) {
      for (;;) switch (_context2.prev = _context2.next) {
       case 0:
        return _context2.next = 2, tx;

       case 2:
        receipt = _context2.sent, events = crestproject.extractEvent(receipt, event), expect(events.length).toBe(0);

       case 5:
       case "end":
        return _context2.stop();
      }
    }), _callee2);
  })))).apply(this, arguments);
}

var deployPersistent = describeDeployment({
  dispatcher: function(config) {
    return protocol.Dispatcher.deploy(config.deployer);
  }
});

function _arrayWithHoles(arr) {
  if (Array.isArray(arr)) return arr;
}

function _iterableToArray(iter) {
  if ("undefined" != typeof Symbol && Symbol.iterator in Object(iter)) return Array.from(iter);
}

function _arrayLikeToArray(arr, len) {
  (null == len || len > arr.length) && (len = arr.length);
  for (var i = 0, arr2 = new Array(len); i < len; i++) arr2[i] = arr[i];
  return arr2;
}

function _unsupportedIterableToArray(o, minLen) {
  if (o) {
    if ("string" == typeof o) return _arrayLikeToArray(o, minLen);
    var n = Object.prototype.toString.call(o).slice(8, -1);
    return "Object" === n && o.constructor && (n = o.constructor.name), "Map" === n || "Set" === n ? Array.from(o) : "Arguments" === n || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n) ? _arrayLikeToArray(o, minLen) : void 0;
  }
}

function _nonIterableRest() {
  throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.");
}

function _toArray(arr) {
  return _arrayWithHoles(arr) || _iterableToArray(arr) || _unsupportedIterableToArray(arr) || _nonIterableRest();
}

function defaultPersistetTestDeployment(_x) {
  return _defaultPersistetTestDeployment.apply(this, arguments);
}

function _defaultPersistetTestDeployment() {
  return (_defaultPersistetTestDeployment = _asyncToGenerator(regeneratorRuntime.mark((function _callee(provider) {
    var _yield$provider$listA, _yield$provider$listA2, deployer, others, accounts, config, deployment;
    return regeneratorRuntime.wrap((function(_context) {
      for (;;) switch (_context.prev = _context.next) {
       case 0:
        return _context.next = 2, provider.listAccounts();

       case 2:
        return _yield$provider$listA = _context.sent, _yield$provider$listA2 = _toArray(_yield$provider$listA), 
        deployer = _yield$provider$listA2[0], others = _yield$provider$listA2.slice(1), 
        accounts = others.slice(0, 10).map((function(address) {
          return provider.getSigner(address);
        })), config = {
          deployer: provider.getSigner(deployer)
        }, _context.next = 10, deployPersistent(config);

       case 10:
        return deployment = _context.sent, _context.abrupt("return", {
          accounts: accounts,
          config: config,
          deployment: deployment
        });

       case 12:
       case "end":
        return _context.stop();
      }
    }), _callee);
  })))).apply(this, arguments);
}

var deployRelease = describeDeployment({
  comptrollerLib: function(config, deployment) {
    return _asyncToGenerator(regeneratorRuntime.mark((function _callee() {
      var comptrollerLib, fundDeployer;
      return regeneratorRuntime.wrap((function(_context) {
        for (;;) switch (_context.prev = _context.next) {
         case 0:
          return _context.t0 = protocol.ComptrollerLib, _context.t1 = config.deployer, _context.next = 4, 
          deployment.fundDeployer;

         case 4:
          return _context.t2 = _context.sent, _context.next = 7, deployment.valueInterpreter;

         case 7:
          return _context.t3 = _context.sent, _context.next = 10, deployment.feeManager;

         case 10:
          return _context.t4 = _context.sent, _context.next = 13, deployment.integrationManager;

         case 13:
          return _context.t5 = _context.sent, _context.next = 16, deployment.policyManager;

         case 16:
          return _context.t6 = _context.sent, _context.next = 19, deployment.fundLifecycleLib;

         case 19:
          return _context.t7 = _context.sent, _context.next = 22, deployment.permissionedVaultActionLib;

         case 22:
          return _context.t8 = _context.sent, _context.next = 25, deployment.engine;

         case 25:
          return _context.t9 = _context.sent, _context.next = 28, _context.t0.deploy.call(_context.t0, _context.t1, _context.t2, _context.t3, _context.t4, _context.t5, _context.t6, _context.t7, _context.t8, _context.t9);

         case 28:
          return comptrollerLib = _context.sent, _context.next = 31, deployment.fundDeployer;

         case 31:
          return fundDeployer = _context.sent, _context.next = 34, fundDeployer.setComptrollerLib(comptrollerLib);

         case 34:
          return _context.abrupt("return", comptrollerLib);

         case 35:
         case "end":
          return _context.stop();
        }
      }), _callee);
    })))();
  },
  fundDeployer: function(config, deployment) {
    return _asyncToGenerator(regeneratorRuntime.mark((function _callee2() {
      return regeneratorRuntime.wrap((function(_context2) {
        for (;;) switch (_context2.prev = _context2.next) {
         case 0:
          return _context2.t0 = protocol.FundDeployer, _context2.t1 = config.deployer, _context2.t2 = config.dispatcher, 
          _context2.next = 5, deployment.engine;

         case 5:
          return _context2.t3 = _context2.sent, _context2.next = 8, deployment.vaultLib;

         case 8:
          return _context2.t4 = _context2.sent, _context2.t5 = config.registeredVaultCalls.contracts, 
          _context2.t6 = config.registeredVaultCalls.selectors, _context2.abrupt("return", _context2.t0.deploy.call(_context2.t0, _context2.t1, _context2.t2, _context2.t3, _context2.t4, _context2.t5, _context2.t6));

         case 12:
         case "end":
          return _context2.stop();
        }
      }), _callee2);
    })))();
  },
  fundLifecycleLib: function(config, deployment) {
    return _asyncToGenerator(regeneratorRuntime.mark((function _callee3() {
      return regeneratorRuntime.wrap((function(_context3) {
        for (;;) switch (_context3.prev = _context3.next) {
         case 0:
          return _context3.t0 = protocol.FundLifecycleLib, _context3.t1 = config.deployer, 
          _context3.next = 4, deployment.fundDeployer;

         case 4:
          return _context3.t2 = _context3.sent, _context3.next = 7, deployment.chainlinkPriceFeed;

         case 7:
          return _context3.t3 = _context3.sent, _context3.next = 10, deployment.feeManager;

         case 10:
          return _context3.t4 = _context3.sent, _context3.next = 13, deployment.integrationManager;

         case 13:
          return _context3.t5 = _context3.sent, _context3.next = 16, deployment.policyManager;

         case 16:
          return _context3.t6 = _context3.sent, _context3.abrupt("return", _context3.t0.deploy.call(_context3.t0, _context3.t1, _context3.t2, _context3.t3, _context3.t4, _context3.t5, _context3.t6));

         case 18:
         case "end":
          return _context3.stop();
        }
      }), _callee3);
    })))();
  },
  permissionedVaultActionLib: function(config, deployment) {
    return _asyncToGenerator(regeneratorRuntime.mark((function _callee4() {
      return regeneratorRuntime.wrap((function(_context4) {
        for (;;) switch (_context4.prev = _context4.next) {
         case 0:
          return _context4.t0 = protocol.PermissionedVaultActionLib, _context4.t1 = config.deployer, 
          _context4.next = 4, deployment.feeManager;

         case 4:
          return _context4.t2 = _context4.sent, _context4.next = 7, deployment.integrationManager;

         case 7:
          return _context4.t3 = _context4.sent, _context4.abrupt("return", _context4.t0.deploy.call(_context4.t0, _context4.t1, _context4.t2, _context4.t3));

         case 9:
         case "end":
          return _context4.stop();
        }
      }), _callee4);
    })))();
  },
  vaultLib: function(config) {
    return _asyncToGenerator(regeneratorRuntime.mark((function _callee5() {
      return regeneratorRuntime.wrap((function(_context5) {
        for (;;) switch (_context5.prev = _context5.next) {
         case 0:
          return _context5.abrupt("return", protocol.VaultLib.deploy(config.deployer));

         case 1:
         case "end":
          return _context5.stop();
        }
      }), _callee5);
    })))();
  },
  engine: function(config, deployment) {
    return _asyncToGenerator(regeneratorRuntime.mark((function _callee6() {
      return regeneratorRuntime.wrap((function(_context6) {
        for (;;) switch (_context6.prev = _context6.next) {
         case 0:
          return _context6.t0 = protocol.Engine, _context6.t1 = config.deployer, _context6.t2 = config.dispatcher, 
          _context6.t3 = config.mgm, _context6.t4 = config.mln, _context6.t5 = config.weth, 
          _context6.next = 8, deployment.valueInterpreter;

         case 8:
          return _context6.t6 = _context6.sent, _context6.t7 = config.engine.thawDelay, _context6.abrupt("return", _context6.t0.deploy.call(_context6.t0, _context6.t1, _context6.t2, _context6.t3, _context6.t4, _context6.t5, _context6.t6, _context6.t7));

         case 11:
         case "end":
          return _context6.stop();
        }
      }), _callee6);
    })))();
  },
  valueInterpreter: function(config, deployment) {
    return _asyncToGenerator(regeneratorRuntime.mark((function _callee7() {
      return regeneratorRuntime.wrap((function(_context7) {
        for (;;) switch (_context7.prev = _context7.next) {
         case 0:
          return _context7.t0 = protocol.ValueInterpreter, _context7.t1 = config.deployer, 
          _context7.next = 4, deployment.chainlinkPriceFeed;

         case 4:
          return _context7.t2 = _context7.sent, _context7.next = 7, deployment.aggregatedDerivativePriceFeed;

         case 7:
          return _context7.t3 = _context7.sent, _context7.abrupt("return", _context7.t0.deploy.call(_context7.t0, _context7.t1, _context7.t2, _context7.t3));

         case 9:
         case "end":
          return _context7.stop();
        }
      }), _callee7);
    })))();
  },
  feeManager: function(config, deployment) {
    return _asyncToGenerator(regeneratorRuntime.mark((function _callee8() {
      return regeneratorRuntime.wrap((function(_context8) {
        for (;;) switch (_context8.prev = _context8.next) {
         case 0:
          return _context8.t0 = protocol.FeeManager, _context8.t1 = config.deployer, _context8.next = 4, 
          deployment.fundDeployer;

         case 4:
          return _context8.t2 = _context8.sent, _context8.next = 7, _context8.t0.deploy.call(_context8.t0, _context8.t1, _context8.t2);

         case 7:
          return _context8.abrupt("return", _context8.sent);

         case 8:
         case "end":
          return _context8.stop();
        }
      }), _callee8);
    })))();
  },
  integrationManager: function(config, deployment) {
    return _asyncToGenerator(regeneratorRuntime.mark((function _callee9() {
      return regeneratorRuntime.wrap((function(_context9) {
        for (;;) switch (_context9.prev = _context9.next) {
         case 0:
          return _context9.t0 = protocol.IntegrationManager, _context9.t1 = config.deployer, 
          _context9.next = 4, deployment.fundDeployer;

         case 4:
          return _context9.t2 = _context9.sent, _context9.next = 7, deployment.policyManager;

         case 7:
          return _context9.t3 = _context9.sent, _context9.next = 10, deployment.valueInterpreter;

         case 10:
          return _context9.t4 = _context9.sent, _context9.t5 = config.integrationManager.trackedAssetsLimit, 
          _context9.abrupt("return", _context9.t0.deploy.call(_context9.t0, _context9.t1, _context9.t2, _context9.t3, _context9.t4, _context9.t5));

         case 13:
         case "end":
          return _context9.stop();
        }
      }), _callee9);
    })))();
  },
  policyManager: function(config, deployment) {
    return _asyncToGenerator(regeneratorRuntime.mark((function _callee10() {
      return regeneratorRuntime.wrap((function(_context10) {
        for (;;) switch (_context10.prev = _context10.next) {
         case 0:
          return _context10.t0 = protocol.PolicyManager, _context10.t1 = config.deployer, 
          _context10.next = 4, deployment.fundDeployer;

         case 4:
          return _context10.t2 = _context10.sent, _context10.abrupt("return", _context10.t0.deploy.call(_context10.t0, _context10.t1, _context10.t2));

         case 6:
         case "end":
          return _context10.stop();
        }
      }), _callee10);
    })))();
  },
  chainlinkPriceFeed: function(config) {
    return _asyncToGenerator(regeneratorRuntime.mark((function _callee11() {
      return regeneratorRuntime.wrap((function(_context11) {
        for (;;) switch (_context11.prev = _context11.next) {
         case 0:
          return _context11.abrupt("return", protocol.ChainlinkPriceFeed.deploy(config.deployer, config.dispatcher, config.weth, config.chainlink.ethUsdAggregator, config.chainlink.staleRateThreshold, config.chainlink.primitives, config.chainlink.aggregators, config.chainlink.rateAssets));

         case 1:
         case "end":
          return _context11.stop();
        }
      }), _callee11);
    })))();
  },
  aggregatedDerivativePriceFeed: function(config, deployment) {
    return _asyncToGenerator(regeneratorRuntime.mark((function _callee12() {
      return regeneratorRuntime.wrap((function(_context12) {
        for (;;) switch (_context12.prev = _context12.next) {
         case 0:
          return _context12.t0 = protocol.AggregatedDerivativePriceFeed, _context12.t1 = config.deployer, 
          _context12.t2 = config.dispatcher, _context12.t3 = [ config.integratees.chai ], 
          _context12.next = 6, deployment.chaiPriceFeed;

         case 6:
          return _context12.t4 = _context12.sent, _context12.t5 = [ _context12.t4 ], _context12.abrupt("return", _context12.t0.deploy.call(_context12.t0, _context12.t1, _context12.t2, _context12.t3, _context12.t5));

         case 9:
         case "end":
          return _context12.stop();
        }
      }), _callee12);
    })))();
  },
  chaiPriceFeed: function(config) {
    return _asyncToGenerator(regeneratorRuntime.mark((function _callee13() {
      return regeneratorRuntime.wrap((function(_context13) {
        for (;;) switch (_context13.prev = _context13.next) {
         case 0:
          return _context13.abrupt("return", protocol.ChaiPriceFeed.deploy(config.deployer, config.integratees.chai, config.integratees.makerDao.dai, config.integratees.makerDao.pot));

         case 1:
         case "end":
          return _context13.stop();
        }
      }), _callee13);
    })))();
  },
  chaiAdapter: function(config, deployment) {
    return _asyncToGenerator(regeneratorRuntime.mark((function _callee14() {
      return regeneratorRuntime.wrap((function(_context14) {
        for (;;) switch (_context14.prev = _context14.next) {
         case 0:
          return _context14.t0 = protocol.ChaiAdapter, _context14.t1 = config.deployer, _context14.next = 4, 
          deployment.integrationManager;

         case 4:
          return _context14.t2 = _context14.sent, _context14.t3 = config.integratees.chai, 
          _context14.t4 = config.integratees.makerDao.dai, _context14.abrupt("return", _context14.t0.deploy.call(_context14.t0, _context14.t1, _context14.t2, _context14.t3, _context14.t4));

         case 8:
         case "end":
          return _context14.stop();
        }
      }), _callee14);
    })))();
  },
  engineAdapter: function(config, deployment) {
    return _asyncToGenerator(regeneratorRuntime.mark((function _callee15() {
      return regeneratorRuntime.wrap((function(_context15) {
        for (;;) switch (_context15.prev = _context15.next) {
         case 0:
          return _context15.t0 = protocol.EngineAdapter, _context15.t1 = config.deployer, 
          _context15.next = 4, deployment.integrationManager;

         case 4:
          return _context15.t2 = _context15.sent, _context15.next = 7, deployment.engine;

         case 7:
          return _context15.t3 = _context15.sent, _context15.t4 = config.mln, _context15.t5 = config.weth, 
          _context15.abrupt("return", _context15.t0.deploy.call(_context15.t0, _context15.t1, _context15.t2, _context15.t3, _context15.t4, _context15.t5));

         case 11:
         case "end":
          return _context15.stop();
        }
      }), _callee15);
    })))();
  },
  kyberAdapter: function(config, deployment) {
    return _asyncToGenerator(regeneratorRuntime.mark((function _callee16() {
      return regeneratorRuntime.wrap((function(_context16) {
        for (;;) switch (_context16.prev = _context16.next) {
         case 0:
          return _context16.t0 = protocol.KyberAdapter, _context16.t1 = config.deployer, _context16.next = 4, 
          deployment.integrationManager;

         case 4:
          return _context16.t2 = _context16.sent, _context16.t3 = config.integratees.kyber, 
          _context16.t4 = config.weth, _context16.abrupt("return", _context16.t0.deploy.call(_context16.t0, _context16.t1, _context16.t2, _context16.t3, _context16.t4));

         case 8:
         case "end":
          return _context16.stop();
        }
      }), _callee16);
    })))();
  },
  trackedAssetsAdapter: function(config, deployment) {
    return _asyncToGenerator(regeneratorRuntime.mark((function _callee17() {
      return regeneratorRuntime.wrap((function(_context17) {
        for (;;) switch (_context17.prev = _context17.next) {
         case 0:
          return _context17.t0 = protocol.TrackedAssetsAdapter, _context17.t1 = config.deployer, 
          _context17.next = 4, deployment.integrationManager;

         case 4:
          return _context17.t2 = _context17.sent, _context17.abrupt("return", _context17.t0.deploy.call(_context17.t0, _context17.t1, _context17.t2));

         case 6:
         case "end":
          return _context17.stop();
        }
      }), _callee17);
    })))();
  },
  zeroExV2Adapter: function(config, deployment) {
    return _asyncToGenerator(regeneratorRuntime.mark((function _callee18() {
      return regeneratorRuntime.wrap((function(_context18) {
        for (;;) switch (_context18.prev = _context18.next) {
         case 0:
          return _context18.t0 = protocol.ZeroExV2Adapter, _context18.t1 = config.deployer, 
          _context18.next = 4, deployment.integrationManager;

         case 4:
          return _context18.t2 = _context18.sent, _context18.t3 = config.integratees.zeroExV2.exchange, 
          _context18.next = 8, deployment.fundDeployer;

         case 8:
          return _context18.t4 = _context18.sent, _context18.abrupt("return", _context18.t0.deploy.call(_context18.t0, _context18.t1, _context18.t2, _context18.t3, _context18.t4));

         case 10:
         case "end":
          return _context18.stop();
        }
      }), _callee18);
    })))();
  },
  entranceRateFee: function(config, deployment) {
    return _asyncToGenerator(regeneratorRuntime.mark((function _callee19() {
      return regeneratorRuntime.wrap((function(_context19) {
        for (;;) switch (_context19.prev = _context19.next) {
         case 0:
          return _context19.t0 = protocol.EntranceRateFee, _context19.t1 = config.deployer, 
          _context19.next = 4, deployment.feeManager;

         case 4:
          return _context19.t2 = _context19.sent, _context19.abrupt("return", _context19.t0.deploy.call(_context19.t0, _context19.t1, _context19.t2));

         case 6:
         case "end":
          return _context19.stop();
        }
      }), _callee19);
    })))();
  },
  managementFee: function(config, deployment) {
    return _asyncToGenerator(regeneratorRuntime.mark((function _callee20() {
      return regeneratorRuntime.wrap((function(_context20) {
        for (;;) switch (_context20.prev = _context20.next) {
         case 0:
          return _context20.t0 = protocol.ManagementFee, _context20.t1 = config.deployer, 
          _context20.next = 4, deployment.feeManager;

         case 4:
          return _context20.t2 = _context20.sent, _context20.abrupt("return", _context20.t0.deploy.call(_context20.t0, _context20.t1, _context20.t2));

         case 6:
         case "end":
          return _context20.stop();
        }
      }), _callee20);
    })))();
  },
  performanceFee: function(config, deployment) {
    return _asyncToGenerator(regeneratorRuntime.mark((function _callee21() {
      return regeneratorRuntime.wrap((function(_context21) {
        for (;;) switch (_context21.prev = _context21.next) {
         case 0:
          return _context21.t0 = protocol.PerformanceFee, _context21.t1 = config.deployer, 
          _context21.next = 4, deployment.feeManager;

         case 4:
          return _context21.t2 = _context21.sent, _context21.abrupt("return", _context21.t0.deploy.call(_context21.t0, _context21.t1, _context21.t2));

         case 6:
         case "end":
          return _context21.stop();
        }
      }), _callee21);
    })))();
  },
  adapterBlacklist: function(config, deployment) {
    return _asyncToGenerator(regeneratorRuntime.mark((function _callee22() {
      return regeneratorRuntime.wrap((function(_context22) {
        for (;;) switch (_context22.prev = _context22.next) {
         case 0:
          return _context22.t0 = protocol.AdapterBlacklist, _context22.t1 = config.deployer, 
          _context22.next = 4, deployment.policyManager;

         case 4:
          return _context22.t2 = _context22.sent, _context22.abrupt("return", _context22.t0.deploy.call(_context22.t0, _context22.t1, _context22.t2));

         case 6:
         case "end":
          return _context22.stop();
        }
      }), _callee22);
    })))();
  },
  adapterWhitelist: function(config, deployment) {
    return _asyncToGenerator(regeneratorRuntime.mark((function _callee23() {
      return regeneratorRuntime.wrap((function(_context23) {
        for (;;) switch (_context23.prev = _context23.next) {
         case 0:
          return _context23.t0 = protocol.AdapterWhitelist, _context23.t1 = config.deployer, 
          _context23.next = 4, deployment.policyManager;

         case 4:
          return _context23.t2 = _context23.sent, _context23.abrupt("return", _context23.t0.deploy.call(_context23.t0, _context23.t1, _context23.t2));

         case 6:
         case "end":
          return _context23.stop();
        }
      }), _callee23);
    })))();
  },
  assetBlacklist: function(config, deployment) {
    return _asyncToGenerator(regeneratorRuntime.mark((function _callee24() {
      return regeneratorRuntime.wrap((function(_context24) {
        for (;;) switch (_context24.prev = _context24.next) {
         case 0:
          return _context24.t0 = protocol.AssetBlacklist, _context24.t1 = config.deployer, 
          _context24.next = 4, deployment.policyManager;

         case 4:
          return _context24.t2 = _context24.sent, _context24.abrupt("return", _context24.t0.deploy.call(_context24.t0, _context24.t1, _context24.t2));

         case 6:
         case "end":
          return _context24.stop();
        }
      }), _callee24);
    })))();
  },
  assetWhitelist: function(config, deployment) {
    return _asyncToGenerator(regeneratorRuntime.mark((function _callee25() {
      return regeneratorRuntime.wrap((function(_context25) {
        for (;;) switch (_context25.prev = _context25.next) {
         case 0:
          return _context25.t0 = protocol.AssetWhitelist, _context25.t1 = config.deployer, 
          _context25.next = 4, deployment.policyManager;

         case 4:
          return _context25.t2 = _context25.sent, _context25.abrupt("return", _context25.t0.deploy.call(_context25.t0, _context25.t1, _context25.t2));

         case 6:
         case "end":
          return _context25.stop();
        }
      }), _callee25);
    })))();
  },
  buySharesPriceFeedTolerance: function(config, deployment) {
    return _asyncToGenerator(regeneratorRuntime.mark((function _callee26() {
      return regeneratorRuntime.wrap((function(_context26) {
        for (;;) switch (_context26.prev = _context26.next) {
         case 0:
          return _context26.t0 = protocol.BuySharesPriceFeedTolerance, _context26.t1 = config.deployer, 
          _context26.next = 4, deployment.policyManager;

         case 4:
          return _context26.t2 = _context26.sent, _context26.t3 = config.integratees.uniswapV2.factory, 
          _context26.next = 8, deployment.valueInterpreter;

         case 8:
          return _context26.t4 = _context26.sent, _context26.t5 = config.weth, _context26.abrupt("return", _context26.t0.deploy.call(_context26.t0, _context26.t1, _context26.t2, _context26.t3, _context26.t4, _context26.t5));

         case 11:
         case "end":
          return _context26.stop();
        }
      }), _callee26);
    })))();
  },
  maxConcentration: function(config, deployment) {
    return _asyncToGenerator(regeneratorRuntime.mark((function _callee27() {
      return regeneratorRuntime.wrap((function(_context27) {
        for (;;) switch (_context27.prev = _context27.next) {
         case 0:
          return _context27.t0 = protocol.MaxConcentration, _context27.t1 = config.deployer, 
          _context27.next = 4, deployment.policyManager;

         case 4:
          return _context27.t2 = _context27.sent, _context27.next = 7, deployment.valueInterpreter;

         case 7:
          return _context27.t3 = _context27.sent, _context27.abrupt("return", _context27.t0.deploy.call(_context27.t0, _context27.t1, _context27.t2, _context27.t3));

         case 9:
         case "end":
          return _context27.stop();
        }
      }), _callee27);
    })))();
  },
  investorWhitelist: function(config, deployment) {
    return _asyncToGenerator(regeneratorRuntime.mark((function _callee28() {
      return regeneratorRuntime.wrap((function(_context28) {
        for (;;) switch (_context28.prev = _context28.next) {
         case 0:
          return _context28.t0 = protocol.InvestorWhitelist, _context28.t1 = config.deployer, 
          _context28.next = 4, deployment.policyManager;

         case 4:
          return _context28.t2 = _context28.sent, _context28.abrupt("return", _context28.t0.deploy.call(_context28.t0, _context28.t1, _context28.t2));

         case 6:
         case "end":
          return _context28.stop();
        }
      }), _callee28);
    })))();
  },
  fundCalculator: function(config, deployment) {
    return _asyncToGenerator(regeneratorRuntime.mark((function _callee29() {
      return regeneratorRuntime.wrap((function(_context29) {
        for (;;) switch (_context29.prev = _context29.next) {
         case 0:
          return _context29.t0 = protocol.FundCalculator, _context29.t1 = config.deployer, 
          _context29.next = 4, deployment.feeManager;

         case 4:
          return _context29.t2 = _context29.sent, _context29.abrupt("return", _context29.t0.deploy.call(_context29.t0, _context29.t1, _context29.t2));

         case 6:
         case "end":
          return _context29.stop();
        }
      }), _callee29);
    })))();
  },
  postDeployment: function(_config, deployment) {
    return _asyncToGenerator(regeneratorRuntime.mark((function _callee30() {
      var adapters, integrationManager, engineAdapter, engine, fees, feeManager, policies, policyManager;
      return regeneratorRuntime.wrap((function(_context30) {
        for (;;) switch (_context30.prev = _context30.next) {
         case 0:
          return _context30.next = 2, deployment.chaiAdapter;

         case 2:
          return _context30.t0 = _context30.sent, _context30.next = 5, deployment.engineAdapter;

         case 5:
          return _context30.t1 = _context30.sent, _context30.next = 8, deployment.kyberAdapter;

         case 8:
          return _context30.t2 = _context30.sent, _context30.next = 11, deployment.trackedAssetsAdapter;

         case 11:
          return _context30.t3 = _context30.sent, _context30.next = 14, deployment.zeroExV2Adapter;

         case 14:
          return _context30.t4 = _context30.sent, adapters = [ _context30.t0, _context30.t1, _context30.t2, _context30.t3, _context30.t4 ], 
          _context30.next = 18, deployment.integrationManager;

         case 18:
          return integrationManager = _context30.sent, _context30.next = 21, integrationManager.registerAdapters(adapters);

         case 21:
          return _context30.next = 23, deployment.engineAdapter;

         case 23:
          return engineAdapter = _context30.sent, _context30.next = 26, deployment.engine;

         case 26:
          return engine = _context30.sent, _context30.next = 29, engine.addEtherTakers([ engineAdapter ]);

         case 29:
          return _context30.next = 31, deployment.entranceRateFee;

         case 31:
          return _context30.t5 = _context30.sent, _context30.next = 34, deployment.managementFee;

         case 34:
          return _context30.t6 = _context30.sent, _context30.next = 37, deployment.performanceFee;

         case 37:
          return _context30.t7 = _context30.sent, fees = [ _context30.t5, _context30.t6, _context30.t7 ], 
          _context30.next = 41, deployment.feeManager;

         case 41:
          return feeManager = _context30.sent, _context30.next = 44, feeManager.registerFees(fees);

         case 44:
          return _context30.next = 46, deployment.adapterBlacklist;

         case 46:
          return _context30.t8 = _context30.sent, _context30.next = 49, deployment.adapterWhitelist;

         case 49:
          return _context30.t9 = _context30.sent, _context30.next = 52, deployment.assetBlacklist;

         case 52:
          return _context30.t10 = _context30.sent, _context30.next = 55, deployment.assetWhitelist;

         case 55:
          return _context30.t11 = _context30.sent, _context30.next = 58, deployment.maxConcentration;

         case 58:
          return _context30.t12 = _context30.sent, _context30.next = 61, deployment.investorWhitelist;

         case 61:
          return _context30.t13 = _context30.sent, policies = [ _context30.t8, _context30.t9, _context30.t10, _context30.t11, _context30.t12, _context30.t13 ], 
          _context30.next = 65, deployment.policyManager;

         case 65:
          return policyManager = _context30.sent, _context30.next = 68, policyManager.registerPolicies(policies);

         case 68:
         case "end":
          return _context30.stop();
        }
      }), _callee30);
    })))();
  }
});

function _arrayWithoutHoles(arr) {
  if (Array.isArray(arr)) return _arrayLikeToArray(arr);
}

function _nonIterableSpread() {
  throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.");
}

function _toConsumableArray(arr) {
  return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _unsupportedIterableToArray(arr) || _nonIterableSpread();
}

function _iterableToArrayLimit(arr, i) {
  if ("undefined" != typeof Symbol && Symbol.iterator in Object(arr)) {
    var _arr = [], _n = !0, _d = !1, _e = void 0;
    try {
      for (var _s, _i = arr[Symbol.iterator](); !(_n = (_s = _i.next()).done) && (_arr.push(_s.value), 
      !i || _arr.length !== i); _n = !0) ;
    } catch (err) {
      _d = !0, _e = err;
    } finally {
      try {
        _n || null == _i.return || _i.return();
      } finally {
        if (_d) throw _e;
      }
    }
    return _arr;
  }
}

function _slicedToArray(arr, i) {
  return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest();
}

function _createForOfIteratorHelper(o, allowArrayLike) {
  var it;
  if ("undefined" == typeof Symbol || null == o[Symbol.iterator]) {
    if (Array.isArray(o) || (it = _unsupportedIterableToArray(o)) || allowArrayLike && o && "number" == typeof o.length) {
      it && (o = it);
      var i = 0, F = function() {};
      return {
        s: F,
        n: function() {
          return i >= o.length ? {
            done: !0
          } : {
            done: !1,
            value: o[i++]
          };
        },
        e: function(e) {
          throw e;
        },
        f: F
      };
    }
    throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.");
  }
  var err, normalCompletion = !0, didErr = !1;
  return {
    s: function() {
      it = o[Symbol.iterator]();
    },
    n: function() {
      var step = it.next();
      return normalCompletion = step.done, step;
    },
    e: function(e) {
      didErr = !0, err = e;
    },
    f: function() {
      try {
        normalCompletion || null == it.return || it.return();
      } finally {
        if (didErr) throw err;
      }
    }
  };
}

function encodeArgs(_x, _x2) {
  return _encodeArgs.apply(this, arguments);
}

function _encodeArgs() {
  return (_encodeArgs = _asyncToGenerator(regeneratorRuntime.mark((function _callee(types, args) {
    var params, resolved, hex;
    return regeneratorRuntime.wrap((function(_context) {
      for (;;) switch (_context.prev = _context.next) {
       case 0:
        return params = types.map((function(type) {
          return ethers.utils.ParamType.from(type);
        })), _context.next = 3, crestproject.resolveArguments(params, args);

       case 3:
        return resolved = _context.sent, hex = ethers.utils.defaultAbiCoder.encode(params, resolved), 
        _context.abrupt("return", ethers.utils.arrayify(hex));

       case 6:
       case "end":
        return _context.stop();
      }
    }), _callee);
  })))).apply(this, arguments);
}

function encodeArgsSync(types, args) {
  var params = types.map((function(type) {
    return ethers.utils.ParamType.from(type);
  })), hex = ethers.utils.defaultAbiCoder.encode(params, args);
  return ethers.utils.arrayify(hex);
}

function encodeFunctionData(fragment) {
  var args = arguments.length > 1 && void 0 !== arguments[1] ? arguments[1] : [], encodedArgs = encodeArgsSync(fragment.inputs, args);
  return ethers.utils.hexlify(ethers.utils.concat([ sighash(fragment), encodedArgs ]));
}

function sighash(fragment) {
  return ethers.utils.hexDataSlice(ethers.utils.id(fragment.format()), 0, 4);
}

function bigNumberMax(values) {
  var _step, max = ethers.BigNumber.from(0), _iterator = _createForOfIteratorHelper(values);
  try {
    for (_iterator.s(); !(_step = _iterator.n()).done; ) {
      var value = _step.value, bnValue = ethers.BigNumber.from(value);
      bnValue.gt(max) && (max = bnValue);
    }
  } catch (err) {
    _iterator.e(err);
  } finally {
    _iterator.f();
  }
  return max;
}

function getAssetBalances(_x3) {
  return _getAssetBalances.apply(this, arguments);
}

function _getAssetBalances() {
  return (_getAssetBalances = _asyncToGenerator(regeneratorRuntime.mark((function _callee2(_ref) {
    var account, assets;
    return regeneratorRuntime.wrap((function(_context2) {
      for (;;) switch (_context2.prev = _context2.next) {
       case 0:
        return account = _ref.account, assets = _ref.assets, _context2.abrupt("return", Promise.all(assets.map((function(asset) {
          return asset.balanceOf(account);
        }))));

       case 2:
       case "end":
        return _context2.stop();
      }
    }), _callee2);
  })))).apply(this, arguments);
}

function generatePseudoRandomZeroExV2Salt() {
  var hex = ethers.utils.hexlify(ethers.utils.randomBytes(32)), number = ethers.BigNumber.from(hex);
  return ethers.BigNumber.from("".concat(number).slice(0, 10));
}

var zeroExV2AssetFragment = ethers.utils.FunctionFragment.fromString("ERC20Token(address)");

function encodeZeroExV2AssetData(tokenAddress) {
  var lowerCaseAddress = tokenAddress.toLowerCase();
  return encodeFunctionData(zeroExV2AssetFragment, [ lowerCaseAddress ]);
}

function createUnsignedZeroExV2Order(_x) {
  return _createUnsignedZeroExV2Order.apply(this, arguments);
}

function _createUnsignedZeroExV2Order() {
  return (_createUnsignedZeroExV2Order = _asyncToGenerator(regeneratorRuntime.mark((function _callee(_ref) {
    var provider, exchange, maker, feeRecipientAddress, makerAssetAmount, takerAssetAmount, takerFee, _ref$duration, duration, makerAsset, takerAsset, _yield$Promise$all$ma, _yield$Promise$all$ma2, exchangeAddress, makerAddress, makerAssetAddress, takerAssetAddress, makerAssetData, takerAssetData, salt, latestBlock, expirationTimeSeconds;
    return regeneratorRuntime.wrap((function(_context) {
      for (;;) switch (_context.prev = _context.next) {
       case 0:
        return provider = _ref.provider, exchange = _ref.exchange, maker = _ref.maker, feeRecipientAddress = _ref.feeRecipientAddress, 
        makerAssetAmount = _ref.makerAssetAmount, takerAssetAmount = _ref.takerAssetAmount, 
        takerFee = _ref.takerFee, _ref$duration = _ref.duration, duration = void 0 === _ref$duration ? 86400 : _ref$duration, 
        makerAsset = _ref.makerAsset, takerAsset = _ref.takerAsset, _context.next = 3, Promise.all([ crestproject.resolveAddress(exchange), crestproject.resolveAddress(maker), crestproject.resolveAddress(makerAsset), crestproject.resolveAddress(takerAsset) ]);

       case 3:
        return _yield$Promise$all$ma = _context.sent.map((function(value) {
          return value.toLowerCase();
        })), _yield$Promise$all$ma2 = _slicedToArray(_yield$Promise$all$ma, 4), exchangeAddress = _yield$Promise$all$ma2[0], 
        makerAddress = _yield$Promise$all$ma2[1], makerAssetAddress = _yield$Promise$all$ma2[2], 
        takerAssetAddress = _yield$Promise$all$ma2[3], makerAssetData = encodeZeroExV2AssetData(makerAssetAddress), 
        takerAssetData = encodeZeroExV2AssetData(takerAssetAddress), salt = generatePseudoRandomZeroExV2Salt(), 
        _context.next = 14, provider.getBlock("latest");

       case 14:
        return latestBlock = _context.sent, expirationTimeSeconds = ethers.BigNumber.from(latestBlock.timestamp + duration), 
        _context.abrupt("return", {
          exchangeAddress: exchangeAddress,
          makerAddress: makerAddress,
          takerAddress: ethers.constants.AddressZero,
          feeRecipientAddress: feeRecipientAddress.toString(),
          senderAddress: ethers.constants.AddressZero,
          makerAssetAmount: makerAssetAmount.toString(),
          takerAssetAmount: takerAssetAmount.toString(),
          makerFee: ethers.constants.Zero.toString(),
          takerFee: takerFee.toString(),
          expirationTimeSeconds: expirationTimeSeconds.toString(),
          salt: salt.toString(),
          makerAssetData: makerAssetData,
          takerAssetData: takerAssetData,
          makerAsset: makerAssetAddress,
          takerAsset: takerAssetAddress
        });

       case 17:
       case "end":
        return _context.stop();
      }
    }), _callee);
  })))).apply(this, arguments);
}

function signZeroExV2Order(_x2, _x3) {
  return _signZeroExV2Order.apply(this, arguments);
}

function _signZeroExV2Order() {
  return (_signZeroExV2Order = _asyncToGenerator(regeneratorRuntime.mark((function _callee2(order, signer) {
    var orderTypedData, orderHashHex, signature, split, type, joined;
    return regeneratorRuntime.wrap((function(_context2) {
      for (;;) switch (_context2.prev = _context2.next) {
       case 0:
        return orderTypedData = createZeroExV2OrderTypedData(order), orderHashHex = ethersEip712.encodeTypedDataDigest(orderTypedData), 
        _context2.next = 4, signer.signMessage(orderHashHex);

       case 4:
        return signature = _context2.sent, split = ethers.utils.splitSignature(signature), 
        type = ethers.utils.hexlify(3), joined = ethers.utils.hexlify(ethers.utils.concat([ ethers.utils.hexlify(split.v), split.r, split.s, type ])), 
        _context2.abrupt("return", _objectSpread2(_objectSpread2({}, order), {}, {
          signature: joined
        }));

       case 9:
       case "end":
        return _context2.stop();
      }
    }), _callee2);
  })))).apply(this, arguments);
}

function createZeroExV2OrderTypedData(order) {
  var domain = {
    name: "0x Protocol",
    version: "2",
    verifyingContract: order.exchangeAddress
  };
  return ethersEip712.buildTypedData(domain, {
    Order: [ {
      name: "makerAddress",
      type: "address"
    }, {
      name: "takerAddress",
      type: "address"
    }, {
      name: "feeRecipientAddress",
      type: "address"
    }, {
      name: "senderAddress",
      type: "address"
    }, {
      name: "makerAssetAmount",
      type: "uint256"
    }, {
      name: "takerAssetAmount",
      type: "uint256"
    }, {
      name: "makerFee",
      type: "uint256"
    }, {
      name: "takerFee",
      type: "uint256"
    }, {
      name: "expirationTimeSeconds",
      type: "uint256"
    }, {
      name: "salt",
      type: "uint256"
    }, {
      name: "makerAssetData",
      type: "bytes"
    }, {
      name: "takerAssetData",
      type: "bytes"
    } ]
  }, "Order", order);
}

function encodeZeroExV2Order(_x4) {
  return _encodeZeroExV2Order.apply(this, arguments);
}

function _encodeZeroExV2Order() {
  return (_encodeZeroExV2Order = _asyncToGenerator(regeneratorRuntime.mark((function _callee3(order) {
    return regeneratorRuntime.wrap((function(_context3) {
      for (;;) switch (_context3.prev = _context3.next) {
       case 0:
        return _context3.abrupt("return", encodeArgs([ "address[4]", "uint256[6]", "bytes[2]", "bytes" ], [ [ order.makerAddress, order.takerAddress, order.feeRecipientAddress, order.senderAddress ], [ order.makerAssetAmount, order.takerAssetAmount, order.makerFee, order.takerFee, order.expirationTimeSeconds, order.salt ], [ order.makerAssetData, order.takerAssetData ], order.signature ]));

       case 1:
       case "end":
        return _context3.stop();
      }
    }), _callee3);
  })))).apply(this, arguments);
}

function zeroExV2TakeOrderArgs(_x5, _x6) {
  return _zeroExV2TakeOrderArgs.apply(this, arguments);
}

function _zeroExV2TakeOrderArgs() {
  return (_zeroExV2TakeOrderArgs = _asyncToGenerator(regeneratorRuntime.mark((function _callee4(order, takerAssetFillAmount) {
    return regeneratorRuntime.wrap((function(_context4) {
      for (;;) switch (_context4.prev = _context4.next) {
       case 0:
        return _context4.abrupt("return", encodeArgs([ "bytes", "uint256" ], [ encodeZeroExV2Order(order), takerAssetFillAmount ]));

       case 1:
       case "end":
        return _context4.stop();
      }
    }), _callee4);
  })))).apply(this, arguments);
}

var deployMocks = describeDeployment({
  tokens: function(config) {
    return _asyncToGenerator(regeneratorRuntime.mark((function _callee() {
      var _yield$Promise$all, _yield$Promise$all2, weth, mln, rep, knc, zrx, dai, ren;
      return regeneratorRuntime.wrap((function(_context) {
        for (;;) switch (_context.prev = _context.next) {
         case 0:
          return _context.next = 2, Promise.all([ protocol.WETH.deploy(config.deployer), protocol.MockToken.deploy(config.deployer, "mln", "MLN", 18), protocol.MockToken.deploy(config.deployer, "rep", "REP", 18), protocol.MockToken.deploy(config.deployer, "knc", "KNC", 18), protocol.MockToken.deploy(config.deployer, "zrx", "ZRX", 18), protocol.MockToken.deploy(config.deployer, "dai", "DAI", 18), protocol.MockToken.deploy(config.deployer, "ren", "REN", 18) ]);

         case 2:
          return _yield$Promise$all = _context.sent, _yield$Promise$all2 = _slicedToArray(_yield$Promise$all, 7), 
          weth = _yield$Promise$all2[0], mln = _yield$Promise$all2[1], rep = _yield$Promise$all2[2], 
          knc = _yield$Promise$all2[3], zrx = _yield$Promise$all2[4], dai = _yield$Promise$all2[5], 
          ren = _yield$Promise$all2[6], _context.abrupt("return", {
            weth: weth,
            mln: mln,
            rep: rep,
            knc: knc,
            zrx: zrx,
            dai: dai,
            ren: ren
          });

         case 12:
         case "end":
          return _context.stop();
        }
      }), _callee);
    })))();
  },
  chaiPriceSource: function(config) {
    return _asyncToGenerator(regeneratorRuntime.mark((function _callee2() {
      return regeneratorRuntime.wrap((function(_context2) {
        for (;;) switch (_context2.prev = _context2.next) {
         case 0:
          return _context2.abrupt("return", protocol.MockChaiPriceSource.deploy(config.deployer));

         case 1:
         case "end":
          return _context2.stop();
        }
      }), _callee2);
    })))();
  },
  chainlinkAggregators: function(config) {
    return _asyncToGenerator(regeneratorRuntime.mark((function _callee3() {
      var _yield$Promise$all3, _yield$Promise$all4, mln, rep, knc, zrx, dai, ren;
      return regeneratorRuntime.wrap((function(_context3) {
        for (;;) switch (_context3.prev = _context3.next) {
         case 0:
          return _context3.next = 2, Promise.all([ protocol.MockChainlinkPriceSource.deploy(config.deployer, 18), protocol.MockChainlinkPriceSource.deploy(config.deployer, 18), protocol.MockChainlinkPriceSource.deploy(config.deployer, 18), protocol.MockChainlinkPriceSource.deploy(config.deployer, 18), protocol.MockChainlinkPriceSource.deploy(config.deployer, 18), protocol.MockChainlinkPriceSource.deploy(config.deployer, 8) ]);

         case 2:
          return _yield$Promise$all3 = _context3.sent, _yield$Promise$all4 = _slicedToArray(_yield$Promise$all3, 6), 
          mln = _yield$Promise$all4[0], rep = _yield$Promise$all4[1], knc = _yield$Promise$all4[2], 
          zrx = _yield$Promise$all4[3], dai = _yield$Promise$all4[4], ren = _yield$Promise$all4[5], 
          _context3.abrupt("return", {
            mln: mln,
            rep: rep,
            knc: knc,
            zrx: zrx,
            dai: dai,
            ren: ren
          });

         case 11:
         case "end":
          return _context3.stop();
        }
      }), _callee3);
    })))();
  },
  chainlinkEthUsdAggregator: function(config) {
    return _asyncToGenerator(regeneratorRuntime.mark((function _callee4() {
      return regeneratorRuntime.wrap((function(_context4) {
        for (;;) switch (_context4.prev = _context4.next) {
         case 0:
          return _context4.abrupt("return", protocol.MockChainlinkPriceSource.deploy(config.deployer, 8));

         case 1:
         case "end":
          return _context4.stop();
        }
      }), _callee4);
    })))();
  },
  chaiIntegratee: function(config, deployment) {
    return _asyncToGenerator(regeneratorRuntime.mark((function _callee5() {
      var tokens;
      return regeneratorRuntime.wrap((function(_context5) {
        for (;;) switch (_context5.prev = _context5.next) {
         case 0:
          return _context5.next = 2, deployment.tokens;

         case 2:
          return tokens = _context5.sent, _context5.abrupt("return", protocol.MockChaiIntegratee.deploy(config.deployer, tokens.dai));

         case 4:
         case "end":
          return _context5.stop();
        }
      }), _callee5);
    })))();
  },
  kyberIntegratee: function(config) {
    return _asyncToGenerator(regeneratorRuntime.mark((function _callee6() {
      return regeneratorRuntime.wrap((function(_context6) {
        for (;;) switch (_context6.prev = _context6.next) {
         case 0:
          return _context6.abrupt("return", protocol.MockKyberIntegratee.deploy(config.deployer, []));

         case 1:
         case "end":
          return _context6.stop();
        }
      }), _callee6);
    })))();
  },
  mockGenericAdapter: function(config, deployment) {
    return _asyncToGenerator(regeneratorRuntime.mark((function _callee7() {
      return regeneratorRuntime.wrap((function(_context7) {
        for (;;) switch (_context7.prev = _context7.next) {
         case 0:
          return _context7.t0 = protocol.MockGenericAdapter, _context7.t1 = config.deployer, 
          _context7.next = 4, deployment.mockGenericIntegratee;

         case 4:
          return _context7.t2 = _context7.sent, _context7.abrupt("return", _context7.t0.deploy.call(_context7.t0, _context7.t1, _context7.t2));

         case 6:
         case "end":
          return _context7.stop();
        }
      }), _callee7);
    })))();
  },
  mockGenericIntegratee: function(config) {
    return _asyncToGenerator(regeneratorRuntime.mark((function _callee8() {
      return regeneratorRuntime.wrap((function(_context8) {
        for (;;) switch (_context8.prev = _context8.next) {
         case 0:
          return _context8.abrupt("return", protocol.MockGenericIntegratee.deploy(config.deployer));

         case 1:
         case "end":
          return _context8.stop();
        }
      }), _callee8);
    })))();
  },
  zeroExV2Integratee: function(config, deployment) {
    return _asyncToGenerator(regeneratorRuntime.mark((function _callee9() {
      var tokens, assetData;
      return regeneratorRuntime.wrap((function(_context9) {
        for (;;) switch (_context9.prev = _context9.next) {
         case 0:
          return _context9.next = 2, deployment.tokens;

         case 2:
          return tokens = _context9.sent, assetData = encodeZeroExV2AssetData(tokens.zrx.address), 
          _context9.abrupt("return", protocol.MockZeroExV2Integratee.deploy(config.deployer, assetData));

         case 5:
         case "end":
          return _context9.stop();
        }
      }), _callee9);
    })))();
  }
});

function configureMockRelease(_x) {
  return _configureMockRelease.apply(this, arguments);
}

function _configureMockRelease() {
  return (_configureMockRelease = _asyncToGenerator(regeneratorRuntime.mark((function _callee12(_ref) {
    var deployer, mgm, dispatcher, mocks, accounts, integratees, tokens, chainlinkPrimitives, chainlinkAggregators, chainlinkRateAssets;
    return regeneratorRuntime.wrap((function(_context12) {
      for (;;) switch (_context12.prev = _context12.next) {
       case 0:
        return deployer = _ref.deployer, mgm = _ref.mgm, dispatcher = _ref.dispatcher, mocks = _ref.mocks, 
        accounts = _ref.accounts, integratees = [ mocks.kyberIntegratee, mocks.chaiIntegratee, mocks.mockGenericIntegratee ], 
        tokens = [ mocks.tokens.mln, mocks.tokens.rep, mocks.tokens.knc, mocks.tokens.zrx, mocks.tokens.dai, mocks.tokens.ren, mocks.chaiIntegratee ], 
        chainlinkPrimitives = [ mocks.tokens.mln, mocks.tokens.rep, mocks.tokens.knc, mocks.tokens.zrx, mocks.tokens.dai, mocks.tokens.ren ], 
        chainlinkAggregators = [ mocks.chainlinkAggregators.mln, mocks.chainlinkAggregators.rep, mocks.chainlinkAggregators.knc, mocks.chainlinkAggregators.zrx, mocks.chainlinkAggregators.dai, mocks.chainlinkAggregators.ren ], 
        chainlinkRateAssets = [ 0, 0, 0, 0, 0, 1 ], _context12.next = 8, Promise.all([ makeWethRich(mocks.tokens.weth, deployer, ethers.utils.parseEther("1000")), makeTokenRich(Object.values(tokens), deployer) ].concat(_toConsumableArray(accounts.map(function() {
          var _ref2 = _asyncToGenerator(regeneratorRuntime.mark((function _callee10(account) {
            return regeneratorRuntime.wrap((function(_context10) {
              for (;;) switch (_context10.prev = _context10.next) {
               case 0:
                return _context10.next = 2, Promise.all([ makeTokenRich(Object.values(tokens), account), makeWethRich(mocks.tokens.weth, account) ]);

               case 2:
               case "end":
                return _context10.stop();
              }
            }), _callee10);
          })));
          return function(_x6) {
            return _ref2.apply(this, arguments);
          };
        }()))));

       case 8:
        return _context12.next = 10, Promise.all(integratees.map(function() {
          var _ref3 = _asyncToGenerator(regeneratorRuntime.mark((function _callee11(integratee) {
            return regeneratorRuntime.wrap((function(_context11) {
              for (;;) switch (_context11.prev = _context11.next) {
               case 0:
                return _context11.next = 2, Promise.all([ mocks.tokens.weth.transfer(integratee, ethers.utils.parseEther("100")), makeEthRich(deployer, integratee), makeTokenRich(tokens, integratee) ]);

               case 2:
               case "end":
                return _context11.stop();
              }
            }), _callee11);
          })));
          return function(_x7) {
            return _ref3.apply(this, arguments);
          };
        }()));

       case 10:
        return _context12.abrupt("return", {
          deployer: deployer,
          mgm: mgm,
          dispatcher: dispatcher.address,
          mln: mocks.tokens.mln.address,
          weth: mocks.tokens.weth.address,
          registeredVaultCalls: {
            contracts: [],
            selectors: []
          },
          engine: {
            thawDelay: 1e10
          },
          chainlink: {
            ethUsdAggregator: mocks.chainlinkEthUsdAggregator,
            staleRateThreshold: 259200,
            aggregators: chainlinkAggregators,
            primitives: chainlinkPrimitives,
            rateAssets: chainlinkRateAssets
          },
          integrationManager: {
            trackedAssetsLimit: 20
          },
          integratees: {
            chai: mocks.chaiIntegratee.address,
            kyber: mocks.kyberIntegratee.address,
            makerDao: {
              dai: mocks.tokens.dai.address,
              pot: mocks.chaiPriceSource.address
            },
            uniswapV2: {
              factory: crestproject.randomAddress()
            },
            zeroExV2: {
              exchange: mocks.zeroExV2Integratee.address,
              erc20Proxy: crestproject.randomAddress()
            }
          }
        });

       case 11:
       case "end":
        return _context12.stop();
      }
    }), _callee12);
  })))).apply(this, arguments);
}

function makeEthRich(_x2, _x3) {
  return _makeEthRich.apply(this, arguments);
}

function _makeEthRich() {
  return (_makeEthRich = _asyncToGenerator(regeneratorRuntime.mark((function _callee13(sender, receiver) {
    var amount, _args13 = arguments;
    return regeneratorRuntime.wrap((function(_context13) {
      for (;;) switch (_context13.prev = _context13.next) {
       case 0:
        return amount = _args13.length > 2 && void 0 !== _args13[2] ? _args13[2] : ethers.utils.parseEther("100"), 
        _context13.t0 = sender, _context13.next = 4, crestproject.resolveAddress(receiver);

       case 4:
        return _context13.t1 = _context13.sent, _context13.t2 = amount, _context13.t3 = {
          to: _context13.t1,
          value: _context13.t2
        }, _context13.abrupt("return", _context13.t0.sendTransaction.call(_context13.t0, _context13.t3));

       case 8:
       case "end":
        return _context13.stop();
      }
    }), _callee13);
  })))).apply(this, arguments);
}

function makeWethRich(_x4, _x5) {
  return _makeWethRich.apply(this, arguments);
}

function _makeWethRich() {
  return (_makeWethRich = _asyncToGenerator(regeneratorRuntime.mark((function _callee14(weth, account) {
    var amount, connected, _args14 = arguments;
    return regeneratorRuntime.wrap((function(_context14) {
      for (;;) switch (_context14.prev = _context14.next) {
       case 0:
        return amount = _args14.length > 2 && void 0 !== _args14[2] ? _args14[2] : ethers.utils.parseEther("100"), 
        connected = weth.connect(account), _context14.abrupt("return", connected.deposit.value(amount).send());

       case 3:
       case "end":
        return _context14.stop();
      }
    }), _callee14);
  })))).apply(this, arguments);
}

function makeTokenRich(tokens, receiver) {
  var amount = arguments.length > 2 && void 0 !== arguments[2] ? arguments[2] : ethers.utils.parseEther("100"), promises = tokens.map((function(token) {
    return token.mintFor(receiver, amount);
  }));
  return Promise.all(promises);
}

var mainnet = {
  chai: "0x06AF07097C9Eeb7fD685c692751D5C66dB49c215",
  chaiPriceSource: "0x197E90f9FAD81970bA7976f33CbD77088E5D7cf7",
  chainlinkEthUsdAggregator: "0x5f4eC3Df9cbd43714FE2740f5E3616155c5b8419",
  chainlinkAggregators: {
    dai: [ "0x773616E4d11A78F511299002da57A0a94577F1f4", 0 ],
    knc: [ "0x656c0544eF4C98A6a98491833A89204Abb045d6b", 0 ],
    zrx: [ "0x2Da4983a622a8498bb1a21FaE9D8F6C664939962", 0 ],
    rep: [ "0xD4CE430C3b67b3E2F7026D86E7128588629e2455", 0 ],
    ren: [ "0x0f59666EDE214281e956cb3b2D0d69415AfF4A01", 1 ]
  },
  kyber: "0x9AAb3f75489902f3a48495025729a0AF77d4b11e",
  tokens: {
    dai: "0x6B175474E89094C44Da98b954EedeAC495271d0F",
    knc: "0xdd974D5C2e2928deA5F71b9825b8b646686BD200",
    mln: "0xec67005c4E498Ec7f55E092bd1d35cbC47C91892",
    rep: "0x221657776846890989a759BA2973e427DfF5C9bB",
    ren: "0x408e41876cccdc0f92210600ef50372656052a38",
    usdc: "0xA0b86991c6218b36c1d19D4a2e9Eb0cE3606eB48",
    weth: "0xC02aaA39b223FE8D0A0e5C4F27eAD9083C756Cc2",
    zrx: "0xE41d2489571d322189246DaFA5ebDe1F4699F498"
  },
  whales: {
    dai: "0x16B34Ce9A6a6F7FC2DD25Ba59bf7308E7B38E186",
    knc: "0x986C98AF08AdBB82A8De7c7E88c6e8e4C74105ae",
    mln: "0xd8f8a53945bcfbbc19da162aa405e662ef71c40d",
    rep: "0x78d196056e1f369ec2d563aaac504ea53462b30e",
    ren: "0xbe0eb53f46cd790cd13851d5eff43d12404d33e8",
    usdc: "0x18F77cf74D91f946dD65CC235B8100DCec741280",
    weth: "0xe08A8b19e5722a201EaF20A6BC595eF655397bd5",
    zrx: "0x206376e8940e42538781cd94ef024df3c1e0fd43"
  },
  zeroExV2: {
    exchange: "0x080bf510fcbf18b91105470639e9561022937712",
    erc20Proxy: "0x95e6f48254609a6ee006f7d493c8e5fb97094cef"
  }
};

function configureForkRelease(_x) {
  return _configureForkRelease.apply(this, arguments);
}

function _configureForkRelease() {
  return (_configureForkRelease = _asyncToGenerator(regeneratorRuntime.mark((function _callee4(_ref) {
    var provider, deployer, mgm, dispatcher, accounts, whales, tokens, chainlinkConfig, chainlinkRateAssets, chainlinkAggregators, chainlinkPrimitives;
    return regeneratorRuntime.wrap((function(_context4) {
      for (;;) switch (_context4.prev = _context4.next) {
       case 0:
        return provider = _ref.provider, deployer = _ref.deployer, mgm = _ref.mgm, dispatcher = _ref.dispatcher, 
        accounts = _ref.accounts, whales = Object.entries(mainnet.whales).reduce((function(carry, _ref2) {
          var _ref3 = _slicedToArray(_ref2, 2), key = _ref3[0], address = _ref3[1], signer = provider.getSigner(address);
          return _objectSpread2(_objectSpread2({}, carry), {}, _defineProperty({}, key, signer));
        }), {}), tokens = Object.entries(mainnet.tokens).reduce((function(carry, _ref4) {
          var _ref5 = _slicedToArray(_ref4, 2), key = _ref5[0], address = _ref5[1], token = new protocol.StandardToken(address, deployer);
          return _objectSpread2(_objectSpread2({}, carry), {}, _defineProperty({}, key, token));
        }), {}), chainlinkConfig = Object.values(mainnet.chainlinkAggregators), chainlinkRateAssets = chainlinkConfig.map((function(_ref6) {
          return _slicedToArray(_ref6, 2)[1];
        })), chainlinkAggregators = chainlinkConfig.map((function(_ref8) {
          return _slicedToArray(_ref8, 1)[0];
        })), chainlinkPrimitives = Object.keys(mainnet.chainlinkAggregators).map((function(key) {
          return mainnet.tokens[key];
        })), _context4.next = 9, Promise.all(Object.values(whales).map(function() {
          var _ref10 = _asyncToGenerator(regeneratorRuntime.mark((function _callee(whale) {
            return regeneratorRuntime.wrap((function(_context) {
              for (;;) switch (_context.prev = _context.next) {
               case 0:
                return _context.next = 2, makeEthRich$1(deployer, whale);

               case 2:
               case "end":
                return _context.stop();
              }
            }), _callee);
          })));
          return function(_x7) {
            return _ref10.apply(this, arguments);
          };
        }()));

       case 9:
        return _context4.next = 11, Promise.all([].concat(_toConsumableArray(accounts), [ deployer, mgm ]).map(function() {
          var _ref11 = _asyncToGenerator(regeneratorRuntime.mark((function _callee3(account) {
            return regeneratorRuntime.wrap((function(_context3) {
              for (;;) switch (_context3.prev = _context3.next) {
               case 0:
                return _context3.next = 2, Promise.all(Object.entries(whales).map(function() {
                  var _ref13 = _asyncToGenerator(regeneratorRuntime.mark((function _callee2(_ref12) {
                    var _ref14, symbol, whale, token;
                    return regeneratorRuntime.wrap((function(_context2) {
                      for (;;) switch (_context2.prev = _context2.next) {
                       case 0:
                        return _ref14 = _slicedToArray(_ref12, 2), symbol = _ref14[0], whale = _ref14[1], 
                        token = tokens[symbol], _context2.next = 4, makeTokenRich$1(token, whale, account);

                       case 4:
                       case "end":
                        return _context2.stop();
                      }
                    }), _callee2);
                  })));
                  return function(_x9) {
                    return _ref13.apply(this, arguments);
                  };
                }()));

               case 2:
               case "end":
                return _context3.stop();
              }
            }), _callee3);
          })));
          return function(_x8) {
            return _ref11.apply(this, arguments);
          };
        }()));

       case 11:
        return _context4.abrupt("return", {
          deployer: deployer,
          mgm: mgm,
          mainnet: mainnet,
          tokens: tokens,
          whales: whales,
          dispatcher: dispatcher.address,
          mln: mainnet.tokens.mln,
          weth: mainnet.tokens.weth,
          registeredVaultCalls: {
            contracts: [],
            selectors: []
          },
          engine: {
            thawDelay: 1e10
          },
          chainlink: {
            ethUsdAggregator: mainnet.chainlinkEthUsdAggregator,
            staleRateThreshold: 259200,
            aggregators: chainlinkAggregators,
            primitives: chainlinkPrimitives,
            rateAssets: chainlinkRateAssets
          },
          integrationManager: {
            trackedAssetsLimit: 20
          },
          integratees: {
            chai: mainnet.chai,
            kyber: mainnet.kyber,
            makerDao: {
              dai: crestproject.randomAddress(),
              pot: crestproject.randomAddress()
            },
            uniswapV2: {
              factory: crestproject.randomAddress()
            },
            zeroExV2: {
              exchange: mainnet.zeroExV2.exchange,
              erc20Proxy: mainnet.zeroExV2.erc20Proxy
            }
          }
        });

       case 12:
       case "end":
        return _context4.stop();
      }
    }), _callee4);
  })))).apply(this, arguments);
}

function makeEthRich$1(_x2, _x3) {
  return _makeEthRich$1.apply(this, arguments);
}

function _makeEthRich$1() {
  return (_makeEthRich$1 = _asyncToGenerator(regeneratorRuntime.mark((function _callee5(sender, receiver) {
    return regeneratorRuntime.wrap((function(_context5) {
      for (;;) switch (_context5.prev = _context5.next) {
       case 0:
        return _context5.t0 = sender, _context5.next = 3, crestproject.resolveAddress(receiver);

       case 3:
        return _context5.t1 = _context5.sent, _context5.t2 = ethers.utils.parseEther("100"), 
        _context5.t3 = {
          to: _context5.t1,
          value: _context5.t2
        }, _context5.abrupt("return", _context5.t0.sendTransaction.call(_context5.t0, _context5.t3));

       case 7:
       case "end":
        return _context5.stop();
      }
    }), _callee5);
  })))).apply(this, arguments);
}

function makeTokenRich$1(_x4, _x5, _x6) {
  return _makeTokenRich.apply(this, arguments);
}

function _makeTokenRich() {
  return (_makeTokenRich = _asyncToGenerator(regeneratorRuntime.mark((function _callee6(token, sender, receiver) {
    var amount;
    return regeneratorRuntime.wrap((function(_context6) {
      for (;;) switch (_context6.prev = _context6.next) {
       case 0:
        return _context6.t0 = ethers.constants.One.mul(10), _context6.next = 3, token.decimals();

       case 3:
        return _context6.t1 = _context6.sent, amount = _context6.t0.pow.call(_context6.t0, _context6.t1).mul(100), 
        _context6.next = 7, token.connect(sender).transfer(receiver, amount);

       case 7:
       case "end":
        return _context6.stop();
      }
    }), _callee6);
  })))).apply(this, arguments);
}

function getSigners(_x) {
  return _getSigners.apply(this, arguments);
}

function _getSigners() {
  return (_getSigners = _asyncToGenerator(regeneratorRuntime.mark((function _callee(provider) {
    var limit, addresses, _args = arguments;
    return regeneratorRuntime.wrap((function(_context) {
      for (;;) switch (_context.prev = _context.next) {
       case 0:
        return limit = _args.length > 1 && void 0 !== _args[1] ? _args[1] : 10, _context.next = 3, 
        provider.listAccounts();

       case 3:
        return addresses = _context.sent, _context.abrupt("return", addresses.slice(0, limit).map((function(address) {
          return provider.getSigner(address);
        })));

       case 5:
       case "end":
        return _context.stop();
      }
    }), _callee);
  })))).apply(this, arguments);
}

function defaultTestDeployment(_x2) {
  return _defaultTestDeployment.apply(this, arguments);
}

function _defaultTestDeployment() {
  return (_defaultTestDeployment = _asyncToGenerator(regeneratorRuntime.mark((function _callee2(provider) {
    var _yield$getSigners, _yield$getSigners2, deployer, mgm, accounts, persistent, mocks, config, release;
    return regeneratorRuntime.wrap((function(_context2) {
      for (;;) switch (_context2.prev = _context2.next) {
       case 0:
        return _context2.next = 2, getSigners(provider);

       case 2:
        return _yield$getSigners = _context2.sent, _yield$getSigners2 = _toArray(_yield$getSigners), 
        deployer = _yield$getSigners2[0], mgm = _yield$getSigners2[1], accounts = _yield$getSigners2.slice(2), 
        _context2.next = 9, deployPersistent({
          deployer: deployer
        });

       case 9:
        return persistent = _context2.sent, _context2.next = 12, deployMocks({
          deployer: deployer,
          accounts: accounts
        });

       case 12:
        return mocks = _context2.sent, _context2.next = 15, configureMockRelease({
          dispatcher: persistent.dispatcher,
          deployer: deployer,
          mgm: mgm,
          mocks: mocks,
          accounts: accounts
        });

       case 15:
        return config = _context2.sent, _context2.next = 18, deployRelease(config);

       case 18:
        return release = _context2.sent, _context2.next = 21, persistent.dispatcher.setCurrentFundDeployer(release.fundDeployer);

       case 21:
        return _context2.next = 23, release.integrationManager.registerAdapters([ mocks.mockGenericAdapter ]);

       case 23:
        return _context2.abrupt("return", {
          config: config,
          accounts: accounts,
          deployment: _objectSpread2(_objectSpread2(_objectSpread2({}, mocks), persistent), release)
        });

       case 24:
       case "end":
        return _context2.stop();
      }
    }), _callee2);
  })))).apply(this, arguments);
}

function defaultForkDeployment(_x3) {
  return _defaultForkDeployment.apply(this, arguments);
}

function _defaultForkDeployment() {
  return (_defaultForkDeployment = _asyncToGenerator(regeneratorRuntime.mark((function _callee3(provider) {
    var _yield$getSigners3, _yield$getSigners4, deployer, mgm, accounts, persistent, config, release;
    return regeneratorRuntime.wrap((function(_context3) {
      for (;;) switch (_context3.prev = _context3.next) {
       case 0:
        return _context3.next = 2, getSigners(provider, 5);

       case 2:
        return _yield$getSigners3 = _context3.sent, _yield$getSigners4 = _toArray(_yield$getSigners3), 
        deployer = _yield$getSigners4[0], mgm = _yield$getSigners4[1], accounts = _yield$getSigners4.slice(2), 
        _context3.next = 9, deployPersistent({
          deployer: deployer
        });

       case 9:
        return persistent = _context3.sent, _context3.next = 12, configureForkRelease({
          provider: provider,
          dispatcher: persistent.dispatcher,
          deployer: deployer,
          mgm: mgm,
          accounts: accounts
        });

       case 12:
        return config = _context3.sent, _context3.next = 15, deployRelease(config);

       case 15:
        return release = _context3.sent, _context3.next = 18, persistent.dispatcher.setCurrentFundDeployer(release.fundDeployer);

       case 18:
        return _context3.abrupt("return", {
          config: config,
          accounts: accounts,
          deployment: _objectSpread2(_objectSpread2({}, persistent), release)
        });

       case 19:
       case "end":
        return _context3.stop();
      }
    }), _callee3);
  })))).apply(this, arguments);
}

function updateChainlinkAggregator(_x, _x2) {
  return _updateChainlinkAggregator.apply(this, arguments);
}

function _updateChainlinkAggregator() {
  return (_updateChainlinkAggregator = _asyncToGenerator(regeneratorRuntime.mark((function _callee(aggregator, price) {
    var answer, block;
    return regeneratorRuntime.wrap((function(_context) {
      for (;;) switch (_context.prev = _context.next) {
       case 0:
        if (null == price) {
          _context.next = 4;
          break;
        }
        _context.t0 = price, _context.next = 7;
        break;

       case 4:
        return _context.next = 6, aggregator.latestAnswer();

       case 6:
        _context.t0 = _context.sent;

       case 7:
        return answer = _context.t0, _context.next = 10, aggregator.provider.getBlock("latest");

       case 10:
        return block = _context.sent, _context.next = 13, aggregator.setLatestAnswer(answer, block.timestamp);

       case 13:
       case "end":
        return _context.stop();
      }
    }), _callee);
  })))).apply(this, arguments);
}

function seedAndThawEngine(_x, _x2, _x3) {
  return _seedAndThawEngine.apply(this, arguments);
}

function _seedAndThawEngine() {
  return (_seedAndThawEngine = _asyncToGenerator(regeneratorRuntime.mark((function _callee(provider, engine, amount) {
    return regeneratorRuntime.wrap((function(_context) {
      for (;;) switch (_context.prev = _context.next) {
       case 0:
        return _context.next = 2, engine.payAmguInEther.value(amount).send();

       case 2:
        return _context.next = 4, warpEngine(provider, engine);

       case 4:
        return _context.next = 6, engine.thaw();

       case 6:
       case "end":
        return _context.stop();
      }
    }), _callee);
  })))).apply(this, arguments);
}

function warpEngine(_x4, _x5) {
  return _warpEngine.apply(this, arguments);
}

function _warpEngine() {
  return (_warpEngine = _asyncToGenerator(regeneratorRuntime.mark((function _callee2(provider, engine) {
    var delay, warp;
    return regeneratorRuntime.wrap((function(_context2) {
      for (;;) switch (_context2.prev = _context2.next) {
       case 0:
        return _context2.next = 2, engine.getThawDelay();

       case 2:
        return delay = _context2.sent, warp = delay.add(1).toNumber(), _context2.next = 6, 
        provider.send("evm_increaseTime", [ warp ]);

       case 6:
        return _context2.next = 8, provider.send("evm_mine", []);

       case 8:
       case "end":
        return _context2.stop();
      }
    }), _callee2);
  })))).apply(this, arguments);
}

function callOnExtension(_x) {
  return _callOnExtension.apply(this, arguments);
}

function _callOnExtension() {
  return (_callOnExtension = _asyncToGenerator(regeneratorRuntime.mark((function _callee(_ref) {
    var comptrollerProxy, extension, actionId, _ref$callArgs, callArgs, signer, callOnExtensionTx;
    return regeneratorRuntime.wrap((function(_context) {
      for (;;) switch (_context.prev = _context.next) {
       case 0:
        return comptrollerProxy = _ref.comptrollerProxy, extension = _ref.extension, actionId = _ref.actionId, 
        _ref$callArgs = _ref.callArgs, callArgs = void 0 === _ref$callArgs ? "0x" : _ref$callArgs, 
        signer = _ref.signer, callOnExtensionTx = signer ? comptrollerProxy.connect(signer).callOnExtension(extension, actionId, callArgs) : comptrollerProxy.callOnExtension(extension, actionId, callArgs), 
        _context.next = 4, expect(callOnExtensionTx).resolves.toBeReceipt();

       case 4:
        return _context.abrupt("return", callOnExtensionTx);

       case 5:
       case "end":
        return _context.stop();
      }
    }), _callee);
  })))).apply(this, arguments);
}

function generateFeeManagerConfigWithMockFees(_x) {
  return _generateFeeManagerConfigWithMockFees.apply(this, arguments);
}

function _generateFeeManagerConfigWithMockFees() {
  return (_generateFeeManagerConfigWithMockFees = _asyncToGenerator(regeneratorRuntime.mark((function _callee(_ref) {
    var deployer, feeManager, fees, feeManagerSettingsData;
    return regeneratorRuntime.wrap((function(_context) {
      for (;;) switch (_context.prev = _context.next) {
       case 0:
        return deployer = _ref.deployer, feeManager = _ref.feeManager, _context.next = 3, 
        generateRegisteredMockFees({
          deployer: deployer,
          feeManager: feeManager
        });

       case 3:
        return fees = _context.sent, feeManagerSettingsData = [ ethers.utils.randomBytes(10), "0x", ethers.utils.randomBytes(2) ], 
        _context.next = 7, encodeArgs([ "address[]", "bytes[]" ], [ Object.values(fees), feeManagerSettingsData ]);

       case 7:
        return _context.abrupt("return", _context.sent);

       case 8:
       case "end":
        return _context.stop();
      }
    }), _callee);
  })))).apply(this, arguments);
}

function generateRegisteredMockFees(_x2) {
  return _generateRegisteredMockFees.apply(this, arguments);
}

function _generateRegisteredMockFees() {
  return (_generateRegisteredMockFees = _asyncToGenerator(regeneratorRuntime.mark((function _callee2(_ref2) {
    var deployer, feeManager, mockContinuousFee1, mockContinuousFee2, mockPostBuySharesFee;
    return regeneratorRuntime.wrap((function(_context2) {
      for (;;) switch (_context2.prev = _context2.next) {
       case 0:
        return deployer = _ref2.deployer, feeManager = _ref2.feeManager, _context2.next = 3, 
        protocol.IFee.mock(deployer);

       case 3:
        return mockContinuousFee1 = _context2.sent, _context2.next = 6, protocol.IFee.mock(deployer);

       case 6:
        return mockContinuousFee2 = _context2.sent, _context2.next = 9, protocol.IFee.mock(deployer);

       case 9:
        return mockPostBuySharesFee = _context2.sent, _context2.next = 12, Promise.all([ mockContinuousFee1.identifier.returns("MOCK_CONTINUOUS_1"), mockContinuousFee1.settle.returns(exports.feeSettlementTypes.None, ethers.constants.AddressZero, 0), mockContinuousFee1.payout.returns(!1), mockContinuousFee1.addFundSettings.returns(void 0), mockContinuousFee1.activateForFund.returns(void 0), mockContinuousFee1.implementedHooks.returns([ exports.feeHooks.Continuous, exports.feeHooks.PreBuyShares, exports.feeHooks.PreRedeemShares ]), mockContinuousFee2.identifier.returns("MOCK_CONTINUOUS_2"), mockContinuousFee2.settle.returns(exports.feeSettlementTypes.None, ethers.constants.AddressZero, 0), mockContinuousFee2.payout.returns(!1), mockContinuousFee2.addFundSettings.returns(void 0), mockContinuousFee2.activateForFund.returns(void 0), mockContinuousFee2.implementedHooks.returns([ exports.feeHooks.Continuous, exports.feeHooks.PreBuyShares, exports.feeHooks.PreRedeemShares ]), mockPostBuySharesFee.identifier.returns("MOCK_POST_BUY_SHARES"), mockPostBuySharesFee.settle.returns(exports.feeSettlementTypes.None, ethers.constants.AddressZero, 0), mockPostBuySharesFee.payout.returns(!1), mockPostBuySharesFee.addFundSettings.returns(void 0), mockPostBuySharesFee.activateForFund.returns(void 0), mockPostBuySharesFee.implementedHooks.returns([ exports.feeHooks.PostBuyShares ]) ]);

       case 12:
        return _context2.next = 14, feeManager.registerFees([ mockContinuousFee1, mockContinuousFee2, mockPostBuySharesFee ]);

       case 14:
        return _context2.abrupt("return", {
          mockContinuousFee1: mockContinuousFee1,
          mockContinuousFee2: mockContinuousFee2,
          mockPostBuySharesFee: mockPostBuySharesFee
        });

       case 15:
       case "end":
        return _context2.stop();
      }
    }), _callee2);
  })))).apply(this, arguments);
}

function settlePreBuySharesArgs(_ref3) {
  var _ref3$buyer = _ref3.buyer, buyer = void 0 === _ref3$buyer ? crestproject.randomAddress() : _ref3$buyer, _ref3$investmentAmoun = _ref3.investmentAmount, investmentAmount = void 0 === _ref3$investmentAmoun ? ethers.utils.parseEther("1") : _ref3$investmentAmoun, _ref3$minSharesQuanti = _ref3.minSharesQuantity, minSharesQuantity = void 0 === _ref3$minSharesQuanti ? ethers.utils.parseEther("1") : _ref3$minSharesQuanti, _ref3$gav = _ref3.gav;
  return encodeArgs([ "address", "uint256", "uint256", "uint256" ], [ buyer, investmentAmount, minSharesQuantity, void 0 === _ref3$gav ? 0 : _ref3$gav ]);
}

function settlePostBuySharesArgs(_ref4) {
  var _ref4$buyer = _ref4.buyer, buyer = void 0 === _ref4$buyer ? crestproject.randomAddress() : _ref4$buyer, _ref4$investmentAmoun = _ref4.investmentAmount, investmentAmount = void 0 === _ref4$investmentAmoun ? ethers.utils.parseEther("1") : _ref4$investmentAmoun, _ref4$sharesBought = _ref4.sharesBought;
  return encodeArgs([ "address", "uint256", "uint256" ], [ buyer, investmentAmount, void 0 === _ref4$sharesBought ? ethers.utils.parseEther("1") : _ref4$sharesBought ]);
}

function sharesDueWithInflation(_ref5) {
  var rawSharesDue = _ref5.rawSharesDue, sharesSupply = _ref5.sharesSupply;
  return rawSharesDue == ethers.BigNumber.from(0) || sharesSupply == ethers.BigNumber.from(0) ? 0 : rawSharesDue.mul(sharesSupply).div(sharesSupply.sub(rawSharesDue));
}

!function(feeHooks) {
  feeHooks[feeHooks.Continuous = 0] = "Continuous", feeHooks[feeHooks.PreBuyShares = 1] = "PreBuyShares", 
  feeHooks[feeHooks.PostBuyShares = 2] = "PostBuyShares", feeHooks[feeHooks.PreRedeemShares = 3] = "PreRedeemShares";
}(exports.feeHooks || (exports.feeHooks = {})), function(feeManagerActionIds) {
  feeManagerActionIds[feeManagerActionIds.SettleContinuousFees = 0] = "SettleContinuousFees";
}(exports.feeManagerActionIds || (exports.feeManagerActionIds = {})), function(feeSettlementTypes) {
  feeSettlementTypes[feeSettlementTypes.None = 0] = "None", feeSettlementTypes[feeSettlementTypes.Direct = 1] = "Direct", 
  feeSettlementTypes[feeSettlementTypes.Mint = 2] = "Mint", feeSettlementTypes[feeSettlementTypes.MintSharesOutstanding = 3] = "MintSharesOutstanding", 
  feeSettlementTypes[feeSettlementTypes.BurnSharesOutstanding = 4] = "BurnSharesOutstanding";
}(exports.feeSettlementTypes || (exports.feeSettlementTypes = {}));

var settleContinuousFeesFragment = ethers.utils.FunctionFragment.fromString("settleContinuousFees(address,bytes)"), settleContinuousFeesSelector = sighash(settleContinuousFeesFragment);

function entranceRateFeeConfigArgs(_x) {
  return _entranceRateFeeConfigArgs.apply(this, arguments);
}

function _entranceRateFeeConfigArgs() {
  return (_entranceRateFeeConfigArgs = _asyncToGenerator(regeneratorRuntime.mark((function _callee(rate) {
    return regeneratorRuntime.wrap((function(_context) {
      for (;;) switch (_context.prev = _context.next) {
       case 0:
        return _context.abrupt("return", encodeArgs([ "uint256" ], [ rate ]));

       case 1:
       case "end":
        return _context.stop();
      }
    }), _callee);
  })))).apply(this, arguments);
}

function entranceRateFeeSharesDue(_ref) {
  var rate = _ref.rate, sharesBought = _ref.sharesBought;
  return ethers.BigNumber.from(sharesBought).mul(rate).div(ethers.utils.parseEther("1"));
}

function managementFeeConfigArgs(_x) {
  return _managementFeeConfigArgs.apply(this, arguments);
}

function _managementFeeConfigArgs() {
  return (_managementFeeConfigArgs = _asyncToGenerator(regeneratorRuntime.mark((function _callee(rate) {
    return regeneratorRuntime.wrap((function(_context) {
      for (;;) switch (_context.prev = _context.next) {
       case 0:
        return _context.abrupt("return", encodeArgs([ "uint256" ], [ rate ]));

       case 1:
       case "end":
        return _context.stop();
      }
    }), _callee);
  })))).apply(this, arguments);
}

function managementFeeSharesDue(_ref) {
  var rate = _ref.rate, sharesSupply = _ref.sharesSupply, secondsSinceLastSettled = _ref.secondsSinceLastSettled;
  return sharesDueWithInflation({
    rawSharesDue: ethers.BigNumber.from(sharesSupply).mul(rate).div(ethers.utils.parseEther("1")).mul(secondsSinceLastSettled).div(31536e3),
    sharesSupply: sharesSupply
  });
}

function performanceFeeConfigArgs(_x) {
  return _performanceFeeConfigArgs.apply(this, arguments);
}

function _performanceFeeConfigArgs() {
  return (_performanceFeeConfigArgs = _asyncToGenerator(regeneratorRuntime.mark((function _callee(_ref) {
    var rate, period;
    return regeneratorRuntime.wrap((function(_context) {
      for (;;) switch (_context.prev = _context.next) {
       case 0:
        return rate = _ref.rate, period = _ref.period, _context.abrupt("return", encodeArgs([ "uint256", "uint256" ], [ rate, period ]));

       case 2:
       case "end":
        return _context.stop();
      }
    }), _callee);
  })))).apply(this, arguments);
}

function performanceFeeSharesDue(_ref2) {
  var rate = _ref2.rate, totalSharesSupply = _ref2.totalSharesSupply, sharesOutstanding = _ref2.sharesOutstanding, gav = _ref2.gav, highWaterMark = _ref2.highWaterMark, prevSharePrice = _ref2.prevSharePrice, prevAggregateValueDue = _ref2.prevAggregateValueDue, _ref2$denominationAss = _ref2.denominationAssetDecimals, denominationAssetDecimals = void 0 === _ref2$denominationAss ? 18 : _ref2$denominationAss, _ref2$feeHook = _ref2.feeHook, feeHook = void 0 === _ref2$feeHook ? exports.feeHooks.Continuous : _ref2$feeHook, settlementInfo = _ref2.settlementInfo, rateDivisor = ethers.utils.parseEther("1"), shareUnit = ethers.utils.parseEther("1"), netSharesSupply = ethers.BigNumber.from(totalSharesSupply).sub(sharesOutstanding), sharePriceWithoutPerformance = ethers.BigNumber.from(gav).mul(shareUnit).div(netSharesSupply), superHWMValueSinceLastSettled = bigNumberMax([ highWaterMark, sharePriceWithoutPerformance ]).sub(bigNumberMax([ highWaterMark, prevSharePrice ])).mul(netSharesSupply).div(shareUnit), nextAggregateValueDue = bigNumberMax([ 0, superHWMValueSinceLastSettled.mul(rate).div(rateDivisor).add(prevAggregateValueDue) ]), sharesDueForAggregateValueDue = sharesDueWithInflation({
    rawSharesDue: nextAggregateValueDue.mul(netSharesSupply).div(gav),
    sharesSupply: netSharesSupply
  }), sharesDue = ethers.BigNumber.from(sharesDueForAggregateValueDue).sub(sharesOutstanding), nextSharePrice = ethers.BigNumber.from(0);
  if (feeHook == exports.feeHooks.Continuous) nextSharePrice = sharePriceWithoutPerformance; else {
    var sharesSupplyWithSharesDue = sharesDue.add(totalSharesSupply), denominationAssetUnit = ethers.BigNumber.from(10).pow(denominationAssetDecimals), nextNetSharesSupply = ethers.BigNumber.from(0), nextGav = ethers.BigNumber.from(0);
    if (feeHook == exports.feeHooks.PreBuyShares) {
      var gavIncrease = settlementInfo.buySharesInvestmentAmount;
      nextGav = ethers.BigNumber.from(gav).add(gavIncrease);
      var sharesIncrease = ethers.BigNumber.from(gavIncrease).mul(denominationAssetUnit).mul(sharesSupplyWithSharesDue).div(gav).div(shareUnit);
      nextNetSharesSupply = netSharesSupply.add(sharesIncrease);
    } else {
      if (feeHook != exports.feeHooks.PreRedeemShares) throw "No valid feeHook passed";
      var sharesDecrease = settlementInfo.redeemSharesSharesAmount;
      nextNetSharesSupply = netSharesSupply.sub(sharesDecrease);
      var gavDecrease = ethers.BigNumber.from(sharesDecrease).mul(gav).mul(shareUnit).div(sharesSupplyWithSharesDue).div(denominationAssetUnit);
      nextGav = ethers.BigNumber.from(gav).sub(gavDecrease);
    }
    nextSharePrice = nextGav.mul(shareUnit).div(nextNetSharesSupply);
  }
  return {
    sharesDue: sharesDue,
    nextAggregateValueDue: nextAggregateValueDue,
    nextSharePrice: nextSharePrice
  };
}

!function(integrationManagerActionIds) {
  integrationManagerActionIds[integrationManagerActionIds.CallOnIntegration = 0] = "CallOnIntegration";
}(exports.integrationManagerActionIds || (exports.integrationManagerActionIds = {})), 
function(spendAssetsHandleTypes) {
  spendAssetsHandleTypes[spendAssetsHandleTypes.None = 0] = "None", spendAssetsHandleTypes[spendAssetsHandleTypes.Approve = 1] = "Approve", 
  spendAssetsHandleTypes[spendAssetsHandleTypes.Transfer = 2] = "Transfer";
}(exports.spendAssetsHandleTypes || (exports.spendAssetsHandleTypes = {}));

var callOnIntegrationFragment = ethers.utils.FunctionFragment.fromString("callOnIntegration(address,bytes)"), addTrackedAssetsFragment = ethers.utils.FunctionFragment.fromString("addTrackedAssets(address,bytes,bytes)"), lendFragment = ethers.utils.FunctionFragment.fromString("lend(address,bytes,bytes)"), redeemFragment = ethers.utils.FunctionFragment.fromString("redeem(address,bytes,bytes)"), takeOrderFragment = ethers.utils.FunctionFragment.fromString("takeOrder(address,bytes,bytes)"), callOnIntegrationSelector = sighash(callOnIntegrationFragment), addTrackedAssetsSelector = sighash(addTrackedAssetsFragment), takeOrderSelector = sighash(takeOrderFragment), redeemSelector = sighash(redeemFragment), lendSelector = sighash(lendFragment);

function assetTransferArgs(_x) {
  return _assetTransferArgs.apply(this, arguments);
}

function _assetTransferArgs() {
  return (_assetTransferArgs = _asyncToGenerator(regeneratorRuntime.mark((function _callee(_ref) {
    var adapter, selector, encodedCallArgs, _yield$adapter$parseA, spendAssets_, spendAssetAmounts_, incomingAssets_;
    return regeneratorRuntime.wrap((function(_context) {
      for (;;) switch (_context.prev = _context.next) {
       case 0:
        return adapter = _ref.adapter, selector = _ref.selector, encodedCallArgs = _ref.encodedCallArgs, 
        _context.next = 3, adapter.parseAssetsForMethod(selector, encodedCallArgs);

       case 3:
        return _yield$adapter$parseA = _context.sent, spendAssets_ = _yield$adapter$parseA.spendAssets_, 
        spendAssetAmounts_ = _yield$adapter$parseA.spendAssetAmounts_, incomingAssets_ = _yield$adapter$parseA.incomingAssets_, 
        _context.abrupt("return", encodeArgs([ "address[]", "uint[]", "address[]" ], [ spendAssets_, spendAssetAmounts_, incomingAssets_ ]));

       case 8:
       case "end":
        return _context.stop();
      }
    }), _callee);
  })))).apply(this, arguments);
}

function callOnIntegrationArgs(_ref2) {
  return encodeArgs([ "address", "bytes4", "bytes" ], [ _ref2.adapter, _ref2.selector, _ref2.encodedCallArgs ]);
}

function chaiLendArgs(_x) {
  return _chaiLendArgs.apply(this, arguments);
}

function _chaiLendArgs() {
  return (_chaiLendArgs = _asyncToGenerator(regeneratorRuntime.mark((function _callee(_ref) {
    var outgoingDaiAmount, expectedIncomingChaiAmount;
    return regeneratorRuntime.wrap((function(_context) {
      for (;;) switch (_context.prev = _context.next) {
       case 0:
        return outgoingDaiAmount = _ref.outgoingDaiAmount, expectedIncomingChaiAmount = _ref.expectedIncomingChaiAmount, 
        _context.abrupt("return", encodeArgs([ "uint256", "uint256" ], [ outgoingDaiAmount, expectedIncomingChaiAmount ]));

       case 2:
       case "end":
        return _context.stop();
      }
    }), _callee);
  })))).apply(this, arguments);
}

function chaiRedeemArgs(_x2) {
  return _chaiRedeemArgs.apply(this, arguments);
}

function _chaiRedeemArgs() {
  return (_chaiRedeemArgs = _asyncToGenerator(regeneratorRuntime.mark((function _callee2(_ref2) {
    var outgoingChaiAmount, expectedIncomingDaiAmount;
    return regeneratorRuntime.wrap((function(_context2) {
      for (;;) switch (_context2.prev = _context2.next) {
       case 0:
        return outgoingChaiAmount = _ref2.outgoingChaiAmount, expectedIncomingDaiAmount = _ref2.expectedIncomingDaiAmount, 
        _context2.abrupt("return", encodeArgs([ "uint256", "uint256" ], [ outgoingChaiAmount, expectedIncomingDaiAmount ]));

       case 2:
       case "end":
        return _context2.stop();
      }
    }), _callee2);
  })))).apply(this, arguments);
}

function chaiLend(_x3) {
  return _chaiLend.apply(this, arguments);
}

function _chaiLend() {
  return (_chaiLend = _asyncToGenerator(regeneratorRuntime.mark((function _callee3(_ref3) {
    var comptrollerProxy, vaultProxy, integrationManager, fundOwner, chaiAdapter, dai, _ref3$daiAmount, daiAmount, _ref3$minChaiAmount, minChaiAmount, _ref3$seedFund, lendArgs, callArgs, lendTx;
    return regeneratorRuntime.wrap((function(_context3) {
      for (;;) switch (_context3.prev = _context3.next) {
       case 0:
        if (comptrollerProxy = _ref3.comptrollerProxy, vaultProxy = _ref3.vaultProxy, integrationManager = _ref3.integrationManager, 
        fundOwner = _ref3.fundOwner, chaiAdapter = _ref3.chaiAdapter, dai = _ref3.dai, _ref3$daiAmount = _ref3.daiAmount, 
        daiAmount = void 0 === _ref3$daiAmount ? ethers.utils.parseEther("1") : _ref3$daiAmount, 
        _ref3$minChaiAmount = _ref3.minChaiAmount, minChaiAmount = void 0 === _ref3$minChaiAmount ? ethers.utils.parseEther("1") : _ref3$minChaiAmount, 
        _ref3$seedFund = _ref3.seedFund, !(void 0 !== _ref3$seedFund && _ref3$seedFund)) {
          _context3.next = 4;
          break;
        }
        return _context3.next = 4, dai.transfer(vaultProxy, daiAmount);

       case 4:
        return _context3.next = 6, chaiLendArgs({
          outgoingDaiAmount: daiAmount,
          expectedIncomingChaiAmount: minChaiAmount
        });

       case 6:
        return lendArgs = _context3.sent, _context3.next = 9, callOnIntegrationArgs({
          adapter: chaiAdapter,
          selector: lendSelector,
          encodedCallArgs: lendArgs
        });

       case 9:
        return callArgs = _context3.sent, lendTx = comptrollerProxy.connect(fundOwner).callOnExtension(integrationManager, exports.integrationManagerActionIds.CallOnIntegration, callArgs), 
        _context3.next = 13, expect(lendTx).resolves.toBeReceipt();

       case 13:
        return _context3.abrupt("return", lendTx);

       case 14:
       case "end":
        return _context3.stop();
      }
    }), _callee3);
  })))).apply(this, arguments);
}

function chaiRedeem(_x4) {
  return _chaiRedeem.apply(this, arguments);
}

function _chaiRedeem() {
  return (_chaiRedeem = _asyncToGenerator(regeneratorRuntime.mark((function _callee4(_ref4) {
    var comptrollerProxy, vaultProxy, integrationManager, fundOwner, chaiAdapter, chai, _ref4$chaiAmount, chaiAmount, _ref4$minDaiAmount, minDaiAmount, _ref4$seedFund, redeemArgs, callArgs, redeemTx;
    return regeneratorRuntime.wrap((function(_context4) {
      for (;;) switch (_context4.prev = _context4.next) {
       case 0:
        if (comptrollerProxy = _ref4.comptrollerProxy, vaultProxy = _ref4.vaultProxy, integrationManager = _ref4.integrationManager, 
        fundOwner = _ref4.fundOwner, chaiAdapter = _ref4.chaiAdapter, chai = _ref4.chai, 
        _ref4$chaiAmount = _ref4.chaiAmount, chaiAmount = void 0 === _ref4$chaiAmount ? ethers.utils.parseEther("1") : _ref4$chaiAmount, 
        _ref4$minDaiAmount = _ref4.minDaiAmount, minDaiAmount = void 0 === _ref4$minDaiAmount ? ethers.utils.parseEther("1") : _ref4$minDaiAmount, 
        _ref4$seedFund = _ref4.seedFund, !(void 0 !== _ref4$seedFund && _ref4$seedFund)) {
          _context4.next = 4;
          break;
        }
        return _context4.next = 4, chai.transfer(vaultProxy, chaiAmount);

       case 4:
        return _context4.next = 6, chaiRedeemArgs({
          outgoingChaiAmount: chaiAmount,
          expectedIncomingDaiAmount: minDaiAmount
        });

       case 6:
        return redeemArgs = _context4.sent, _context4.next = 9, callOnIntegrationArgs({
          adapter: chaiAdapter,
          selector: redeemSelector,
          encodedCallArgs: redeemArgs
        });

       case 9:
        return callArgs = _context4.sent, redeemTx = comptrollerProxy.connect(fundOwner).callOnExtension(integrationManager, exports.integrationManagerActionIds.CallOnIntegration, callArgs), 
        _context4.next = 13, expect(redeemTx).resolves.toBeReceipt();

       case 13:
        return _context4.abrupt("return", redeemTx);

       case 14:
       case "end":
        return _context4.stop();
      }
    }), _callee4);
  })))).apply(this, arguments);
}

function engineTakeOrderArgs(_x5, _x6) {
  return _engineTakeOrderArgs.apply(this, arguments);
}

function _engineTakeOrderArgs() {
  return (_engineTakeOrderArgs = _asyncToGenerator(regeneratorRuntime.mark((function _callee5(minNativeAssetAmount, mlnTokenAmount) {
    return regeneratorRuntime.wrap((function(_context5) {
      for (;;) switch (_context5.prev = _context5.next) {
       case 0:
        return _context5.abrupt("return", encodeArgs([ "uint256", "uint256" ], [ minNativeAssetAmount, mlnTokenAmount ]));

       case 1:
       case "end":
        return _context5.stop();
      }
    }), _callee5);
  })))).apply(this, arguments);
}

function engineAdapterTakeOrderArgs(_x) {
  return _engineAdapterTakeOrderArgs.apply(this, arguments);
}

function _engineAdapterTakeOrderArgs() {
  return (_engineAdapterTakeOrderArgs = _asyncToGenerator(regeneratorRuntime.mark((function _callee(_ref) {
    var minWethAmount, mlnAmount;
    return regeneratorRuntime.wrap((function(_context) {
      for (;;) switch (_context.prev = _context.next) {
       case 0:
        return minWethAmount = _ref.minWethAmount, mlnAmount = _ref.mlnAmount, _context.abrupt("return", encodeArgs([ "uint256", "uint256" ], [ minWethAmount, mlnAmount ]));

       case 2:
       case "end":
        return _context.stop();
      }
    }), _callee);
  })))).apply(this, arguments);
}

function engineAdapterTakeOrder(_x2) {
  return _engineAdapterTakeOrder.apply(this, arguments);
}

function _engineAdapterTakeOrder() {
  return (_engineAdapterTakeOrder = _asyncToGenerator(regeneratorRuntime.mark((function _callee2(_ref2) {
    var comptrollerProxy, vaultProxy, integrationManager, fundOwner, engineAdapter, mln, _ref2$mlnAmount, mlnAmount, _ref2$minWethAmount, minWethAmount, _ref2$seedFund, takeOrderArgs, callArgs, takeOrderTx;
    return regeneratorRuntime.wrap((function(_context2) {
      for (;;) switch (_context2.prev = _context2.next) {
       case 0:
        if (comptrollerProxy = _ref2.comptrollerProxy, vaultProxy = _ref2.vaultProxy, integrationManager = _ref2.integrationManager, 
        fundOwner = _ref2.fundOwner, engineAdapter = _ref2.engineAdapter, mln = _ref2.mln, 
        _ref2$mlnAmount = _ref2.mlnAmount, mlnAmount = void 0 === _ref2$mlnAmount ? ethers.utils.parseEther("1") : _ref2$mlnAmount, 
        _ref2$minWethAmount = _ref2.minWethAmount, minWethAmount = void 0 === _ref2$minWethAmount ? ethers.utils.parseEther("1") : _ref2$minWethAmount, 
        _ref2$seedFund = _ref2.seedFund, !(void 0 !== _ref2$seedFund && _ref2$seedFund)) {
          _context2.next = 4;
          break;
        }
        return _context2.next = 4, mln.transfer(vaultProxy, mlnAmount);

       case 4:
        return _context2.next = 6, engineAdapterTakeOrderArgs({
          minWethAmount: minWethAmount,
          mlnAmount: mlnAmount
        });

       case 6:
        return takeOrderArgs = _context2.sent, _context2.next = 9, callOnIntegrationArgs({
          adapter: engineAdapter,
          selector: takeOrderSelector,
          encodedCallArgs: takeOrderArgs
        });

       case 9:
        return callArgs = _context2.sent, takeOrderTx = comptrollerProxy.connect(fundOwner).callOnExtension(integrationManager, exports.integrationManagerActionIds.CallOnIntegration, callArgs), 
        _context2.next = 13, expect(takeOrderTx).resolves.toBeReceipt();

       case 13:
        return _context2.abrupt("return", takeOrderTx);

       case 14:
       case "end":
        return _context2.stop();
      }
    }), _callee2);
  })))).apply(this, arguments);
}

function _taggedTemplateLiteral(strings, raw) {
  return raw || (raw = strings.slice(0)), Object.freeze(Object.defineProperties(strings, {
    raw: {
      value: Object.freeze(raw)
    }
  }));
}

function _templateObject() {
  var data = _taggedTemplateLiteral([ "\n  function getExpectedRate(address src, address dest, uint256 srcQty) view returns (uint256 expectedRate, uint256 worstRate)\n" ]);
  return _templateObject = function() {
    return data;
  }, data;
}

var IKyberNetworkProxy = crestproject.contract()(_templateObject());

function kyberTakeOrderArgs(_x) {
  return _kyberTakeOrderArgs.apply(this, arguments);
}

function _kyberTakeOrderArgs() {
  return (_kyberTakeOrderArgs = _asyncToGenerator(regeneratorRuntime.mark((function _callee(_ref) {
    var incomingAsset, minIncomingAssetAmount, outgoingAsset, outgoingAssetAmount;
    return regeneratorRuntime.wrap((function(_context) {
      for (;;) switch (_context.prev = _context.next) {
       case 0:
        return incomingAsset = _ref.incomingAsset, minIncomingAssetAmount = _ref.minIncomingAssetAmount, 
        outgoingAsset = _ref.outgoingAsset, outgoingAssetAmount = _ref.outgoingAssetAmount, 
        _context.abrupt("return", encodeArgs([ "address", "uint256", "address", "uint256" ], [ incomingAsset, minIncomingAssetAmount, outgoingAsset, outgoingAssetAmount ]));

       case 2:
       case "end":
        return _context.stop();
      }
    }), _callee);
  })))).apply(this, arguments);
}

function kyberTakeOrder(_x2) {
  return _kyberTakeOrder.apply(this, arguments);
}

function _kyberTakeOrder() {
  return (_kyberTakeOrder = _asyncToGenerator(regeneratorRuntime.mark((function _callee2(_ref2) {
    var comptrollerProxy, vaultProxy, integrationManager, fundOwner, kyberAdapter, outgoingAsset, _ref2$outgoingAssetAm, outgoingAssetAmount, incomingAsset, _ref2$minIncomingAsse, minIncomingAssetAmount, _ref2$seedFund, takeOrderArgs, callArgs, takeOrderTx;
    return regeneratorRuntime.wrap((function(_context2) {
      for (;;) switch (_context2.prev = _context2.next) {
       case 0:
        if (comptrollerProxy = _ref2.comptrollerProxy, vaultProxy = _ref2.vaultProxy, integrationManager = _ref2.integrationManager, 
        fundOwner = _ref2.fundOwner, kyberAdapter = _ref2.kyberAdapter, outgoingAsset = _ref2.outgoingAsset, 
        _ref2$outgoingAssetAm = _ref2.outgoingAssetAmount, outgoingAssetAmount = void 0 === _ref2$outgoingAssetAm ? ethers.utils.parseEther("1") : _ref2$outgoingAssetAm, 
        incomingAsset = _ref2.incomingAsset, _ref2$minIncomingAsse = _ref2.minIncomingAssetAmount, 
        minIncomingAssetAmount = void 0 === _ref2$minIncomingAsse ? ethers.utils.parseEther("1") : _ref2$minIncomingAsse, 
        _ref2$seedFund = _ref2.seedFund, !(void 0 !== _ref2$seedFund && _ref2$seedFund)) {
          _context2.next = 4;
          break;
        }
        return _context2.next = 4, outgoingAsset.transfer(vaultProxy, outgoingAssetAmount);

       case 4:
        return _context2.next = 6, kyberTakeOrderArgs({
          incomingAsset: incomingAsset,
          minIncomingAssetAmount: minIncomingAssetAmount,
          outgoingAsset: outgoingAsset,
          outgoingAssetAmount: outgoingAssetAmount
        });

       case 6:
        return takeOrderArgs = _context2.sent, _context2.next = 9, callOnIntegrationArgs({
          adapter: kyberAdapter,
          selector: takeOrderSelector,
          encodedCallArgs: takeOrderArgs
        });

       case 9:
        return callArgs = _context2.sent, takeOrderTx = comptrollerProxy.connect(fundOwner).callOnExtension(integrationManager, exports.integrationManagerActionIds.CallOnIntegration, callArgs), 
        _context2.next = 13, expect(takeOrderTx).resolves.toBeReceipt();

       case 13:
        return _context2.abrupt("return", takeOrderTx);

       case 14:
       case "end":
        return _context2.stop();
      }
    }), _callee2);
  })))).apply(this, arguments);
}

var mockGenericSwapASelector = sighash(ethers.utils.FunctionFragment.fromString("swapA(address,bytes,bytes)")), mockGenericSwapBSelector = sighash(ethers.utils.FunctionFragment.fromString("swapB(address,bytes,bytes)")), mockGenericSwapCSelector = sighash(ethers.utils.FunctionFragment.fromString("swapC(address,bytes,bytes)"));

function mockGenericSwapArgs(_x) {
  return _mockGenericSwapArgs.apply(this, arguments);
}

function _mockGenericSwapArgs() {
  return (_mockGenericSwapArgs = _asyncToGenerator(regeneratorRuntime.mark((function _callee(_ref) {
    var spendAssets, spendAssetAmounts, incomingAssets, minIncomingAssetAmounts, incomingAssetAmounts;
    return regeneratorRuntime.wrap((function(_context) {
      for (;;) switch (_context.prev = _context.next) {
       case 0:
        return spendAssets = _ref.spendAssets, spendAssetAmounts = _ref.spendAssetAmounts, 
        incomingAssets = _ref.incomingAssets, minIncomingAssetAmounts = _ref.minIncomingAssetAmounts, 
        incomingAssetAmounts = _ref.incomingAssetAmounts, _context.abrupt("return", encodeArgs([ "address[]", "uint256[]", "address[]", "uint256[]", "uint256[]" ], [ spendAssets, spendAssetAmounts, incomingAssets, minIncomingAssetAmounts, incomingAssetAmounts ]));

       case 2:
       case "end":
        return _context.stop();
      }
    }), _callee);
  })))).apply(this, arguments);
}

function mockGenericSwap(_x2) {
  return _mockGenericSwap.apply(this, arguments);
}

function _mockGenericSwap() {
  return (_mockGenericSwap = _asyncToGenerator(regeneratorRuntime.mark((function _callee2(_ref2) {
    var comptrollerProxy, vaultProxy, integrationManager, fundOwner, mockGenericAdapter, _ref2$selector, selector, _ref2$spendAssets, spendAssets, _ref2$spendAssetAmoun, spendAssetAmounts, _ref2$incomingAssets, incomingAssets, _ref2$minIncomingAsse, minIncomingAssetAmounts, _ref2$actualIncomingA, actualIncomingAssetAmounts, _ref2$seedFund, key, swapArgs, callArgs, swapTx;
    return regeneratorRuntime.wrap((function(_context2) {
      for (;;) switch (_context2.prev = _context2.next) {
       case 0:
        if (comptrollerProxy = _ref2.comptrollerProxy, vaultProxy = _ref2.vaultProxy, integrationManager = _ref2.integrationManager, 
        fundOwner = _ref2.fundOwner, mockGenericAdapter = _ref2.mockGenericAdapter, _ref2$selector = _ref2.selector, 
        selector = void 0 === _ref2$selector ? mockGenericSwapASelector : _ref2$selector, 
        _ref2$spendAssets = _ref2.spendAssets, spendAssets = void 0 === _ref2$spendAssets ? [] : _ref2$spendAssets, 
        _ref2$spendAssetAmoun = _ref2.spendAssetAmounts, spendAssetAmounts = void 0 === _ref2$spendAssetAmoun ? [] : _ref2$spendAssetAmoun, 
        _ref2$incomingAssets = _ref2.incomingAssets, incomingAssets = void 0 === _ref2$incomingAssets ? [] : _ref2$incomingAssets, 
        _ref2$minIncomingAsse = _ref2.minIncomingAssetAmounts, minIncomingAssetAmounts = void 0 === _ref2$minIncomingAsse ? [] : _ref2$minIncomingAsse, 
        _ref2$actualIncomingA = _ref2.actualIncomingAssetAmounts, actualIncomingAssetAmounts = void 0 === _ref2$actualIncomingA ? [] : _ref2$actualIncomingA, 
        _ref2$seedFund = _ref2.seedFund, !(void 0 !== _ref2$seedFund && _ref2$seedFund)) {
          _context2.next = 9;
          break;
        }
        _context2.t0 = regeneratorRuntime.keys(spendAssets);

       case 3:
        if ((_context2.t1 = _context2.t0()).done) {
          _context2.next = 9;
          break;
        }
        return key = _context2.t1.value, _context2.next = 7, spendAssets[key].transfer(vaultProxy, spendAssetAmounts[key]);

       case 7:
        _context2.next = 3;
        break;

       case 9:
        return _context2.next = 11, mockGenericSwapArgs({
          spendAssets: spendAssets,
          spendAssetAmounts: spendAssetAmounts,
          incomingAssets: incomingAssets,
          minIncomingAssetAmounts: minIncomingAssetAmounts,
          incomingAssetAmounts: actualIncomingAssetAmounts
        });

       case 11:
        return swapArgs = _context2.sent, _context2.next = 14, callOnIntegrationArgs({
          adapter: mockGenericAdapter,
          selector: selector,
          encodedCallArgs: swapArgs
        });

       case 14:
        return callArgs = _context2.sent, swapTx = comptrollerProxy.connect(fundOwner).callOnExtension(integrationManager, exports.integrationManagerActionIds.CallOnIntegration, callArgs), 
        _context2.next = 18, expect(swapTx).resolves.toBeReceipt();

       case 18:
        return _context2.abrupt("return", swapTx);

       case 19:
       case "end":
        return _context2.stop();
      }
    }), _callee2);
  })))).apply(this, arguments);
}

function addTrackedAssetsArgs(_x) {
  return _addTrackedAssetsArgs.apply(this, arguments);
}

function _addTrackedAssetsArgs() {
  return (_addTrackedAssetsArgs = _asyncToGenerator(regeneratorRuntime.mark((function _callee(_ref) {
    var incomingAssets;
    return regeneratorRuntime.wrap((function(_context) {
      for (;;) switch (_context.prev = _context.next) {
       case 0:
        return incomingAssets = _ref.incomingAssets, _context.abrupt("return", encodeArgs([ "address[]" ], [ incomingAssets ]));

       case 2:
       case "end":
        return _context.stop();
      }
    }), _callee);
  })))).apply(this, arguments);
}

function addTrackedAssets(_x2) {
  return _addTrackedAssets.apply(this, arguments);
}

function _addTrackedAssets() {
  return (_addTrackedAssets = _asyncToGenerator(regeneratorRuntime.mark((function _callee2(_ref2) {
    var comptrollerProxy, integrationManager, fundOwner, trackedAssetsAdapter, incomingAssets, args, callArgs, addTrackedAssetsTx;
    return regeneratorRuntime.wrap((function(_context2) {
      for (;;) switch (_context2.prev = _context2.next) {
       case 0:
        return comptrollerProxy = _ref2.comptrollerProxy, integrationManager = _ref2.integrationManager, 
        fundOwner = _ref2.fundOwner, trackedAssetsAdapter = _ref2.trackedAssetsAdapter, 
        incomingAssets = _ref2.incomingAssets, _context2.next = 3, addTrackedAssetsArgs({
          incomingAssets: incomingAssets
        });

       case 3:
        return args = _context2.sent, _context2.next = 6, callOnIntegrationArgs({
          adapter: trackedAssetsAdapter,
          selector: addTrackedAssetsSelector,
          encodedCallArgs: args
        });

       case 6:
        return callArgs = _context2.sent, addTrackedAssetsTx = comptrollerProxy.connect(fundOwner).callOnExtension(integrationManager, exports.integrationManagerActionIds.CallOnIntegration, callArgs), 
        _context2.next = 10, expect(addTrackedAssetsTx).resolves.toBeReceipt();

       case 10:
        return _context2.abrupt("return", addTrackedAssetsTx);

       case 11:
       case "end":
        return _context2.stop();
      }
    }), _callee2);
  })))).apply(this, arguments);
}

function zeroExV2TakeOrder(_x) {
  return _zeroExV2TakeOrder.apply(this, arguments);
}

function _zeroExV2TakeOrder() {
  return (_zeroExV2TakeOrder = _asyncToGenerator(regeneratorRuntime.mark((function _callee(_ref) {
    var comptrollerProxy, integrationManager, fundOwner, zeroExV2Adapter, signedOrder, takerAssetFillAmount, takeOrderArgs, callArgs, takeOrderTx;
    return regeneratorRuntime.wrap((function(_context) {
      for (;;) switch (_context.prev = _context.next) {
       case 0:
        return comptrollerProxy = _ref.comptrollerProxy, integrationManager = _ref.integrationManager, 
        fundOwner = _ref.fundOwner, zeroExV2Adapter = _ref.zeroExV2Adapter, signedOrder = _ref.signedOrder, 
        takerAssetFillAmount = _ref.takerAssetFillAmount, _context.next = 3, zeroExV2TakeOrderArgs(signedOrder, takerAssetFillAmount);

       case 3:
        return takeOrderArgs = _context.sent, _context.next = 6, callOnIntegrationArgs({
          adapter: zeroExV2Adapter,
          selector: takeOrderSelector,
          encodedCallArgs: takeOrderArgs
        });

       case 6:
        return callArgs = _context.sent, takeOrderTx = comptrollerProxy.connect(fundOwner).callOnExtension(integrationManager, exports.integrationManagerActionIds.CallOnIntegration, callArgs), 
        _context.next = 10, expect(takeOrderTx).resolves.toBeReceipt();

       case 10:
        return _context.abrupt("return", takeOrderTx);

       case 11:
       case "end":
        return _context.stop();
      }
    }), _callee);
  })))).apply(this, arguments);
}

function generatePolicyManagerConfigWithMockPolicies(_x) {
  return _generatePolicyManagerConfigWithMockPolicies.apply(this, arguments);
}

function _generatePolicyManagerConfigWithMockPolicies() {
  return (_generatePolicyManagerConfigWithMockPolicies = _asyncToGenerator(regeneratorRuntime.mark((function _callee(_ref) {
    var deployer, policyManager, policies, policiesSettingsData;
    return regeneratorRuntime.wrap((function(_context) {
      for (;;) switch (_context.prev = _context.next) {
       case 0:
        return deployer = _ref.deployer, policyManager = _ref.policyManager, _context.next = 3, 
        generateRegisteredMockPolicies({
          deployer: deployer,
          policyManager: policyManager
        });

       case 3:
        return policies = _context.sent, policiesSettingsData = [ ethers.utils.randomBytes(10), ethers.constants.HashZero, ethers.constants.HashZero, ethers.utils.randomBytes(2) ], 
        _context.abrupt("return", encodeArgs([ "address[]", "bytes[]" ], [ Object.values(policies), policiesSettingsData ]));

       case 6:
       case "end":
        return _context.stop();
      }
    }), _callee);
  })))).apply(this, arguments);
}

function generateRegisteredMockPolicies(_x2) {
  return _generateRegisteredMockPolicies.apply(this, arguments);
}

function _generateRegisteredMockPolicies() {
  return (_generateRegisteredMockPolicies = _asyncToGenerator(regeneratorRuntime.mark((function _callee2(_ref2) {
    var deployer, policyManager, mockPreBuySharesPolicy, mockPostBuySharesPolicy, mockPreCoIPolicy, mockPostCoIPolicy;
    return regeneratorRuntime.wrap((function(_context2) {
      for (;;) switch (_context2.prev = _context2.next) {
       case 0:
        return deployer = _ref2.deployer, policyManager = _ref2.policyManager, _context2.next = 3, 
        protocol.IPolicy.mock(deployer);

       case 3:
        return mockPreBuySharesPolicy = _context2.sent, _context2.next = 6, protocol.IPolicy.mock(deployer);

       case 6:
        return mockPostBuySharesPolicy = _context2.sent, _context2.next = 9, protocol.IPolicy.mock(deployer);

       case 9:
        return mockPreCoIPolicy = _context2.sent, _context2.next = 12, protocol.IPolicy.mock(deployer);

       case 12:
        return mockPostCoIPolicy = _context2.sent, _context2.next = 15, Promise.all([ mockPreBuySharesPolicy.identifier.returns("MOCK_PRE_BUY_SHARES"), mockPreBuySharesPolicy.addFundSettings.returns(void 0), mockPreBuySharesPolicy.activateForFund.returns(void 0), mockPreBuySharesPolicy.validateRule.returns(!0), mockPreBuySharesPolicy.implementedHooks.returns([ exports.policyHooks.PreBuyShares ]), mockPostBuySharesPolicy.identifier.returns("MOCK_POST_BUY_SHARES"), mockPostBuySharesPolicy.addFundSettings.returns(void 0), mockPostBuySharesPolicy.activateForFund.returns(void 0), mockPostBuySharesPolicy.validateRule.returns(!0), mockPostBuySharesPolicy.implementedHooks.returns([ exports.policyHooks.PostBuyShares ]), mockPreCoIPolicy.identifier.returns("MOCK_PRE_CALL_ON_INTEGRATION"), mockPreCoIPolicy.addFundSettings.returns(void 0), mockPreCoIPolicy.activateForFund.returns(void 0), mockPreCoIPolicy.validateRule.returns(!0), mockPreCoIPolicy.implementedHooks.returns([ exports.policyHooks.PreCallOnIntegration ]), mockPostCoIPolicy.identifier.returns("MOCK_POST_CALL_ON_INTEGRATION"), mockPostCoIPolicy.addFundSettings.returns(void 0), mockPostCoIPolicy.activateForFund.returns(void 0), mockPostCoIPolicy.validateRule.returns(!0), mockPostCoIPolicy.implementedHooks.returns([ exports.policyHooks.PostCallOnIntegration ]) ]);

       case 15:
        return _context2.next = 17, policyManager.registerPolicies([ mockPreBuySharesPolicy, mockPostBuySharesPolicy, mockPreCoIPolicy, mockPostCoIPolicy ]);

       case 17:
        return _context2.abrupt("return", {
          mockPreBuySharesPolicy: mockPreBuySharesPolicy,
          mockPostBuySharesPolicy: mockPostBuySharesPolicy,
          mockPreCoIPolicy: mockPreCoIPolicy,
          mockPostCoIPolicy: mockPostCoIPolicy
        });

       case 18:
       case "end":
        return _context2.stop();
      }
    }), _callee2);
  })))).apply(this, arguments);
}

function policyManagerConfigArgs(_x3, _x4) {
  return _policyManagerConfigArgs.apply(this, arguments);
}

function _policyManagerConfigArgs() {
  return (_policyManagerConfigArgs = _asyncToGenerator(regeneratorRuntime.mark((function _callee3(policies, settingsData) {
    return regeneratorRuntime.wrap((function(_context3) {
      for (;;) switch (_context3.prev = _context3.next) {
       case 0:
        return _context3.abrupt("return", encodeArgs([ "address[]", "bytes[]" ], [ policies, settingsData ]));

       case 1:
       case "end":
        return _context3.stop();
      }
    }), _callee3);
  })))).apply(this, arguments);
}

function validateRulePreBuySharesArgs(_x5) {
  return _validateRulePreBuySharesArgs.apply(this, arguments);
}

function _validateRulePreBuySharesArgs() {
  return (_validateRulePreBuySharesArgs = _asyncToGenerator(regeneratorRuntime.mark((function _callee4(_ref3) {
    var _ref3$buyer, buyer, _ref3$investmentAmoun, investmentAmount, _ref3$minSharesQuanti, minSharesQuantity, _ref3$gav, gav;
    return regeneratorRuntime.wrap((function(_context4) {
      for (;;) switch (_context4.prev = _context4.next) {
       case 0:
        return _ref3$buyer = _ref3.buyer, buyer = void 0 === _ref3$buyer ? crestproject.randomAddress() : _ref3$buyer, 
        _ref3$investmentAmoun = _ref3.investmentAmount, investmentAmount = void 0 === _ref3$investmentAmoun ? ethers.utils.parseEther("1") : _ref3$investmentAmoun, 
        _ref3$minSharesQuanti = _ref3.minSharesQuantity, minSharesQuantity = void 0 === _ref3$minSharesQuanti ? ethers.utils.parseEther("1") : _ref3$minSharesQuanti, 
        _ref3$gav = _ref3.gav, gav = void 0 === _ref3$gav ? 0 : _ref3$gav, _context4.abrupt("return", encodeArgs([ "address", "uint256", "uint256", "uint256" ], [ buyer, investmentAmount, minSharesQuantity, gav ]));

       case 2:
       case "end":
        return _context4.stop();
      }
    }), _callee4);
  })))).apply(this, arguments);
}

function validateRulePostBuySharesArgs(buyer, investmentAmount, sharesBought) {
  return encodeArgs([ "address", "uint256", "uint256" ], [ buyer, investmentAmount, sharesBought ]);
}

function validateRulePreCoIArgs(adapter, selector) {
  return encodeArgs([ "address", "bytes4" ], [ adapter, selector ]);
}

function validateRulePostCoIArgs(adapter, selector, incomingAssets, incomingAssetAmounts, outgoingAssets, outgoingAssetAmounts) {
  return encodeArgs([ "address", "bytes4", "address[]", "uint256[]", "address[]", "uint256[]" ], [ adapter, selector, incomingAssets, incomingAssetAmounts, outgoingAssets, outgoingAssetAmounts ]);
}

function adapterBlacklistArgs(_x6) {
  return _adapterBlacklistArgs.apply(this, arguments);
}

function _adapterBlacklistArgs() {
  return (_adapterBlacklistArgs = _asyncToGenerator(regeneratorRuntime.mark((function _callee5(adapters) {
    return regeneratorRuntime.wrap((function(_context5) {
      for (;;) switch (_context5.prev = _context5.next) {
       case 0:
        return _context5.abrupt("return", encodeArgs([ "address[]" ], [ adapters ]));

       case 1:
       case "end":
        return _context5.stop();
      }
    }), _callee5);
  })))).apply(this, arguments);
}

function adapterWhitelistArgs(_x7) {
  return _adapterWhitelistArgs.apply(this, arguments);
}

function _adapterWhitelistArgs() {
  return (_adapterWhitelistArgs = _asyncToGenerator(regeneratorRuntime.mark((function _callee6(adapters) {
    return regeneratorRuntime.wrap((function(_context6) {
      for (;;) switch (_context6.prev = _context6.next) {
       case 0:
        return _context6.abrupt("return", encodeArgs([ "address[]" ], [ adapters ]));

       case 1:
       case "end":
        return _context6.stop();
      }
    }), _callee6);
  })))).apply(this, arguments);
}

function assetBlacklistArgs(_x8) {
  return _assetBlacklistArgs.apply(this, arguments);
}

function _assetBlacklistArgs() {
  return (_assetBlacklistArgs = _asyncToGenerator(regeneratorRuntime.mark((function _callee7(assets) {
    return regeneratorRuntime.wrap((function(_context7) {
      for (;;) switch (_context7.prev = _context7.next) {
       case 0:
        return _context7.abrupt("return", encodeArgs([ "address[]" ], [ assets ]));

       case 1:
       case "end":
        return _context7.stop();
      }
    }), _callee7);
  })))).apply(this, arguments);
}

function assetWhitelistArgs(_x9) {
  return _assetWhitelistArgs.apply(this, arguments);
}

function _assetWhitelistArgs() {
  return (_assetWhitelistArgs = _asyncToGenerator(regeneratorRuntime.mark((function _callee8(assets) {
    return regeneratorRuntime.wrap((function(_context8) {
      for (;;) switch (_context8.prev = _context8.next) {
       case 0:
        return _context8.abrupt("return", encodeArgs([ "address[]" ], [ assets ]));

       case 1:
       case "end":
        return _context8.stop();
      }
    }), _callee8);
  })))).apply(this, arguments);
}

function buySharesPriceFeedToleranceArgs(_x10) {
  return _buySharesPriceFeedToleranceArgs.apply(this, arguments);
}

function _buySharesPriceFeedToleranceArgs() {
  return (_buySharesPriceFeedToleranceArgs = _asyncToGenerator(regeneratorRuntime.mark((function _callee9(tolerance) {
    return regeneratorRuntime.wrap((function(_context9) {
      for (;;) switch (_context9.prev = _context9.next) {
       case 0:
        return _context9.abrupt("return", encodeArgs([ "uint256" ], [ tolerance ]));

       case 1:
       case "end":
        return _context9.stop();
      }
    }), _callee9);
  })))).apply(this, arguments);
}

function investorWhitelistArgs(_x11) {
  return _investorWhitelistArgs.apply(this, arguments);
}

function _investorWhitelistArgs() {
  return (_investorWhitelistArgs = _asyncToGenerator(regeneratorRuntime.mark((function _callee10(_ref4) {
    var _ref4$investorsToAdd, investorsToAdd, _ref4$investorsToRemo, investorsToRemove;
    return regeneratorRuntime.wrap((function(_context10) {
      for (;;) switch (_context10.prev = _context10.next) {
       case 0:
        return _ref4$investorsToAdd = _ref4.investorsToAdd, investorsToAdd = void 0 === _ref4$investorsToAdd ? [] : _ref4$investorsToAdd, 
        _ref4$investorsToRemo = _ref4.investorsToRemove, investorsToRemove = void 0 === _ref4$investorsToRemo ? [] : _ref4$investorsToRemo, 
        _context10.abrupt("return", encodeArgs([ "address[]", "address[]" ], [ investorsToAdd, investorsToRemove ]));

       case 2:
       case "end":
        return _context10.stop();
      }
    }), _callee10);
  })))).apply(this, arguments);
}

function maxConcentrationArgs(_x12) {
  return _maxConcentrationArgs.apply(this, arguments);
}

function _maxConcentrationArgs() {
  return (_maxConcentrationArgs = _asyncToGenerator(regeneratorRuntime.mark((function _callee11(maxConcentration) {
    return regeneratorRuntime.wrap((function(_context11) {
      for (;;) switch (_context11.prev = _context11.next) {
       case 0:
        return _context11.abrupt("return", encodeArgs([ "uint256" ], [ maxConcentration ]));

       case 1:
       case "end":
        return _context11.stop();
      }
    }), _callee11);
  })))).apply(this, arguments);
}

function buyShares(_x) {
  return _buyShares.apply(this, arguments);
}

function _buyShares() {
  return (_buyShares = _asyncToGenerator(regeneratorRuntime.mark((function _callee(_ref) {
    var comptrollerProxy, signer, buyer, denominationAsset, _ref$amguValue, amguValue, _ref$investmentAmount, investmentAmount, _ref$minSharesAmount, minSharesAmount, callerDenominationAsset, callerComptrollerProxy;
    return regeneratorRuntime.wrap((function(_context) {
      for (;;) switch (_context.prev = _context.next) {
       case 0:
        return comptrollerProxy = _ref.comptrollerProxy, signer = _ref.signer, buyer = _ref.buyer, 
        denominationAsset = _ref.denominationAsset, _ref$amguValue = _ref.amguValue, amguValue = void 0 === _ref$amguValue ? ethers.utils.parseEther("1") : _ref$amguValue, 
        _ref$investmentAmount = _ref.investmentAmount, investmentAmount = void 0 === _ref$investmentAmount ? ethers.utils.parseEther("1") : _ref$investmentAmount, 
        _ref$minSharesAmount = _ref.minSharesAmount, minSharesAmount = void 0 === _ref$minSharesAmount ? investmentAmount : _ref$minSharesAmount, 
        callerDenominationAsset = denominationAsset.connect(signer), _context.next = 4, 
        callerDenominationAsset.approve(comptrollerProxy, investmentAmount);

       case 4:
        return callerComptrollerProxy = comptrollerProxy.connect(signer), _context.abrupt("return", callerComptrollerProxy.buyShares.args(buyer, investmentAmount, minSharesAmount).value(amguValue).send());

       case 6:
       case "end":
        return _context.stop();
      }
    }), _callee);
  })))).apply(this, arguments);
}

function redeemShares(_x2) {
  return _redeemShares.apply(this, arguments);
}

function _redeemShares() {
  return (_redeemShares = _asyncToGenerator(regeneratorRuntime.mark((function _callee2(_ref2) {
    var comptrollerProxy, signer, quantity, _ref2$additionalAsset, additionalAssets, _ref2$assetsToSkip, assetsToSkip;
    return regeneratorRuntime.wrap((function(_context2) {
      for (;;) switch (_context2.prev = _context2.next) {
       case 0:
        if (comptrollerProxy = _ref2.comptrollerProxy, signer = _ref2.signer, quantity = _ref2.quantity, 
        _ref2$additionalAsset = _ref2.additionalAssets, additionalAssets = void 0 === _ref2$additionalAsset ? [] : _ref2$additionalAsset, 
        _ref2$assetsToSkip = _ref2.assetsToSkip, assetsToSkip = void 0 === _ref2$assetsToSkip ? [] : _ref2$assetsToSkip, 
        null != quantity) {
          _context2.next = 7;
          break;
        }
        if (!(additionalAssets.length > 0 || assetsToSkip.length > 0)) {
          _context2.next = 4;
          break;
        }
        throw "Must specify shares quantity if specifying additional assets or assets to skip";

       case 4:
        return _context2.abrupt("return", comptrollerProxy.connect(signer).redeemShares());

       case 7:
        return _context2.abrupt("return", comptrollerProxy.connect(signer).redeemSharesDetailed(quantity, additionalAssets, assetsToSkip));

       case 8:
       case "end":
        return _context2.stop();
      }
    }), _callee2);
  })))).apply(this, arguments);
}

function createComptrollerProxy(_x) {
  return _createComptrollerProxy.apply(this, arguments);
}

function _createComptrollerProxy() {
  return (_createComptrollerProxy = _asyncToGenerator(regeneratorRuntime.mark((function _callee(_ref) {
    var signer, comptrollerLib, denominationAsset, _ref$sharesActionTime, sharesActionTimelock, _ref$allowedBuyShares, allowedBuySharesCallers, _ref$feeManagerConfig, feeManagerConfigData, _ref$policyManagerCon, policyManagerConfigData, constructData, comptrollerProxyContract, deployComptrollerProxyReceipt;
    return regeneratorRuntime.wrap((function(_context) {
      for (;;) switch (_context.prev = _context.next) {
       case 0:
        return signer = _ref.signer, comptrollerLib = _ref.comptrollerLib, denominationAsset = _ref.denominationAsset, 
        _ref$sharesActionTime = _ref.sharesActionTimelock, sharesActionTimelock = void 0 === _ref$sharesActionTime ? 0 : _ref$sharesActionTime, 
        _ref$allowedBuyShares = _ref.allowedBuySharesCallers, allowedBuySharesCallers = void 0 === _ref$allowedBuyShares ? [] : _ref$allowedBuyShares, 
        _ref$feeManagerConfig = _ref.feeManagerConfigData, feeManagerConfigData = void 0 === _ref$feeManagerConfig ? "0x" : _ref$feeManagerConfig, 
        _ref$policyManagerCon = _ref.policyManagerConfigData, policyManagerConfigData = void 0 === _ref$policyManagerCon ? "0x" : _ref$policyManagerCon, 
        constructData = comptrollerLib.abi.encodeFunctionData(comptrollerLib.init.fragment, [ denominationAsset, sharesActionTimelock, allowedBuySharesCallers, feeManagerConfigData, policyManagerConfigData ]), 
        _context.next = 4, protocol.ComptrollerProxy.deploy(signer, constructData, comptrollerLib);

       case 4:
        return comptrollerProxyContract = _context.sent, deployComptrollerProxyReceipt = comptrollerProxyContract.deployment, 
        _context.abrupt("return", {
          comptrollerProxy: new protocol.ComptrollerLib(comptrollerProxyContract.address, signer),
          deployComptrollerProxyReceipt: deployComptrollerProxyReceipt
        });

       case 7:
       case "end":
        return _context.stop();
      }
    }), _callee);
  })))).apply(this, arguments);
}

function createMigratedFundConfig(_x2) {
  return _createMigratedFundConfig.apply(this, arguments);
}

function _createMigratedFundConfig() {
  return (_createMigratedFundConfig = _asyncToGenerator(regeneratorRuntime.mark((function _callee2(_ref2) {
    var signer, fundDeployer, denominationAsset, _ref2$sharesActionTim, sharesActionTimelock, _ref2$allowedBuyShare, allowedBuySharesCallers, _ref2$feeManagerConfi, feeManagerConfigData, _ref2$policyManagerCo, policyManagerConfigData, newFundConfigTx, signerAddress, denominationAssetAddress, allowedBuySharesCallersAddresses, comptrollerDeployedArgs;
    return regeneratorRuntime.wrap((function(_context2) {
      for (;;) switch (_context2.prev = _context2.next) {
       case 0:
        return signer = _ref2.signer, fundDeployer = _ref2.fundDeployer, denominationAsset = _ref2.denominationAsset, 
        _ref2$sharesActionTim = _ref2.sharesActionTimelock, sharesActionTimelock = void 0 === _ref2$sharesActionTim ? 0 : _ref2$sharesActionTim, 
        _ref2$allowedBuyShare = _ref2.allowedBuySharesCallers, allowedBuySharesCallers = void 0 === _ref2$allowedBuyShare ? [] : _ref2$allowedBuyShare, 
        _ref2$feeManagerConfi = _ref2.feeManagerConfigData, feeManagerConfigData = void 0 === _ref2$feeManagerConfi ? "0x" : _ref2$feeManagerConfi, 
        _ref2$policyManagerCo = _ref2.policyManagerConfigData, policyManagerConfigData = void 0 === _ref2$policyManagerCo ? "0x" : _ref2$policyManagerCo, 
        newFundConfigTx = fundDeployer.connect(signer).createMigratedFundConfig(denominationAsset, sharesActionTimelock, allowedBuySharesCallers, feeManagerConfigData, policyManagerConfigData), 
        _context2.next = 4, expect(newFundConfigTx).resolves.toBeReceipt();

       case 4:
        return _context2.next = 6, crestproject.resolveAddress(signer);

       case 6:
        return signerAddress = _context2.sent, _context2.next = 9, crestproject.resolveAddress(denominationAsset);

       case 9:
        return denominationAssetAddress = _context2.sent, allowedBuySharesCallersAddresses = allowedBuySharesCallers.map((function(caller) {
          return crestproject.resolveAddress(caller);
        })), _context2.next = 13, assertEvent(newFundConfigTx, "ComptrollerProxyDeployed", {
          creator: signerAddress,
          comptrollerProxy: expect.any(String),
          denominationAsset: denominationAssetAddress,
          sharesActionTimelock: ethers.BigNumber.from(sharesActionTimelock),
          allowedBuySharesCallers: allowedBuySharesCallersAddresses,
          feeManagerConfigData: ethers.utils.hexlify(feeManagerConfigData),
          policyManagerConfigData: ethers.utils.hexlify(policyManagerConfigData),
          forMigration: !0
        });

       case 13:
        return comptrollerDeployedArgs = _context2.sent, _context2.abrupt("return", {
          comptrollerProxy: new protocol.ComptrollerLib(comptrollerDeployedArgs.comptrollerProxy, signer),
          newFundConfigTx: newFundConfigTx
        });

       case 15:
       case "end":
        return _context2.stop();
      }
    }), _callee2);
  })))).apply(this, arguments);
}

function createNewFund(_x3) {
  return _createNewFund.apply(this, arguments);
}

function _createNewFund() {
  return (_createNewFund = _asyncToGenerator(regeneratorRuntime.mark((function _callee3(_ref3) {
    var signer, fundDeployer, denominationAsset, _ref3$sharesActionTim, sharesActionTimelock, _ref3$allowedBuyShare, allowedBuySharesCallers, _ref3$fundOwner, fundOwner, _ref3$fundName, fundName, _ref3$feeManagerConfi, feeManagerConfig, _ref3$policyManagerCo, policyManagerConfig, investment, newFundTx, creator, denominationAssetAddress, allowedBuySharesCallersAddresses, comptrollerDeployedArgs, comptrollerProxy, fundOwnerAddress, newFundDeployedArgs, vaultProxy;
    return regeneratorRuntime.wrap((function(_context3) {
      for (;;) switch (_context3.prev = _context3.next) {
       case 0:
        return signer = _ref3.signer, fundDeployer = _ref3.fundDeployer, denominationAsset = _ref3.denominationAsset, 
        _ref3$sharesActionTim = _ref3.sharesActionTimelock, sharesActionTimelock = void 0 === _ref3$sharesActionTim ? 0 : _ref3$sharesActionTim, 
        _ref3$allowedBuyShare = _ref3.allowedBuySharesCallers, allowedBuySharesCallers = void 0 === _ref3$allowedBuyShare ? [] : _ref3$allowedBuyShare, 
        _ref3$fundOwner = _ref3.fundOwner, fundOwner = void 0 === _ref3$fundOwner ? crestproject.randomAddress() : _ref3$fundOwner, 
        _ref3$fundName = _ref3.fundName, fundName = void 0 === _ref3$fundName ? "My Fund" : _ref3$fundName, 
        _ref3$feeManagerConfi = _ref3.feeManagerConfig, feeManagerConfig = void 0 === _ref3$feeManagerConfi ? "0x" : _ref3$feeManagerConfi, 
        _ref3$policyManagerCo = _ref3.policyManagerConfig, policyManagerConfig = void 0 === _ref3$policyManagerCo ? "0x" : _ref3$policyManagerCo, 
        investment = _ref3.investment, newFundTx = fundDeployer.connect(signer).createNewFund(fundOwner, fundName, denominationAsset, sharesActionTimelock, allowedBuySharesCallers, feeManagerConfig, policyManagerConfig), 
        _context3.next = 4, expect(newFundTx).resolves.toBeReceipt();

       case 4:
        return _context3.next = 6, crestproject.resolveAddress(signer);

       case 6:
        return creator = _context3.sent, _context3.next = 9, crestproject.resolveAddress(denominationAsset);

       case 9:
        return denominationAssetAddress = _context3.sent, allowedBuySharesCallersAddresses = allowedBuySharesCallers.map((function(caller) {
          return crestproject.resolveAddress(caller);
        })), _context3.next = 13, assertEvent(newFundTx, "ComptrollerProxyDeployed", {
          creator: creator,
          comptrollerProxy: expect.any(String),
          denominationAsset: denominationAssetAddress,
          sharesActionTimelock: ethers.BigNumber.from(sharesActionTimelock),
          allowedBuySharesCallers: allowedBuySharesCallersAddresses,
          feeManagerConfigData: ethers.utils.hexlify(feeManagerConfig),
          policyManagerConfigData: ethers.utils.hexlify(policyManagerConfig),
          forMigration: !1
        });

       case 13:
        return comptrollerDeployedArgs = _context3.sent, comptrollerProxy = new protocol.ComptrollerLib(comptrollerDeployedArgs.comptrollerProxy, signer), 
        _context3.next = 17, crestproject.resolveAddress(fundOwner);

       case 17:
        return fundOwnerAddress = _context3.sent, _context3.next = 20, assertEvent(newFundTx, "NewFundCreated", {
          creator: creator,
          comptrollerProxy: comptrollerProxy.address,
          vaultProxy: expect.any(String),
          fundOwner: fundOwnerAddress,
          fundName: fundName,
          denominationAsset: denominationAssetAddress,
          sharesActionTimelock: ethers.BigNumber.from(sharesActionTimelock),
          allowedBuySharesCallers: allowedBuySharesCallersAddresses,
          feeManagerConfigData: ethers.utils.hexlify(feeManagerConfig),
          policyManagerConfigData: ethers.utils.hexlify(policyManagerConfig)
        });

       case 20:
        if (newFundDeployedArgs = _context3.sent, vaultProxy = new protocol.VaultLib(newFundDeployedArgs.vaultProxy, signer), 
        null == investment) {
          _context3.next = 25;
          break;
        }
        return _context3.next = 25, buyShares(_objectSpread2({
          comptrollerProxy: comptrollerProxy,
          denominationAsset: denominationAsset
        }, investment));

       case 25:
        return _context3.abrupt("return", {
          comptrollerProxy: comptrollerProxy,
          newFundTx: newFundTx,
          vaultProxy: vaultProxy
        });

       case 26:
       case "end":
        return _context3.stop();
      }
    }), _callee3);
  })))).apply(this, arguments);
}

!function(policyHooks) {
  policyHooks[policyHooks.PreBuyShares = 0] = "PreBuyShares", policyHooks[policyHooks.PostBuyShares = 1] = "PostBuyShares", 
  policyHooks[policyHooks.PreCallOnIntegration = 2] = "PreCallOnIntegration", policyHooks[policyHooks.PostCallOnIntegration = 3] = "PostCallOnIntegration";
}(exports.policyHooks || (exports.policyHooks = {})), function(releaseStatusTypes) {
  releaseStatusTypes[releaseStatusTypes.PreLaunch = 0] = "PreLaunch", releaseStatusTypes[releaseStatusTypes.Live = 1] = "Live", 
  releaseStatusTypes[releaseStatusTypes.Paused = 2] = "Paused";
}(exports.releaseStatusTypes || (exports.releaseStatusTypes = {})), exports.IKyberNetworkProxy = IKyberNetworkProxy, 
exports.adapterBlacklistArgs = adapterBlacklistArgs, exports.adapterWhitelistArgs = adapterWhitelistArgs, 
exports.addTrackedAssets = addTrackedAssets, exports.addTrackedAssetsArgs = addTrackedAssetsArgs, 
exports.addTrackedAssetsFragment = addTrackedAssetsFragment, exports.addTrackedAssetsSelector = addTrackedAssetsSelector, 
exports.assertEvent = assertEvent, exports.assertNoEvent = assertNoEvent, exports.assetBlacklistArgs = assetBlacklistArgs, 
exports.assetTransferArgs = assetTransferArgs, exports.assetWhitelistArgs = assetWhitelistArgs, 
exports.bigNumberMax = bigNumberMax, exports.buyShares = buyShares, exports.buySharesPriceFeedToleranceArgs = buySharesPriceFeedToleranceArgs, 
exports.callOnExtension = callOnExtension, exports.callOnIntegrationArgs = callOnIntegrationArgs, 
exports.callOnIntegrationFragment = callOnIntegrationFragment, exports.callOnIntegrationSelector = callOnIntegrationSelector, 
exports.chaiLend = chaiLend, exports.chaiLendArgs = chaiLendArgs, exports.chaiRedeem = chaiRedeem, 
exports.chaiRedeemArgs = chaiRedeemArgs, exports.configureMockRelease = configureMockRelease, 
exports.createComptrollerProxy = createComptrollerProxy, exports.createDeploymentProxy = createDeploymentProxy, 
exports.createMigratedFundConfig = createMigratedFundConfig, exports.createNewFund = createNewFund, 
exports.createUnsignedZeroExV2Order = createUnsignedZeroExV2Order, exports.createZeroExV2OrderTypedData = createZeroExV2OrderTypedData, 
exports.defaultForkDeployment = defaultForkDeployment, exports.defaultPersistetTestDeployment = defaultPersistetTestDeployment, 
exports.defaultTestDeployment = defaultTestDeployment, exports.deployMocks = deployMocks, 
exports.deployPersistent = deployPersistent, exports.deployRelease = deployRelease, 
exports.describeDeployment = describeDeployment, exports.encodeArgs = encodeArgs, 
exports.encodeArgsSync = encodeArgsSync, exports.encodeFunctionData = encodeFunctionData, 
exports.encodeZeroExV2AssetData = encodeZeroExV2AssetData, exports.encodeZeroExV2Order = encodeZeroExV2Order, 
exports.engineAdapterTakeOrder = engineAdapterTakeOrder, exports.engineAdapterTakeOrderArgs = engineAdapterTakeOrderArgs, 
exports.engineTakeOrderArgs = engineTakeOrderArgs, exports.entranceRateFeeConfigArgs = entranceRateFeeConfigArgs, 
exports.entranceRateFeeSharesDue = entranceRateFeeSharesDue, exports.generateFeeManagerConfigWithMockFees = generateFeeManagerConfigWithMockFees, 
exports.generatePolicyManagerConfigWithMockPolicies = generatePolicyManagerConfigWithMockPolicies, 
exports.generatePseudoRandomZeroExV2Salt = generatePseudoRandomZeroExV2Salt, exports.generateRegisteredMockFees = generateRegisteredMockFees, 
exports.generateRegisteredMockPolicies = generateRegisteredMockPolicies, exports.getAssetBalances = getAssetBalances, 
exports.investorWhitelistArgs = investorWhitelistArgs, exports.kyberTakeOrder = kyberTakeOrder, 
exports.kyberTakeOrderArgs = kyberTakeOrderArgs, exports.lendFragment = lendFragment, 
exports.lendSelector = lendSelector, exports.makeEthRich = makeEthRich, exports.makeTokenRich = makeTokenRich, 
exports.makeWethRich = makeWethRich, exports.managementFeeConfigArgs = managementFeeConfigArgs, 
exports.managementFeeSharesDue = managementFeeSharesDue, exports.maxConcentrationArgs = maxConcentrationArgs, 
exports.mockGenericSwap = mockGenericSwap, exports.mockGenericSwapASelector = mockGenericSwapASelector, 
exports.mockGenericSwapArgs = mockGenericSwapArgs, exports.mockGenericSwapBSelector = mockGenericSwapBSelector, 
exports.mockGenericSwapCSelector = mockGenericSwapCSelector, exports.performanceFeeConfigArgs = performanceFeeConfigArgs, 
exports.performanceFeeSharesDue = performanceFeeSharesDue, exports.policyManagerConfigArgs = policyManagerConfigArgs, 
exports.redeemFragment = redeemFragment, exports.redeemSelector = redeemSelector, 
exports.redeemShares = redeemShares, exports.resolveDeploymentProxy = resolveDeploymentProxy, 
exports.seedAndThawEngine = seedAndThawEngine, exports.settleContinuousFeesFragment = settleContinuousFeesFragment, 
exports.settleContinuousFeesSelector = settleContinuousFeesSelector, exports.settlePostBuySharesArgs = settlePostBuySharesArgs, 
exports.settlePreBuySharesArgs = settlePreBuySharesArgs, exports.sharesDueWithInflation = sharesDueWithInflation, 
exports.sighash = sighash, exports.signZeroExV2Order = signZeroExV2Order, exports.takeOrderFragment = takeOrderFragment, 
exports.takeOrderSelector = takeOrderSelector, exports.updateChainlinkAggregator = updateChainlinkAggregator, 
exports.validateRulePostBuySharesArgs = validateRulePostBuySharesArgs, exports.validateRulePostCoIArgs = validateRulePostCoIArgs, 
exports.validateRulePreBuySharesArgs = validateRulePreBuySharesArgs, exports.validateRulePreCoIArgs = validateRulePreCoIArgs, 
exports.warpEngine = warpEngine, exports.zeroExV2AssetFragment = zeroExV2AssetFragment, 
exports.zeroExV2TakeOrder = zeroExV2TakeOrder, exports.zeroExV2TakeOrderArgs = zeroExV2TakeOrderArgs;
