import { Dispatcher, ComptrollerLib, FundDeployer, FundLifecycleLib, PermissionedVaultActionLib, VaultLib, Engine, ValueInterpreter, FeeManager, IntegrationManager, PolicyManager, ChainlinkPriceFeed, AggregatedDerivativePriceFeed, ChaiPriceFeed, ChaiAdapter, EngineAdapter, KyberAdapter, TrackedAssetsAdapter, ZeroExV2Adapter, EntranceRateFee, ManagementFee, PerformanceFee, AdapterBlacklist, AdapterWhitelist, AssetBlacklist, AssetWhitelist, BuySharesPriceFeedTolerance, MaxConcentration, InvestorWhitelist, FundCalculator, WETH, MockToken, MockChaiPriceSource, MockChainlinkPriceSource, MockChaiIntegratee, MockKyberIntegratee, MockGenericAdapter, MockGenericIntegratee, MockZeroExV2Integratee, StandardToken, IFee, IPolicy, ComptrollerProxy } from '@melonproject/protocol';
import { extractEvent, resolveArguments, resolveAddress, randomAddress, contract } from '@crestproject/crestproject';
import { utils, BigNumber, constants } from 'ethers';
import { buildTypedData, encodeTypedDataDigest } from 'ethers-eip712';

function _defineProperty(obj, key, value) {
  if (key in obj) {
    Object.defineProperty(obj, key, {
      value: value,
      enumerable: true,
      configurable: true,
      writable: true
    });
  } else {
    obj[key] = value;
  }

  return obj;
}

function ownKeys(object, enumerableOnly) {
  var keys = Object.keys(object);

  if (Object.getOwnPropertySymbols) {
    var symbols = Object.getOwnPropertySymbols(object);
    if (enumerableOnly) symbols = symbols.filter(function (sym) {
      return Object.getOwnPropertyDescriptor(object, sym).enumerable;
    });
    keys.push.apply(keys, symbols);
  }

  return keys;
}

function _objectSpread2(target) {
  for (var i = 1; i < arguments.length; i++) {
    var source = arguments[i] != null ? arguments[i] : {};

    if (i % 2) {
      ownKeys(Object(source), true).forEach(function (key) {
        _defineProperty(target, key, source[key]);
      });
    } else if (Object.getOwnPropertyDescriptors) {
      Object.defineProperties(target, Object.getOwnPropertyDescriptors(source));
    } else {
      ownKeys(Object(source)).forEach(function (key) {
        Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key));
      });
    }
  }

  return target;
}

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) {
  try {
    var info = gen[key](arg);
    var value = info.value;
  } catch (error) {
    reject(error);
    return;
  }

  if (info.done) {
    resolve(value);
  } else {
    Promise.resolve(value).then(_next, _throw);
  }
}

function _asyncToGenerator(fn) {
  return function () {
    var self = this,
        args = arguments;
    return new Promise(function (resolve, reject) {
      var gen = fn.apply(self, args);

      function _next(value) {
        asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value);
      }

      function _throw(err) {
        asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err);
      }

      _next(undefined);
    });
  };
}

function createRecursionAwareProxy(constructors, config, state) {
  var prefix = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : [];
  return new Proxy(state, {
    ownKeys: function ownKeys() {
      return Object.keys(constructors);
    },
    get: function get(target, prop, receiver) {
      if (!constructors.hasOwnProperty(prop)) {
        return Reflect.get(target, prop, receiver);
      }

      if (prefix.includes(prop)) {
        var joined = prefix.concat(prop).join(' => ');
        throw new Error("Recursive deployment dependency detected: ".concat(joined));
      }

      if (constructors.hasOwnProperty(prop) && !Reflect.has(target, prop)) {
        var path = prefix.concat(prop);
        var proxy = createRecursionAwareProxy(constructors, config, state, path);
        var promise = constructors[prop](config, proxy);
        Reflect.set(target, prop, promise, receiver);
      }

      return Reflect.get(target, prop, receiver);
    }
  });
}

function createDeploymentProxy(constructors, config) {
  var state = {};
  return createRecursionAwareProxy(constructors, config, state);
}
function resolveDeploymentProxy(_x) {
  return _resolveDeploymentProxy.apply(this, arguments);
}

function _resolveDeploymentProxy() {
  _resolveDeploymentProxy = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee2(proxy) {
    var keys;
    return regeneratorRuntime.wrap(function _callee2$(_context2) {
      while (1) {
        switch (_context2.prev = _context2.next) {
          case 0:
            keys = Object.getOwnPropertyNames(proxy);
            return _context2.abrupt("return", keys.reduce( /*#__PURE__*/function () {
              var _ref = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee(carry, current) {
                return regeneratorRuntime.wrap(function _callee$(_context) {
                  while (1) {
                    switch (_context.prev = _context.next) {
                      case 0:
                        _context.t0 = _objectSpread2;
                        _context.t1 = _objectSpread2;
                        _context.t2 = {};
                        _context.next = 5;
                        return carry;

                      case 5:
                        _context.t3 = _context.sent;
                        _context.t4 = (0, _context.t1)(_context.t2, _context.t3);
                        _context.t5 = {};
                        _context.t6 = _defineProperty;
                        _context.t7 = {};
                        _context.t8 = current;
                        _context.next = 13;
                        return proxy[current];

                      case 13:
                        _context.t9 = _context.sent;
                        _context.t10 = (0, _context.t6)(_context.t7, _context.t8, _context.t9);
                        return _context.abrupt("return", (0, _context.t0)(_context.t4, _context.t5, _context.t10));

                      case 16:
                      case "end":
                        return _context.stop();
                    }
                  }
                }, _callee);
              }));

              return function (_x2, _x3) {
                return _ref.apply(this, arguments);
              };
            }(), Promise.resolve({})));

          case 2:
          case "end":
            return _context2.stop();
        }
      }
    }, _callee2);
  }));
  return _resolveDeploymentProxy.apply(this, arguments);
}

function describeDeployment(handlers) {
  return function deploy(config) {
    var proxy = createDeploymentProxy(handlers, config);
    return resolveDeploymentProxy(proxy);
  };
}

function assertEvent(_x, _x2, _x3) {
  return _assertEvent.apply(this, arguments);
}

function _assertEvent() {
  _assertEvent = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee(tx, event, match) {
    var _events$shift;

    var receipt, events, args;
    return regeneratorRuntime.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            _context.next = 2;
            return tx;

          case 2:
            receipt = _context.sent;
            events = extractEvent(receipt, event);
            expect(events.length).toBe(1);
            args = (_events$shift = events.shift()) === null || _events$shift === void 0 ? void 0 : _events$shift.args;

            if (match != null) {
              expect(args).toMatchObject(match);
            }

            return _context.abrupt("return", args);

          case 8:
          case "end":
            return _context.stop();
        }
      }
    }, _callee);
  }));
  return _assertEvent.apply(this, arguments);
}

function assertNoEvent(_x4, _x5) {
  return _assertNoEvent.apply(this, arguments);
}

function _assertNoEvent() {
  _assertNoEvent = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee2(tx, event) {
    var receipt, events;
    return regeneratorRuntime.wrap(function _callee2$(_context2) {
      while (1) {
        switch (_context2.prev = _context2.next) {
          case 0:
            _context2.next = 2;
            return tx;

          case 2:
            receipt = _context2.sent;
            events = extractEvent(receipt, event);
            expect(events.length).toBe(0);

          case 5:
          case "end":
            return _context2.stop();
        }
      }
    }, _callee2);
  }));
  return _assertNoEvent.apply(this, arguments);
}

var deployPersistent = describeDeployment({
  dispatcher: function dispatcher(config) {
    return Dispatcher.deploy(config.deployer);
  }
});

function _arrayWithHoles(arr) {
  if (Array.isArray(arr)) return arr;
}

function _iterableToArray(iter) {
  if (typeof Symbol !== "undefined" && Symbol.iterator in Object(iter)) return Array.from(iter);
}

function _arrayLikeToArray(arr, len) {
  if (len == null || len > arr.length) len = arr.length;

  for (var i = 0, arr2 = new Array(len); i < len; i++) arr2[i] = arr[i];

  return arr2;
}

function _unsupportedIterableToArray(o, minLen) {
  if (!o) return;
  if (typeof o === "string") return _arrayLikeToArray(o, minLen);
  var n = Object.prototype.toString.call(o).slice(8, -1);
  if (n === "Object" && o.constructor) n = o.constructor.name;
  if (n === "Map" || n === "Set") return Array.from(o);
  if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen);
}

function _nonIterableRest() {
  throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.");
}

function _toArray(arr) {
  return _arrayWithHoles(arr) || _iterableToArray(arr) || _unsupportedIterableToArray(arr) || _nonIterableRest();
}

function defaultPersistetTestDeployment(_x) {
  return _defaultPersistetTestDeployment.apply(this, arguments);
}

function _defaultPersistetTestDeployment() {
  _defaultPersistetTestDeployment = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee(provider) {
    var _yield$provider$listA, _yield$provider$listA2, deployer, others, accounts, config, deployment;

    return regeneratorRuntime.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            _context.next = 2;
            return provider.listAccounts();

          case 2:
            _yield$provider$listA = _context.sent;
            _yield$provider$listA2 = _toArray(_yield$provider$listA);
            deployer = _yield$provider$listA2[0];
            others = _yield$provider$listA2.slice(1);
            accounts = others.slice(0, 10) // Only prepare a maximum of ten accounts.
            .map(function (address) {
              return provider.getSigner(address);
            });
            config = {
              deployer: provider.getSigner(deployer)
            };
            _context.next = 10;
            return deployPersistent(config);

          case 10:
            deployment = _context.sent;
            return _context.abrupt("return", {
              accounts: accounts,
              config: config,
              deployment: deployment
            });

          case 12:
          case "end":
            return _context.stop();
        }
      }
    }, _callee);
  }));
  return _defaultPersistetTestDeployment.apply(this, arguments);
}

var deployRelease = describeDeployment({
  // Core
  comptrollerLib: function comptrollerLib(config, deployment) {
    return _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee() {
      var comptrollerLib, fundDeployer;
      return regeneratorRuntime.wrap(function _callee$(_context) {
        while (1) {
          switch (_context.prev = _context.next) {
            case 0:
              _context.t0 = ComptrollerLib;
              _context.t1 = config.deployer;
              _context.next = 4;
              return deployment.fundDeployer;

            case 4:
              _context.t2 = _context.sent;
              _context.next = 7;
              return deployment.valueInterpreter;

            case 7:
              _context.t3 = _context.sent;
              _context.next = 10;
              return deployment.feeManager;

            case 10:
              _context.t4 = _context.sent;
              _context.next = 13;
              return deployment.integrationManager;

            case 13:
              _context.t5 = _context.sent;
              _context.next = 16;
              return deployment.policyManager;

            case 16:
              _context.t6 = _context.sent;
              _context.next = 19;
              return deployment.fundLifecycleLib;

            case 19:
              _context.t7 = _context.sent;
              _context.next = 22;
              return deployment.permissionedVaultActionLib;

            case 22:
              _context.t8 = _context.sent;
              _context.next = 25;
              return deployment.engine;

            case 25:
              _context.t9 = _context.sent;
              _context.next = 28;
              return _context.t0.deploy.call(_context.t0, _context.t1, _context.t2, _context.t3, _context.t4, _context.t5, _context.t6, _context.t7, _context.t8, _context.t9);

            case 28:
              comptrollerLib = _context.sent;
              _context.next = 31;
              return deployment.fundDeployer;

            case 31:
              fundDeployer = _context.sent;
              _context.next = 34;
              return fundDeployer.setComptrollerLib(comptrollerLib);

            case 34:
              return _context.abrupt("return", comptrollerLib);

            case 35:
            case "end":
              return _context.stop();
          }
        }
      }, _callee);
    }))();
  },
  fundDeployer: function fundDeployer(config, deployment) {
    return _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee2() {
      return regeneratorRuntime.wrap(function _callee2$(_context2) {
        while (1) {
          switch (_context2.prev = _context2.next) {
            case 0:
              _context2.t0 = FundDeployer;
              _context2.t1 = config.deployer;
              _context2.t2 = config.dispatcher;
              _context2.next = 5;
              return deployment.engine;

            case 5:
              _context2.t3 = _context2.sent;
              _context2.next = 8;
              return deployment.vaultLib;

            case 8:
              _context2.t4 = _context2.sent;
              _context2.t5 = config.registeredVaultCalls.contracts;
              _context2.t6 = config.registeredVaultCalls.selectors;
              return _context2.abrupt("return", _context2.t0.deploy.call(_context2.t0, _context2.t1, _context2.t2, _context2.t3, _context2.t4, _context2.t5, _context2.t6));

            case 12:
            case "end":
              return _context2.stop();
          }
        }
      }, _callee2);
    }))();
  },
  fundLifecycleLib: function fundLifecycleLib(config, deployment) {
    return _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee3() {
      return regeneratorRuntime.wrap(function _callee3$(_context3) {
        while (1) {
          switch (_context3.prev = _context3.next) {
            case 0:
              _context3.t0 = FundLifecycleLib;
              _context3.t1 = config.deployer;
              _context3.next = 4;
              return deployment.fundDeployer;

            case 4:
              _context3.t2 = _context3.sent;
              _context3.next = 7;
              return deployment.chainlinkPriceFeed;

            case 7:
              _context3.t3 = _context3.sent;
              _context3.next = 10;
              return deployment.feeManager;

            case 10:
              _context3.t4 = _context3.sent;
              _context3.next = 13;
              return deployment.integrationManager;

            case 13:
              _context3.t5 = _context3.sent;
              _context3.next = 16;
              return deployment.policyManager;

            case 16:
              _context3.t6 = _context3.sent;
              return _context3.abrupt("return", _context3.t0.deploy.call(_context3.t0, _context3.t1, _context3.t2, _context3.t3, _context3.t4, _context3.t5, _context3.t6));

            case 18:
            case "end":
              return _context3.stop();
          }
        }
      }, _callee3);
    }))();
  },
  permissionedVaultActionLib: function permissionedVaultActionLib(config, deployment) {
    return _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee4() {
      return regeneratorRuntime.wrap(function _callee4$(_context4) {
        while (1) {
          switch (_context4.prev = _context4.next) {
            case 0:
              _context4.t0 = PermissionedVaultActionLib;
              _context4.t1 = config.deployer;
              _context4.next = 4;
              return deployment.feeManager;

            case 4:
              _context4.t2 = _context4.sent;
              _context4.next = 7;
              return deployment.integrationManager;

            case 7:
              _context4.t3 = _context4.sent;
              return _context4.abrupt("return", _context4.t0.deploy.call(_context4.t0, _context4.t1, _context4.t2, _context4.t3));

            case 9:
            case "end":
              return _context4.stop();
          }
        }
      }, _callee4);
    }))();
  },
  vaultLib: function vaultLib(config) {
    return _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee5() {
      return regeneratorRuntime.wrap(function _callee5$(_context5) {
        while (1) {
          switch (_context5.prev = _context5.next) {
            case 0:
              return _context5.abrupt("return", VaultLib.deploy(config.deployer));

            case 1:
            case "end":
              return _context5.stop();
          }
        }
      }, _callee5);
    }))();
  },
  // Shared Infrastructure
  engine: function engine(config, deployment) {
    return _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee6() {
      return regeneratorRuntime.wrap(function _callee6$(_context6) {
        while (1) {
          switch (_context6.prev = _context6.next) {
            case 0:
              _context6.t0 = Engine;
              _context6.t1 = config.deployer;
              _context6.t2 = config.dispatcher;
              _context6.t3 = config.mgm;
              _context6.t4 = config.mln;
              _context6.t5 = config.weth;
              _context6.next = 8;
              return deployment.valueInterpreter;

            case 8:
              _context6.t6 = _context6.sent;
              _context6.t7 = config.engine.thawDelay;
              return _context6.abrupt("return", _context6.t0.deploy.call(_context6.t0, _context6.t1, _context6.t2, _context6.t3, _context6.t4, _context6.t5, _context6.t6, _context6.t7));

            case 11:
            case "end":
              return _context6.stop();
          }
        }
      }, _callee6);
    }))();
  },
  valueInterpreter: function valueInterpreter(config, deployment) {
    return _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee7() {
      return regeneratorRuntime.wrap(function _callee7$(_context7) {
        while (1) {
          switch (_context7.prev = _context7.next) {
            case 0:
              _context7.t0 = ValueInterpreter;
              _context7.t1 = config.deployer;
              _context7.next = 4;
              return deployment.chainlinkPriceFeed;

            case 4:
              _context7.t2 = _context7.sent;
              _context7.next = 7;
              return deployment.aggregatedDerivativePriceFeed;

            case 7:
              _context7.t3 = _context7.sent;
              return _context7.abrupt("return", _context7.t0.deploy.call(_context7.t0, _context7.t1, _context7.t2, _context7.t3));

            case 9:
            case "end":
              return _context7.stop();
          }
        }
      }, _callee7);
    }))();
  },
  // Extensions
  feeManager: function feeManager(config, deployment) {
    return _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee8() {
      return regeneratorRuntime.wrap(function _callee8$(_context8) {
        while (1) {
          switch (_context8.prev = _context8.next) {
            case 0:
              _context8.t0 = FeeManager;
              _context8.t1 = config.deployer;
              _context8.next = 4;
              return deployment.fundDeployer;

            case 4:
              _context8.t2 = _context8.sent;
              _context8.next = 7;
              return _context8.t0.deploy.call(_context8.t0, _context8.t1, _context8.t2);

            case 7:
              return _context8.abrupt("return", _context8.sent);

            case 8:
            case "end":
              return _context8.stop();
          }
        }
      }, _callee8);
    }))();
  },
  integrationManager: function integrationManager(config, deployment) {
    return _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee9() {
      return regeneratorRuntime.wrap(function _callee9$(_context9) {
        while (1) {
          switch (_context9.prev = _context9.next) {
            case 0:
              _context9.t0 = IntegrationManager;
              _context9.t1 = config.deployer;
              _context9.next = 4;
              return deployment.fundDeployer;

            case 4:
              _context9.t2 = _context9.sent;
              _context9.next = 7;
              return deployment.policyManager;

            case 7:
              _context9.t3 = _context9.sent;
              _context9.next = 10;
              return deployment.valueInterpreter;

            case 10:
              _context9.t4 = _context9.sent;
              _context9.t5 = config.integrationManager.trackedAssetsLimit;
              return _context9.abrupt("return", _context9.t0.deploy.call(_context9.t0, _context9.t1, _context9.t2, _context9.t3, _context9.t4, _context9.t5));

            case 13:
            case "end":
              return _context9.stop();
          }
        }
      }, _callee9);
    }))();
  },
  policyManager: function policyManager(config, deployment) {
    return _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee10() {
      return regeneratorRuntime.wrap(function _callee10$(_context10) {
        while (1) {
          switch (_context10.prev = _context10.next) {
            case 0:
              _context10.t0 = PolicyManager;
              _context10.t1 = config.deployer;
              _context10.next = 4;
              return deployment.fundDeployer;

            case 4:
              _context10.t2 = _context10.sent;
              return _context10.abrupt("return", _context10.t0.deploy.call(_context10.t0, _context10.t1, _context10.t2));

            case 6:
            case "end":
              return _context10.stop();
          }
        }
      }, _callee10);
    }))();
  },
  // Price feeds
  chainlinkPriceFeed: function chainlinkPriceFeed(config) {
    return _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee11() {
      return regeneratorRuntime.wrap(function _callee11$(_context11) {
        while (1) {
          switch (_context11.prev = _context11.next) {
            case 0:
              return _context11.abrupt("return", ChainlinkPriceFeed.deploy(config.deployer, config.dispatcher, config.weth, config.chainlink.ethUsdAggregator, config.chainlink.staleRateThreshold, config.chainlink.primitives, config.chainlink.aggregators, config.chainlink.rateAssets));

            case 1:
            case "end":
              return _context11.stop();
          }
        }
      }, _callee11);
    }))();
  },
  // Derivative price feeds
  aggregatedDerivativePriceFeed: function aggregatedDerivativePriceFeed(config, deployment) {
    return _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee12() {
      return regeneratorRuntime.wrap(function _callee12$(_context12) {
        while (1) {
          switch (_context12.prev = _context12.next) {
            case 0:
              _context12.t0 = AggregatedDerivativePriceFeed;
              _context12.t1 = config.deployer;
              _context12.t2 = config.dispatcher;
              _context12.t3 = [config.integratees.chai];
              _context12.next = 6;
              return deployment.chaiPriceFeed;

            case 6:
              _context12.t4 = _context12.sent;
              _context12.t5 = [_context12.t4];
              return _context12.abrupt("return", _context12.t0.deploy.call(_context12.t0, _context12.t1, _context12.t2, _context12.t3, _context12.t5));

            case 9:
            case "end":
              return _context12.stop();
          }
        }
      }, _callee12);
    }))();
  },
  chaiPriceFeed: function chaiPriceFeed(config) {
    return _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee13() {
      return regeneratorRuntime.wrap(function _callee13$(_context13) {
        while (1) {
          switch (_context13.prev = _context13.next) {
            case 0:
              return _context13.abrupt("return", ChaiPriceFeed.deploy(config.deployer, config.integratees.chai, config.integratees.makerDao.dai, config.integratees.makerDao.pot));

            case 1:
            case "end":
              return _context13.stop();
          }
        }
      }, _callee13);
    }))();
  },
  // Adapters
  chaiAdapter: function chaiAdapter(config, deployment) {
    return _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee14() {
      return regeneratorRuntime.wrap(function _callee14$(_context14) {
        while (1) {
          switch (_context14.prev = _context14.next) {
            case 0:
              _context14.t0 = ChaiAdapter;
              _context14.t1 = config.deployer;
              _context14.next = 4;
              return deployment.integrationManager;

            case 4:
              _context14.t2 = _context14.sent;
              _context14.t3 = config.integratees.chai;
              _context14.t4 = config.integratees.makerDao.dai;
              return _context14.abrupt("return", _context14.t0.deploy.call(_context14.t0, _context14.t1, _context14.t2, _context14.t3, _context14.t4));

            case 8:
            case "end":
              return _context14.stop();
          }
        }
      }, _callee14);
    }))();
  },
  engineAdapter: function engineAdapter(config, deployment) {
    return _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee15() {
      return regeneratorRuntime.wrap(function _callee15$(_context15) {
        while (1) {
          switch (_context15.prev = _context15.next) {
            case 0:
              _context15.t0 = EngineAdapter;
              _context15.t1 = config.deployer;
              _context15.next = 4;
              return deployment.integrationManager;

            case 4:
              _context15.t2 = _context15.sent;
              _context15.next = 7;
              return deployment.engine;

            case 7:
              _context15.t3 = _context15.sent;
              _context15.t4 = config.mln;
              _context15.t5 = config.weth;
              return _context15.abrupt("return", _context15.t0.deploy.call(_context15.t0, _context15.t1, _context15.t2, _context15.t3, _context15.t4, _context15.t5));

            case 11:
            case "end":
              return _context15.stop();
          }
        }
      }, _callee15);
    }))();
  },
  kyberAdapter: function kyberAdapter(config, deployment) {
    return _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee16() {
      return regeneratorRuntime.wrap(function _callee16$(_context16) {
        while (1) {
          switch (_context16.prev = _context16.next) {
            case 0:
              _context16.t0 = KyberAdapter;
              _context16.t1 = config.deployer;
              _context16.next = 4;
              return deployment.integrationManager;

            case 4:
              _context16.t2 = _context16.sent;
              _context16.t3 = config.integratees.kyber;
              _context16.t4 = config.weth;
              return _context16.abrupt("return", _context16.t0.deploy.call(_context16.t0, _context16.t1, _context16.t2, _context16.t3, _context16.t4));

            case 8:
            case "end":
              return _context16.stop();
          }
        }
      }, _callee16);
    }))();
  },
  trackedAssetsAdapter: function trackedAssetsAdapter(config, deployment) {
    return _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee17() {
      return regeneratorRuntime.wrap(function _callee17$(_context17) {
        while (1) {
          switch (_context17.prev = _context17.next) {
            case 0:
              _context17.t0 = TrackedAssetsAdapter;
              _context17.t1 = config.deployer;
              _context17.next = 4;
              return deployment.integrationManager;

            case 4:
              _context17.t2 = _context17.sent;
              return _context17.abrupt("return", _context17.t0.deploy.call(_context17.t0, _context17.t1, _context17.t2));

            case 6:
            case "end":
              return _context17.stop();
          }
        }
      }, _callee17);
    }))();
  },
  zeroExV2Adapter: function zeroExV2Adapter(config, deployment) {
    return _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee18() {
      return regeneratorRuntime.wrap(function _callee18$(_context18) {
        while (1) {
          switch (_context18.prev = _context18.next) {
            case 0:
              _context18.t0 = ZeroExV2Adapter;
              _context18.t1 = config.deployer;
              _context18.next = 4;
              return deployment.integrationManager;

            case 4:
              _context18.t2 = _context18.sent;
              _context18.t3 = config.integratees.zeroExV2.exchange;
              _context18.next = 8;
              return deployment.fundDeployer;

            case 8:
              _context18.t4 = _context18.sent;
              return _context18.abrupt("return", _context18.t0.deploy.call(_context18.t0, _context18.t1, _context18.t2, _context18.t3, _context18.t4));

            case 10:
            case "end":
              return _context18.stop();
          }
        }
      }, _callee18);
    }))();
  },
  // Fees
  entranceRateFee: function entranceRateFee(config, deployment) {
    return _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee19() {
      return regeneratorRuntime.wrap(function _callee19$(_context19) {
        while (1) {
          switch (_context19.prev = _context19.next) {
            case 0:
              _context19.t0 = EntranceRateFee;
              _context19.t1 = config.deployer;
              _context19.next = 4;
              return deployment.feeManager;

            case 4:
              _context19.t2 = _context19.sent;
              return _context19.abrupt("return", _context19.t0.deploy.call(_context19.t0, _context19.t1, _context19.t2));

            case 6:
            case "end":
              return _context19.stop();
          }
        }
      }, _callee19);
    }))();
  },
  managementFee: function managementFee(config, deployment) {
    return _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee20() {
      return regeneratorRuntime.wrap(function _callee20$(_context20) {
        while (1) {
          switch (_context20.prev = _context20.next) {
            case 0:
              _context20.t0 = ManagementFee;
              _context20.t1 = config.deployer;
              _context20.next = 4;
              return deployment.feeManager;

            case 4:
              _context20.t2 = _context20.sent;
              return _context20.abrupt("return", _context20.t0.deploy.call(_context20.t0, _context20.t1, _context20.t2));

            case 6:
            case "end":
              return _context20.stop();
          }
        }
      }, _callee20);
    }))();
  },
  performanceFee: function performanceFee(config, deployment) {
    return _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee21() {
      return regeneratorRuntime.wrap(function _callee21$(_context21) {
        while (1) {
          switch (_context21.prev = _context21.next) {
            case 0:
              _context21.t0 = PerformanceFee;
              _context21.t1 = config.deployer;
              _context21.next = 4;
              return deployment.feeManager;

            case 4:
              _context21.t2 = _context21.sent;
              return _context21.abrupt("return", _context21.t0.deploy.call(_context21.t0, _context21.t1, _context21.t2));

            case 6:
            case "end":
              return _context21.stop();
          }
        }
      }, _callee21);
    }))();
  },
  // Policies
  adapterBlacklist: function adapterBlacklist(config, deployment) {
    return _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee22() {
      return regeneratorRuntime.wrap(function _callee22$(_context22) {
        while (1) {
          switch (_context22.prev = _context22.next) {
            case 0:
              _context22.t0 = AdapterBlacklist;
              _context22.t1 = config.deployer;
              _context22.next = 4;
              return deployment.policyManager;

            case 4:
              _context22.t2 = _context22.sent;
              return _context22.abrupt("return", _context22.t0.deploy.call(_context22.t0, _context22.t1, _context22.t2));

            case 6:
            case "end":
              return _context22.stop();
          }
        }
      }, _callee22);
    }))();
  },
  adapterWhitelist: function adapterWhitelist(config, deployment) {
    return _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee23() {
      return regeneratorRuntime.wrap(function _callee23$(_context23) {
        while (1) {
          switch (_context23.prev = _context23.next) {
            case 0:
              _context23.t0 = AdapterWhitelist;
              _context23.t1 = config.deployer;
              _context23.next = 4;
              return deployment.policyManager;

            case 4:
              _context23.t2 = _context23.sent;
              return _context23.abrupt("return", _context23.t0.deploy.call(_context23.t0, _context23.t1, _context23.t2));

            case 6:
            case "end":
              return _context23.stop();
          }
        }
      }, _callee23);
    }))();
  },
  assetBlacklist: function assetBlacklist(config, deployment) {
    return _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee24() {
      return regeneratorRuntime.wrap(function _callee24$(_context24) {
        while (1) {
          switch (_context24.prev = _context24.next) {
            case 0:
              _context24.t0 = AssetBlacklist;
              _context24.t1 = config.deployer;
              _context24.next = 4;
              return deployment.policyManager;

            case 4:
              _context24.t2 = _context24.sent;
              return _context24.abrupt("return", _context24.t0.deploy.call(_context24.t0, _context24.t1, _context24.t2));

            case 6:
            case "end":
              return _context24.stop();
          }
        }
      }, _callee24);
    }))();
  },
  assetWhitelist: function assetWhitelist(config, deployment) {
    return _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee25() {
      return regeneratorRuntime.wrap(function _callee25$(_context25) {
        while (1) {
          switch (_context25.prev = _context25.next) {
            case 0:
              _context25.t0 = AssetWhitelist;
              _context25.t1 = config.deployer;
              _context25.next = 4;
              return deployment.policyManager;

            case 4:
              _context25.t2 = _context25.sent;
              return _context25.abrupt("return", _context25.t0.deploy.call(_context25.t0, _context25.t1, _context25.t2));

            case 6:
            case "end":
              return _context25.stop();
          }
        }
      }, _callee25);
    }))();
  },
  buySharesPriceFeedTolerance: function buySharesPriceFeedTolerance(config, deployment) {
    return _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee26() {
      return regeneratorRuntime.wrap(function _callee26$(_context26) {
        while (1) {
          switch (_context26.prev = _context26.next) {
            case 0:
              _context26.t0 = BuySharesPriceFeedTolerance;
              _context26.t1 = config.deployer;
              _context26.next = 4;
              return deployment.policyManager;

            case 4:
              _context26.t2 = _context26.sent;
              _context26.t3 = config.integratees.uniswapV2.factory;
              _context26.next = 8;
              return deployment.valueInterpreter;

            case 8:
              _context26.t4 = _context26.sent;
              _context26.t5 = config.weth;
              return _context26.abrupt("return", _context26.t0.deploy.call(_context26.t0, _context26.t1, _context26.t2, _context26.t3, _context26.t4, _context26.t5));

            case 11:
            case "end":
              return _context26.stop();
          }
        }
      }, _callee26);
    }))();
  },
  maxConcentration: function maxConcentration(config, deployment) {
    return _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee27() {
      return regeneratorRuntime.wrap(function _callee27$(_context27) {
        while (1) {
          switch (_context27.prev = _context27.next) {
            case 0:
              _context27.t0 = MaxConcentration;
              _context27.t1 = config.deployer;
              _context27.next = 4;
              return deployment.policyManager;

            case 4:
              _context27.t2 = _context27.sent;
              _context27.next = 7;
              return deployment.valueInterpreter;

            case 7:
              _context27.t3 = _context27.sent;
              return _context27.abrupt("return", _context27.t0.deploy.call(_context27.t0, _context27.t1, _context27.t2, _context27.t3));

            case 9:
            case "end":
              return _context27.stop();
          }
        }
      }, _callee27);
    }))();
  },
  investorWhitelist: function investorWhitelist(config, deployment) {
    return _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee28() {
      return regeneratorRuntime.wrap(function _callee28$(_context28) {
        while (1) {
          switch (_context28.prev = _context28.next) {
            case 0:
              _context28.t0 = InvestorWhitelist;
              _context28.t1 = config.deployer;
              _context28.next = 4;
              return deployment.policyManager;

            case 4:
              _context28.t2 = _context28.sent;
              return _context28.abrupt("return", _context28.t0.deploy.call(_context28.t0, _context28.t1, _context28.t2));

            case 6:
            case "end":
              return _context28.stop();
          }
        }
      }, _callee28);
    }))();
  },
  // Peripheral
  fundCalculator: function fundCalculator(config, deployment) {
    return _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee29() {
      return regeneratorRuntime.wrap(function _callee29$(_context29) {
        while (1) {
          switch (_context29.prev = _context29.next) {
            case 0:
              _context29.t0 = FundCalculator;
              _context29.t1 = config.deployer;
              _context29.next = 4;
              return deployment.feeManager;

            case 4:
              _context29.t2 = _context29.sent;
              return _context29.abrupt("return", _context29.t0.deploy.call(_context29.t0, _context29.t1, _context29.t2));

            case 6:
            case "end":
              return _context29.stop();
          }
        }
      }, _callee29);
    }))();
  },
  // Post-deployment config
  postDeployment: function postDeployment(_config, deployment) {
    return _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee30() {
      var adapters, integrationManager, engineAdapter, engine, fees, feeManager, policies, policyManager;
      return regeneratorRuntime.wrap(function _callee30$(_context30) {
        while (1) {
          switch (_context30.prev = _context30.next) {
            case 0:
              _context30.next = 2;
              return deployment.chaiAdapter;

            case 2:
              _context30.t0 = _context30.sent;
              _context30.next = 5;
              return deployment.engineAdapter;

            case 5:
              _context30.t1 = _context30.sent;
              _context30.next = 8;
              return deployment.kyberAdapter;

            case 8:
              _context30.t2 = _context30.sent;
              _context30.next = 11;
              return deployment.trackedAssetsAdapter;

            case 11:
              _context30.t3 = _context30.sent;
              _context30.next = 14;
              return deployment.zeroExV2Adapter;

            case 14:
              _context30.t4 = _context30.sent;
              adapters = [_context30.t0, _context30.t1, _context30.t2, _context30.t3, _context30.t4];
              _context30.next = 18;
              return deployment.integrationManager;

            case 18:
              integrationManager = _context30.sent;
              _context30.next = 21;
              return integrationManager.registerAdapters(adapters);

            case 21:
              _context30.next = 23;
              return deployment.engineAdapter;

            case 23:
              engineAdapter = _context30.sent;
              _context30.next = 26;
              return deployment.engine;

            case 26:
              engine = _context30.sent;
              _context30.next = 29;
              return engine.addEtherTakers([engineAdapter]);

            case 29:
              _context30.next = 31;
              return deployment.entranceRateFee;

            case 31:
              _context30.t5 = _context30.sent;
              _context30.next = 34;
              return deployment.managementFee;

            case 34:
              _context30.t6 = _context30.sent;
              _context30.next = 37;
              return deployment.performanceFee;

            case 37:
              _context30.t7 = _context30.sent;
              fees = [_context30.t5, _context30.t6, _context30.t7];
              _context30.next = 41;
              return deployment.feeManager;

            case 41:
              feeManager = _context30.sent;
              _context30.next = 44;
              return feeManager.registerFees(fees);

            case 44:
              _context30.next = 46;
              return deployment.adapterBlacklist;

            case 46:
              _context30.t8 = _context30.sent;
              _context30.next = 49;
              return deployment.adapterWhitelist;

            case 49:
              _context30.t9 = _context30.sent;
              _context30.next = 52;
              return deployment.assetBlacklist;

            case 52:
              _context30.t10 = _context30.sent;
              _context30.next = 55;
              return deployment.assetWhitelist;

            case 55:
              _context30.t11 = _context30.sent;
              _context30.next = 58;
              return deployment.maxConcentration;

            case 58:
              _context30.t12 = _context30.sent;
              _context30.next = 61;
              return deployment.investorWhitelist;

            case 61:
              _context30.t13 = _context30.sent;
              policies = [_context30.t8, _context30.t9, _context30.t10, _context30.t11, _context30.t12, _context30.t13];
              _context30.next = 65;
              return deployment.policyManager;

            case 65:
              policyManager = _context30.sent;
              _context30.next = 68;
              return policyManager.registerPolicies(policies);

            case 68:
            case "end":
              return _context30.stop();
          }
        }
      }, _callee30);
    }))();
  }
});

function _arrayWithoutHoles(arr) {
  if (Array.isArray(arr)) return _arrayLikeToArray(arr);
}

function _nonIterableSpread() {
  throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.");
}

function _toConsumableArray(arr) {
  return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _unsupportedIterableToArray(arr) || _nonIterableSpread();
}

function _iterableToArrayLimit(arr, i) {
  if (typeof Symbol === "undefined" || !(Symbol.iterator in Object(arr))) return;
  var _arr = [];
  var _n = true;
  var _d = false;
  var _e = undefined;

  try {
    for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) {
      _arr.push(_s.value);

      if (i && _arr.length === i) break;
    }
  } catch (err) {
    _d = true;
    _e = err;
  } finally {
    try {
      if (!_n && _i["return"] != null) _i["return"]();
    } finally {
      if (_d) throw _e;
    }
  }

  return _arr;
}

function _slicedToArray(arr, i) {
  return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest();
}

function _createForOfIteratorHelper(o, allowArrayLike) {
  var it;

  if (typeof Symbol === "undefined" || o[Symbol.iterator] == null) {
    if (Array.isArray(o) || (it = _unsupportedIterableToArray(o)) || allowArrayLike && o && typeof o.length === "number") {
      if (it) o = it;
      var i = 0;

      var F = function () {};

      return {
        s: F,
        n: function () {
          if (i >= o.length) return {
            done: true
          };
          return {
            done: false,
            value: o[i++]
          };
        },
        e: function (e) {
          throw e;
        },
        f: F
      };
    }

    throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.");
  }

  var normalCompletion = true,
      didErr = false,
      err;
  return {
    s: function () {
      it = o[Symbol.iterator]();
    },
    n: function () {
      var step = it.next();
      normalCompletion = step.done;
      return step;
    },
    e: function (e) {
      didErr = true;
      err = e;
    },
    f: function () {
      try {
        if (!normalCompletion && it.return != null) it.return();
      } finally {
        if (didErr) throw err;
      }
    }
  };
}

function encodeArgs(_x, _x2) {
  return _encodeArgs.apply(this, arguments);
}

function _encodeArgs() {
  _encodeArgs = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee(types, args) {
    var params, resolved, hex;
    return regeneratorRuntime.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            params = types.map(function (type) {
              return utils.ParamType.from(type);
            });
            _context.next = 3;
            return resolveArguments(params, args);

          case 3:
            resolved = _context.sent;
            hex = utils.defaultAbiCoder.encode(params, resolved);
            return _context.abrupt("return", utils.arrayify(hex));

          case 6:
          case "end":
            return _context.stop();
        }
      }
    }, _callee);
  }));
  return _encodeArgs.apply(this, arguments);
}

function encodeArgsSync(types, args) {
  var params = types.map(function (type) {
    return utils.ParamType.from(type);
  });
  var hex = utils.defaultAbiCoder.encode(params, args);
  return utils.arrayify(hex);
}
function encodeFunctionData(fragment) {
  var args = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : [];
  var encodedArgs = encodeArgsSync(fragment.inputs, args);
  return utils.hexlify(utils.concat([sighash(fragment), encodedArgs]));
}
function sighash(fragment) {
  return utils.hexDataSlice(utils.id(fragment.format()), 0, 4);
}
function bigNumberMax(values) {
  var max = BigNumber.from(0);

  var _iterator = _createForOfIteratorHelper(values),
      _step;

  try {
    for (_iterator.s(); !(_step = _iterator.n()).done;) {
      var value = _step.value;
      var bnValue = BigNumber.from(value);

      if (bnValue.gt(max)) {
        max = bnValue;
      }
    }
  } catch (err) {
    _iterator.e(err);
  } finally {
    _iterator.f();
  }

  return max;
}
function getAssetBalances(_x3) {
  return _getAssetBalances.apply(this, arguments);
}

function _getAssetBalances() {
  _getAssetBalances = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee2(_ref) {
    var account, assets;
    return regeneratorRuntime.wrap(function _callee2$(_context2) {
      while (1) {
        switch (_context2.prev = _context2.next) {
          case 0:
            account = _ref.account, assets = _ref.assets;
            return _context2.abrupt("return", Promise.all(assets.map(function (asset) {
              return asset.balanceOf(account);
            })));

          case 2:
          case "end":
            return _context2.stop();
        }
      }
    }, _callee2);
  }));
  return _getAssetBalances.apply(this, arguments);
}

function generatePseudoRandomZeroExV2Salt() {
  var hex = utils.hexlify(utils.randomBytes(32));
  var number = BigNumber.from(hex);
  return BigNumber.from("".concat(number).slice(0, 10));
}
var zeroExV2AssetFragment = utils.FunctionFragment.fromString('ERC20Token(address)');
function encodeZeroExV2AssetData(tokenAddress) {
  var lowerCaseAddress = tokenAddress.toLowerCase();
  return encodeFunctionData(zeroExV2AssetFragment, [lowerCaseAddress]);
}
function createUnsignedZeroExV2Order(_x) {
  return _createUnsignedZeroExV2Order.apply(this, arguments);
}

function _createUnsignedZeroExV2Order() {
  _createUnsignedZeroExV2Order = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee(_ref) {
    var provider, exchange, maker, feeRecipientAddress, makerAssetAmount, takerAssetAmount, takerFee, _ref$duration, duration, makerAsset, takerAsset, _yield$Promise$all$ma, _yield$Promise$all$ma2, exchangeAddress, makerAddress, makerAssetAddress, takerAssetAddress, makerAssetData, takerAssetData, salt, latestBlock, expirationTimeSeconds;

    return regeneratorRuntime.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            provider = _ref.provider, exchange = _ref.exchange, maker = _ref.maker, feeRecipientAddress = _ref.feeRecipientAddress, makerAssetAmount = _ref.makerAssetAmount, takerAssetAmount = _ref.takerAssetAmount, takerFee = _ref.takerFee, _ref$duration = _ref.duration, duration = _ref$duration === void 0 ? 24 * 60 * 60 : _ref$duration, makerAsset = _ref.makerAsset, takerAsset = _ref.takerAsset;
            _context.next = 3;
            return Promise.all([resolveAddress(exchange), resolveAddress(maker), resolveAddress(makerAsset), resolveAddress(takerAsset)]);

          case 3:
            _yield$Promise$all$ma = _context.sent.map(function (value) {
              return value.toLowerCase();
            });
            _yield$Promise$all$ma2 = _slicedToArray(_yield$Promise$all$ma, 4);
            exchangeAddress = _yield$Promise$all$ma2[0];
            makerAddress = _yield$Promise$all$ma2[1];
            makerAssetAddress = _yield$Promise$all$ma2[2];
            takerAssetAddress = _yield$Promise$all$ma2[3];
            makerAssetData = encodeZeroExV2AssetData(makerAssetAddress);
            takerAssetData = encodeZeroExV2AssetData(takerAssetAddress);
            salt = generatePseudoRandomZeroExV2Salt();
            _context.next = 14;
            return provider.getBlock('latest');

          case 14:
            latestBlock = _context.sent;
            expirationTimeSeconds = BigNumber.from(latestBlock.timestamp + duration);
            return _context.abrupt("return", {
              exchangeAddress: exchangeAddress,
              makerAddress: makerAddress,
              takerAddress: constants.AddressZero,
              feeRecipientAddress: feeRecipientAddress.toString(),
              senderAddress: constants.AddressZero,
              makerAssetAmount: makerAssetAmount.toString(),
              takerAssetAmount: takerAssetAmount.toString(),
              makerFee: constants.Zero.toString(),
              takerFee: takerFee.toString(),
              expirationTimeSeconds: expirationTimeSeconds.toString(),
              salt: salt.toString(),
              makerAssetData: makerAssetData,
              takerAssetData: takerAssetData,
              makerAsset: makerAssetAddress,
              takerAsset: takerAssetAddress
            });

          case 17:
          case "end":
            return _context.stop();
        }
      }
    }, _callee);
  }));
  return _createUnsignedZeroExV2Order.apply(this, arguments);
}

function signZeroExV2Order(_x2, _x3) {
  return _signZeroExV2Order.apply(this, arguments);
}

function _signZeroExV2Order() {
  _signZeroExV2Order = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee2(order, signer) {
    var orderTypedData, orderHashHex, signature, split, type, joined;
    return regeneratorRuntime.wrap(function _callee2$(_context2) {
      while (1) {
        switch (_context2.prev = _context2.next) {
          case 0:
            orderTypedData = createZeroExV2OrderTypedData(order);
            orderHashHex = encodeTypedDataDigest(orderTypedData);
            _context2.next = 4;
            return signer.signMessage(orderHashHex);

          case 4:
            signature = _context2.sent;
            split = utils.splitSignature(signature);
            type = utils.hexlify(3); // ETHSign

            joined = utils.hexlify(utils.concat([utils.hexlify(split.v), split.r, split.s, type]));
            return _context2.abrupt("return", _objectSpread2(_objectSpread2({}, order), {}, {
              signature: joined
            }));

          case 9:
          case "end":
            return _context2.stop();
        }
      }
    }, _callee2);
  }));
  return _signZeroExV2Order.apply(this, arguments);
}

function createZeroExV2OrderTypedData(order) {
  var domain = {
    name: '0x Protocol',
    version: '2',
    verifyingContract: order.exchangeAddress
  };
  var types = {
    Order: [{
      name: 'makerAddress',
      type: 'address'
    }, {
      name: 'takerAddress',
      type: 'address'
    }, {
      name: 'feeRecipientAddress',
      type: 'address'
    }, {
      name: 'senderAddress',
      type: 'address'
    }, {
      name: 'makerAssetAmount',
      type: 'uint256'
    }, {
      name: 'takerAssetAmount',
      type: 'uint256'
    }, {
      name: 'makerFee',
      type: 'uint256'
    }, {
      name: 'takerFee',
      type: 'uint256'
    }, {
      name: 'expirationTimeSeconds',
      type: 'uint256'
    }, {
      name: 'salt',
      type: 'uint256'
    }, {
      name: 'makerAssetData',
      type: 'bytes'
    }, {
      name: 'takerAssetData',
      type: 'bytes'
    }]
  };
  return buildTypedData(domain, types, 'Order', order);
}
function encodeZeroExV2Order(_x4) {
  return _encodeZeroExV2Order.apply(this, arguments);
}

function _encodeZeroExV2Order() {
  _encodeZeroExV2Order = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee3(order) {
    return regeneratorRuntime.wrap(function _callee3$(_context3) {
      while (1) {
        switch (_context3.prev = _context3.next) {
          case 0:
            return _context3.abrupt("return", encodeArgs(['address[4]', 'uint256[6]', 'bytes[2]', 'bytes'], [[order.makerAddress, order.takerAddress, order.feeRecipientAddress, order.senderAddress], [order.makerAssetAmount, order.takerAssetAmount, order.makerFee, order.takerFee, order.expirationTimeSeconds, order.salt], [order.makerAssetData, order.takerAssetData], order.signature]));

          case 1:
          case "end":
            return _context3.stop();
        }
      }
    }, _callee3);
  }));
  return _encodeZeroExV2Order.apply(this, arguments);
}

function zeroExV2TakeOrderArgs(_x5, _x6) {
  return _zeroExV2TakeOrderArgs.apply(this, arguments);
}

function _zeroExV2TakeOrderArgs() {
  _zeroExV2TakeOrderArgs = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee4(order, takerAssetFillAmount) {
    return regeneratorRuntime.wrap(function _callee4$(_context4) {
      while (1) {
        switch (_context4.prev = _context4.next) {
          case 0:
            return _context4.abrupt("return", encodeArgs(['bytes', 'uint256'], [encodeZeroExV2Order(order), takerAssetFillAmount]));

          case 1:
          case "end":
            return _context4.stop();
        }
      }
    }, _callee4);
  }));
  return _zeroExV2TakeOrderArgs.apply(this, arguments);
}

var deployMocks = describeDeployment({
  // Assets
  tokens: function tokens(config) {
    return _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee() {
      var _yield$Promise$all, _yield$Promise$all2, weth, mln, rep, knc, zrx, dai, ren;

      return regeneratorRuntime.wrap(function _callee$(_context) {
        while (1) {
          switch (_context.prev = _context.next) {
            case 0:
              _context.next = 2;
              return Promise.all([WETH.deploy(config.deployer), MockToken.deploy(config.deployer, 'mln', 'MLN', 18), MockToken.deploy(config.deployer, 'rep', 'REP', 18), MockToken.deploy(config.deployer, 'knc', 'KNC', 18), MockToken.deploy(config.deployer, 'zrx', 'ZRX', 18), MockToken.deploy(config.deployer, 'dai', 'DAI', 18), MockToken.deploy(config.deployer, 'ren', 'REN', 18)]);

            case 2:
              _yield$Promise$all = _context.sent;
              _yield$Promise$all2 = _slicedToArray(_yield$Promise$all, 7);
              weth = _yield$Promise$all2[0];
              mln = _yield$Promise$all2[1];
              rep = _yield$Promise$all2[2];
              knc = _yield$Promise$all2[3];
              zrx = _yield$Promise$all2[4];
              dai = _yield$Promise$all2[5];
              ren = _yield$Promise$all2[6];
              return _context.abrupt("return", {
                weth: weth,
                mln: mln,
                rep: rep,
                knc: knc,
                zrx: zrx,
                dai: dai,
                ren: ren
              });

            case 12:
            case "end":
              return _context.stop();
          }
        }
      }, _callee);
    }))();
  },
  // Price feed sources
  chaiPriceSource: function chaiPriceSource(config) {
    return _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee2() {
      return regeneratorRuntime.wrap(function _callee2$(_context2) {
        while (1) {
          switch (_context2.prev = _context2.next) {
            case 0:
              return _context2.abrupt("return", MockChaiPriceSource.deploy(config.deployer));

            case 1:
            case "end":
              return _context2.stop();
          }
        }
      }, _callee2);
    }))();
  },
  chainlinkAggregators: function chainlinkAggregators(config) {
    return _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee3() {
      var _yield$Promise$all3, _yield$Promise$all4, mln, rep, knc, zrx, dai, ren;

      return regeneratorRuntime.wrap(function _callee3$(_context3) {
        while (1) {
          switch (_context3.prev = _context3.next) {
            case 0:
              _context3.next = 2;
              return Promise.all([MockChainlinkPriceSource.deploy(config.deployer, 18), MockChainlinkPriceSource.deploy(config.deployer, 18), MockChainlinkPriceSource.deploy(config.deployer, 18), MockChainlinkPriceSource.deploy(config.deployer, 18), MockChainlinkPriceSource.deploy(config.deployer, 18), MockChainlinkPriceSource.deploy(config.deployer, 8)]);

            case 2:
              _yield$Promise$all3 = _context3.sent;
              _yield$Promise$all4 = _slicedToArray(_yield$Promise$all3, 6);
              mln = _yield$Promise$all4[0];
              rep = _yield$Promise$all4[1];
              knc = _yield$Promise$all4[2];
              zrx = _yield$Promise$all4[3];
              dai = _yield$Promise$all4[4];
              ren = _yield$Promise$all4[5];
              return _context3.abrupt("return", {
                mln: mln,
                rep: rep,
                knc: knc,
                zrx: zrx,
                dai: dai,
                ren: ren
              });

            case 11:
            case "end":
              return _context3.stop();
          }
        }
      }, _callee3);
    }))();
  },
  chainlinkEthUsdAggregator: function chainlinkEthUsdAggregator(config) {
    return _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee4() {
      return regeneratorRuntime.wrap(function _callee4$(_context4) {
        while (1) {
          switch (_context4.prev = _context4.next) {
            case 0:
              return _context4.abrupt("return", MockChainlinkPriceSource.deploy(config.deployer, 8));

            case 1:
            case "end":
              return _context4.stop();
          }
        }
      }, _callee4);
    }))();
  },
  // Adapter integratees
  chaiIntegratee: function chaiIntegratee(config, deployment) {
    return _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee5() {
      var tokens;
      return regeneratorRuntime.wrap(function _callee5$(_context5) {
        while (1) {
          switch (_context5.prev = _context5.next) {
            case 0:
              _context5.next = 2;
              return deployment.tokens;

            case 2:
              tokens = _context5.sent;
              return _context5.abrupt("return", MockChaiIntegratee.deploy(config.deployer, tokens.dai));

            case 4:
            case "end":
              return _context5.stop();
          }
        }
      }, _callee5);
    }))();
  },
  kyberIntegratee: function kyberIntegratee(config) {
    return _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee6() {
      return regeneratorRuntime.wrap(function _callee6$(_context6) {
        while (1) {
          switch (_context6.prev = _context6.next) {
            case 0:
              return _context6.abrupt("return", MockKyberIntegratee.deploy(config.deployer, []));

            case 1:
            case "end":
              return _context6.stop();
          }
        }
      }, _callee6);
    }))();
  },
  mockGenericAdapter: function mockGenericAdapter(config, deployment) {
    return _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee7() {
      return regeneratorRuntime.wrap(function _callee7$(_context7) {
        while (1) {
          switch (_context7.prev = _context7.next) {
            case 0:
              _context7.t0 = MockGenericAdapter;
              _context7.t1 = config.deployer;
              _context7.next = 4;
              return deployment.mockGenericIntegratee;

            case 4:
              _context7.t2 = _context7.sent;
              return _context7.abrupt("return", _context7.t0.deploy.call(_context7.t0, _context7.t1, _context7.t2));

            case 6:
            case "end":
              return _context7.stop();
          }
        }
      }, _callee7);
    }))();
  },
  mockGenericIntegratee: function mockGenericIntegratee(config) {
    return _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee8() {
      return regeneratorRuntime.wrap(function _callee8$(_context8) {
        while (1) {
          switch (_context8.prev = _context8.next) {
            case 0:
              return _context8.abrupt("return", MockGenericIntegratee.deploy(config.deployer));

            case 1:
            case "end":
              return _context8.stop();
          }
        }
      }, _callee8);
    }))();
  },
  zeroExV2Integratee: function zeroExV2Integratee(config, deployment) {
    return _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee9() {
      var tokens, assetData;
      return regeneratorRuntime.wrap(function _callee9$(_context9) {
        while (1) {
          switch (_context9.prev = _context9.next) {
            case 0:
              _context9.next = 2;
              return deployment.tokens;

            case 2:
              tokens = _context9.sent;
              assetData = encodeZeroExV2AssetData(tokens.zrx.address);
              return _context9.abrupt("return", MockZeroExV2Integratee.deploy(config.deployer, assetData));

            case 5:
            case "end":
              return _context9.stop();
          }
        }
      }, _callee9);
    }))();
  }
});
function configureMockRelease(_x) {
  return _configureMockRelease.apply(this, arguments);
}

function _configureMockRelease() {
  _configureMockRelease = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee12(_ref) {
    var deployer, mgm, dispatcher, mocks, accounts, integratees, tokens, chainlinkPrimitives, chainlinkAggregators, chainlinkRateAssets;
    return regeneratorRuntime.wrap(function _callee12$(_context12) {
      while (1) {
        switch (_context12.prev = _context12.next) {
          case 0:
            deployer = _ref.deployer, mgm = _ref.mgm, dispatcher = _ref.dispatcher, mocks = _ref.mocks, accounts = _ref.accounts;
            integratees = [mocks.kyberIntegratee, mocks.chaiIntegratee, mocks.mockGenericIntegratee];
            tokens = [mocks.tokens.mln, mocks.tokens.rep, mocks.tokens.knc, mocks.tokens.zrx, mocks.tokens.dai, mocks.tokens.ren, mocks.chaiIntegratee];
            chainlinkPrimitives = [mocks.tokens.mln, mocks.tokens.rep, mocks.tokens.knc, mocks.tokens.zrx, mocks.tokens.dai, mocks.tokens.ren];
            chainlinkAggregators = [mocks.chainlinkAggregators.mln, mocks.chainlinkAggregators.rep, mocks.chainlinkAggregators.knc, mocks.chainlinkAggregators.zrx, mocks.chainlinkAggregators.dai, mocks.chainlinkAggregators.ren];
            chainlinkRateAssets = [0, // MLN/ETH
            0, // REP/ETH
            0, // KNC/ETH
            0, // ZRX/ETH
            0, // DAI/ETH
            1 // REN/USD
            ]; // Make all accounts rich in WETH and tokens.

            _context12.next = 8;
            return Promise.all([makeWethRich(mocks.tokens.weth, deployer, utils.parseEther('1000')), makeTokenRich(Object.values(tokens), deployer)].concat(_toConsumableArray(accounts.map( /*#__PURE__*/function () {
              var _ref2 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee10(account) {
                return regeneratorRuntime.wrap(function _callee10$(_context10) {
                  while (1) {
                    switch (_context10.prev = _context10.next) {
                      case 0:
                        _context10.next = 2;
                        return Promise.all([makeTokenRich(Object.values(tokens), account), makeWethRich(mocks.tokens.weth, account)]);

                      case 2:
                      case "end":
                        return _context10.stop();
                    }
                  }
                }, _callee10);
              }));

              return function (_x6) {
                return _ref2.apply(this, arguments);
              };
            }()))));

          case 8:
            _context12.next = 10;
            return Promise.all(integratees.map( /*#__PURE__*/function () {
              var _ref3 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee11(integratee) {
                return regeneratorRuntime.wrap(function _callee11$(_context11) {
                  while (1) {
                    switch (_context11.prev = _context11.next) {
                      case 0:
                        _context11.next = 2;
                        return Promise.all([mocks.tokens.weth.transfer(integratee, utils.parseEther('100')), makeEthRich(deployer, integratee), makeTokenRich(tokens, integratee)]);

                      case 2:
                      case "end":
                        return _context11.stop();
                    }
                  }
                }, _callee11);
              }));

              return function (_x7) {
                return _ref3.apply(this, arguments);
              };
            }()));

          case 10:
            return _context12.abrupt("return", {
              deployer: deployer,
              mgm: mgm,
              dispatcher: dispatcher.address,
              mln: mocks.tokens.mln.address,
              weth: mocks.tokens.weth.address,
              registeredVaultCalls: {
                contracts: [],
                selectors: []
              },
              engine: {
                thawDelay: 10000000000
              },
              chainlink: {
                ethUsdAggregator: mocks.chainlinkEthUsdAggregator,
                staleRateThreshold: 259200,
                // 72 hours
                aggregators: chainlinkAggregators,
                primitives: chainlinkPrimitives,
                rateAssets: chainlinkRateAssets
              },
              integrationManager: {
                trackedAssetsLimit: 20 // TODO

              },
              integratees: {
                chai: mocks.chaiIntegratee.address,
                kyber: mocks.kyberIntegratee.address,
                makerDao: {
                  dai: mocks.tokens.dai.address,
                  pot: mocks.chaiPriceSource.address
                },
                uniswapV2: {
                  factory: randomAddress() // TODO

                },
                zeroExV2: {
                  // TODO
                  exchange: mocks.zeroExV2Integratee.address,
                  erc20Proxy: randomAddress()
                }
              }
            });

          case 11:
          case "end":
            return _context12.stop();
        }
      }
    }, _callee12);
  }));
  return _configureMockRelease.apply(this, arguments);
}

function makeEthRich(_x2, _x3) {
  return _makeEthRich.apply(this, arguments);
}

function _makeEthRich() {
  _makeEthRich = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee13(sender, receiver) {
    var amount,
        _args13 = arguments;
    return regeneratorRuntime.wrap(function _callee13$(_context13) {
      while (1) {
        switch (_context13.prev = _context13.next) {
          case 0:
            amount = _args13.length > 2 && _args13[2] !== undefined ? _args13[2] : utils.parseEther('100');
            _context13.t0 = sender;
            _context13.next = 4;
            return resolveAddress(receiver);

          case 4:
            _context13.t1 = _context13.sent;
            _context13.t2 = amount;
            _context13.t3 = {
              to: _context13.t1,
              value: _context13.t2
            };
            return _context13.abrupt("return", _context13.t0.sendTransaction.call(_context13.t0, _context13.t3));

          case 8:
          case "end":
            return _context13.stop();
        }
      }
    }, _callee13);
  }));
  return _makeEthRich.apply(this, arguments);
}

function makeWethRich(_x4, _x5) {
  return _makeWethRich.apply(this, arguments);
}

function _makeWethRich() {
  _makeWethRich = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee14(weth, account) {
    var amount,
        connected,
        _args14 = arguments;
    return regeneratorRuntime.wrap(function _callee14$(_context14) {
      while (1) {
        switch (_context14.prev = _context14.next) {
          case 0:
            amount = _args14.length > 2 && _args14[2] !== undefined ? _args14[2] : utils.parseEther('100');
            connected = weth.connect(account);
            return _context14.abrupt("return", connected.deposit.value(amount).send());

          case 3:
          case "end":
            return _context14.stop();
        }
      }
    }, _callee14);
  }));
  return _makeWethRich.apply(this, arguments);
}

function makeTokenRich(tokens, receiver) {
  var amount = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : utils.parseEther('100');
  var promises = tokens.map(function (token) {
    return token.mintFor(receiver, amount);
  });
  return Promise.all(promises);
}

var mainnet = {
	chai: "0x06AF07097C9Eeb7fD685c692751D5C66dB49c215",
	chaiPriceSource: "0x197E90f9FAD81970bA7976f33CbD77088E5D7cf7",
	chainlinkEthUsdAggregator: "0x5f4eC3Df9cbd43714FE2740f5E3616155c5b8419",
	chainlinkAggregators: {
		dai: [
			"0x773616E4d11A78F511299002da57A0a94577F1f4",
			0
		],
		knc: [
			"0x656c0544eF4C98A6a98491833A89204Abb045d6b",
			0
		],
		zrx: [
			"0x2Da4983a622a8498bb1a21FaE9D8F6C664939962",
			0
		],
		rep: [
			"0xD4CE430C3b67b3E2F7026D86E7128588629e2455",
			0
		],
		ren: [
			"0x0f59666EDE214281e956cb3b2D0d69415AfF4A01",
			1
		]
	},
	kyber: "0x9AAb3f75489902f3a48495025729a0AF77d4b11e",
	tokens: {
		dai: "0x6B175474E89094C44Da98b954EedeAC495271d0F",
		knc: "0xdd974D5C2e2928deA5F71b9825b8b646686BD200",
		mln: "0xec67005c4E498Ec7f55E092bd1d35cbC47C91892",
		rep: "0x221657776846890989a759BA2973e427DfF5C9bB",
		ren: "0x408e41876cccdc0f92210600ef50372656052a38",
		usdc: "0xA0b86991c6218b36c1d19D4a2e9Eb0cE3606eB48",
		weth: "0xC02aaA39b223FE8D0A0e5C4F27eAD9083C756Cc2",
		zrx: "0xE41d2489571d322189246DaFA5ebDe1F4699F498"
	},
	whales: {
		dai: "0x16B34Ce9A6a6F7FC2DD25Ba59bf7308E7B38E186",
		knc: "0x986C98AF08AdBB82A8De7c7E88c6e8e4C74105ae",
		mln: "0xd8f8a53945bcfbbc19da162aa405e662ef71c40d",
		rep: "0x78d196056e1f369ec2d563aaac504ea53462b30e",
		ren: "0xbe0eb53f46cd790cd13851d5eff43d12404d33e8",
		usdc: "0x18F77cf74D91f946dD65CC235B8100DCec741280",
		weth: "0xe08A8b19e5722a201EaF20A6BC595eF655397bd5",
		zrx: "0x206376e8940e42538781cd94ef024df3c1e0fd43"
	},
	zeroExV2: {
		exchange: "0x080bf510fcbf18b91105470639e9561022937712",
		erc20Proxy: "0x95e6f48254609a6ee006f7d493c8e5fb97094cef"
	}
};

function configureForkRelease(_x) {
  return _configureForkRelease.apply(this, arguments);
}

function _configureForkRelease() {
  _configureForkRelease = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee4(_ref) {
    var provider, deployer, mgm, dispatcher, accounts, whales, tokens, chainlinkConfig, chainlinkRateAssets, chainlinkAggregators, chainlinkPrimitives;
    return regeneratorRuntime.wrap(function _callee4$(_context4) {
      while (1) {
        switch (_context4.prev = _context4.next) {
          case 0:
            provider = _ref.provider, deployer = _ref.deployer, mgm = _ref.mgm, dispatcher = _ref.dispatcher, accounts = _ref.accounts;
            whales = Object.entries(mainnet.whales).reduce(function (carry, _ref2) {
              var _ref3 = _slicedToArray(_ref2, 2),
                  key = _ref3[0],
                  address = _ref3[1];

              var signer = provider.getSigner(address);
              return _objectSpread2(_objectSpread2({}, carry), {}, _defineProperty({}, key, signer));
            }, {});
            tokens = Object.entries(mainnet.tokens).reduce(function (carry, _ref4) {
              var _ref5 = _slicedToArray(_ref4, 2),
                  key = _ref5[0],
                  address = _ref5[1];

              var token = new StandardToken(address, deployer);
              return _objectSpread2(_objectSpread2({}, carry), {}, _defineProperty({}, key, token));
            }, {});
            chainlinkConfig = Object.values(mainnet.chainlinkAggregators);
            chainlinkRateAssets = chainlinkConfig.map(function (_ref6) {
              var _ref7 = _slicedToArray(_ref6, 2),
                  b = _ref7[1];

              return b;
            });
            chainlinkAggregators = chainlinkConfig.map(function (_ref8) {
              var _ref9 = _slicedToArray(_ref8, 1),
                  a = _ref9[0];

              return a;
            });
            chainlinkPrimitives = Object.keys(mainnet.chainlinkAggregators).map(function (key) {
              return mainnet.tokens[key];
            }); // Transfer some ether to all whales.

            _context4.next = 9;
            return Promise.all(Object.values(whales).map( /*#__PURE__*/function () {
              var _ref10 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee(whale) {
                return regeneratorRuntime.wrap(function _callee$(_context) {
                  while (1) {
                    switch (_context.prev = _context.next) {
                      case 0:
                        _context.next = 2;
                        return makeEthRich$1(deployer, whale);

                      case 2:
                      case "end":
                        return _context.stop();
                    }
                  }
                }, _callee);
              }));

              return function (_x7) {
                return _ref10.apply(this, arguments);
              };
            }()));

          case 9:
            _context4.next = 11;
            return Promise.all([].concat(_toConsumableArray(accounts), [deployer, mgm]).map( /*#__PURE__*/function () {
              var _ref11 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee3(account) {
                return regeneratorRuntime.wrap(function _callee3$(_context3) {
                  while (1) {
                    switch (_context3.prev = _context3.next) {
                      case 0:
                        _context3.next = 2;
                        return Promise.all(Object.entries(whales).map( /*#__PURE__*/function () {
                          var _ref13 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee2(_ref12) {
                            var _ref14, symbol, whale, token;

                            return regeneratorRuntime.wrap(function _callee2$(_context2) {
                              while (1) {
                                switch (_context2.prev = _context2.next) {
                                  case 0:
                                    _ref14 = _slicedToArray(_ref12, 2), symbol = _ref14[0], whale = _ref14[1];
                                    token = tokens[symbol];
                                    _context2.next = 4;
                                    return makeTokenRich$1(token, whale, account);

                                  case 4:
                                  case "end":
                                    return _context2.stop();
                                }
                              }
                            }, _callee2);
                          }));

                          return function (_x9) {
                            return _ref13.apply(this, arguments);
                          };
                        }()));

                      case 2:
                      case "end":
                        return _context3.stop();
                    }
                  }
                }, _callee3);
              }));

              return function (_x8) {
                return _ref11.apply(this, arguments);
              };
            }()));

          case 11:
            return _context4.abrupt("return", {
              deployer: deployer,
              mgm: mgm,
              mainnet: mainnet,
              tokens: tokens,
              whales: whales,
              dispatcher: dispatcher.address,
              mln: mainnet.tokens.mln,
              weth: mainnet.tokens.weth,
              registeredVaultCalls: {
                contracts: [],
                selectors: []
              },
              engine: {
                thawDelay: 10000000000
              },
              chainlink: {
                ethUsdAggregator: mainnet.chainlinkEthUsdAggregator,
                staleRateThreshold: 259200,
                // 72 hours
                aggregators: chainlinkAggregators,
                primitives: chainlinkPrimitives,
                rateAssets: chainlinkRateAssets
              },
              integrationManager: {
                trackedAssetsLimit: 20 // TODO

              },
              integratees: {
                chai: mainnet.chai,
                kyber: mainnet.kyber,
                makerDao: {
                  dai: randomAddress(),
                  // TODO
                  pot: randomAddress() // TODO

                },
                uniswapV2: {
                  factory: randomAddress() // TODO

                },
                zeroExV2: {
                  exchange: mainnet.zeroExV2.exchange,
                  erc20Proxy: mainnet.zeroExV2.erc20Proxy
                }
              }
            });

          case 12:
          case "end":
            return _context4.stop();
        }
      }
    }, _callee4);
  }));
  return _configureForkRelease.apply(this, arguments);
}

function makeEthRich$1(_x2, _x3) {
  return _makeEthRich$1.apply(this, arguments);
}

function _makeEthRich$1() {
  _makeEthRich$1 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee5(sender, receiver) {
    return regeneratorRuntime.wrap(function _callee5$(_context5) {
      while (1) {
        switch (_context5.prev = _context5.next) {
          case 0:
            _context5.t0 = sender;
            _context5.next = 3;
            return resolveAddress(receiver);

          case 3:
            _context5.t1 = _context5.sent;
            _context5.t2 = utils.parseEther('100');
            _context5.t3 = {
              to: _context5.t1,
              value: _context5.t2
            };
            return _context5.abrupt("return", _context5.t0.sendTransaction.call(_context5.t0, _context5.t3));

          case 7:
          case "end":
            return _context5.stop();
        }
      }
    }, _callee5);
  }));
  return _makeEthRich$1.apply(this, arguments);
}

function makeTokenRich$1(_x4, _x5, _x6) {
  return _makeTokenRich.apply(this, arguments);
}

function _makeTokenRich() {
  _makeTokenRich = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee6(token, sender, receiver) {
    var amount;
    return regeneratorRuntime.wrap(function _callee6$(_context6) {
      while (1) {
        switch (_context6.prev = _context6.next) {
          case 0:
            _context6.t0 = constants.One.mul(10);
            _context6.next = 3;
            return token.decimals();

          case 3:
            _context6.t1 = _context6.sent;
            amount = _context6.t0.pow.call(_context6.t0, _context6.t1).mul(100);
            _context6.next = 7;
            return token.connect(sender).transfer(receiver, amount);

          case 7:
          case "end":
            return _context6.stop();
        }
      }
    }, _callee6);
  }));
  return _makeTokenRich.apply(this, arguments);
}

function getSigners(_x) {
  return _getSigners.apply(this, arguments);
}

function _getSigners() {
  _getSigners = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee(provider) {
    var limit,
        addresses,
        _args = arguments;
    return regeneratorRuntime.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            limit = _args.length > 1 && _args[1] !== undefined ? _args[1] : 10;
            _context.next = 3;
            return provider.listAccounts();

          case 3:
            addresses = _context.sent;
            return _context.abrupt("return", addresses.slice(0, limit) // Only prepare a maximum of ten accounts.
            .map(function (address) {
              return provider.getSigner(address);
            }));

          case 5:
          case "end":
            return _context.stop();
        }
      }
    }, _callee);
  }));
  return _getSigners.apply(this, arguments);
}

function defaultTestDeployment(_x2) {
  return _defaultTestDeployment.apply(this, arguments);
}

function _defaultTestDeployment() {
  _defaultTestDeployment = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee2(provider) {
    var _yield$getSigners, _yield$getSigners2, deployer, mgm, accounts, persistent, mocks, config, release;

    return regeneratorRuntime.wrap(function _callee2$(_context2) {
      while (1) {
        switch (_context2.prev = _context2.next) {
          case 0:
            _context2.next = 2;
            return getSigners(provider);

          case 2:
            _yield$getSigners = _context2.sent;
            _yield$getSigners2 = _toArray(_yield$getSigners);
            deployer = _yield$getSigners2[0];
            mgm = _yield$getSigners2[1];
            accounts = _yield$getSigners2.slice(2);
            _context2.next = 9;
            return deployPersistent({
              deployer: deployer
            });

          case 9:
            persistent = _context2.sent;
            _context2.next = 12;
            return deployMocks({
              deployer: deployer,
              accounts: accounts
            });

          case 12:
            mocks = _context2.sent;
            _context2.next = 15;
            return configureMockRelease({
              dispatcher: persistent.dispatcher,
              deployer: deployer,
              mgm: mgm,
              mocks: mocks,
              accounts: accounts
            });

          case 15:
            config = _context2.sent;
            _context2.next = 18;
            return deployRelease(config);

          case 18:
            release = _context2.sent;
            _context2.next = 21;
            return persistent.dispatcher.setCurrentFundDeployer(release.fundDeployer);

          case 21:
            _context2.next = 23;
            return release.integrationManager.registerAdapters([mocks.mockGenericAdapter]);

          case 23:
            return _context2.abrupt("return", {
              config: config,
              accounts: accounts,
              deployment: _objectSpread2(_objectSpread2(_objectSpread2({}, mocks), persistent), release)
            });

          case 24:
          case "end":
            return _context2.stop();
        }
      }
    }, _callee2);
  }));
  return _defaultTestDeployment.apply(this, arguments);
}

function defaultForkDeployment(_x3) {
  return _defaultForkDeployment.apply(this, arguments);
}

function _defaultForkDeployment() {
  _defaultForkDeployment = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee3(provider) {
    var _yield$getSigners3, _yield$getSigners4, deployer, mgm, accounts, persistent, config, release;

    return regeneratorRuntime.wrap(function _callee3$(_context3) {
      while (1) {
        switch (_context3.prev = _context3.next) {
          case 0:
            _context3.next = 2;
            return getSigners(provider, 5);

          case 2:
            _yield$getSigners3 = _context3.sent;
            _yield$getSigners4 = _toArray(_yield$getSigners3);
            deployer = _yield$getSigners4[0];
            mgm = _yield$getSigners4[1];
            accounts = _yield$getSigners4.slice(2);
            _context3.next = 9;
            return deployPersistent({
              deployer: deployer
            });

          case 9:
            persistent = _context3.sent;
            _context3.next = 12;
            return configureForkRelease({
              provider: provider,
              dispatcher: persistent.dispatcher,
              deployer: deployer,
              mgm: mgm,
              accounts: accounts
            });

          case 12:
            config = _context3.sent;
            _context3.next = 15;
            return deployRelease(config);

          case 15:
            release = _context3.sent;
            _context3.next = 18;
            return persistent.dispatcher.setCurrentFundDeployer(release.fundDeployer);

          case 18:
            return _context3.abrupt("return", {
              config: config,
              accounts: accounts,
              deployment: _objectSpread2(_objectSpread2({}, persistent), release)
            });

          case 19:
          case "end":
            return _context3.stop();
        }
      }
    }, _callee3);
  }));
  return _defaultForkDeployment.apply(this, arguments);
}

function updateChainlinkAggregator(_x, _x2) {
  return _updateChainlinkAggregator.apply(this, arguments);
}

function _updateChainlinkAggregator() {
  _updateChainlinkAggregator = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee(aggregator, price) {
    var answer, block;
    return regeneratorRuntime.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            if (!(price !== null && price !== void 0)) {
              _context.next = 4;
              break;
            }

            _context.t0 = price;
            _context.next = 7;
            break;

          case 4:
            _context.next = 6;
            return aggregator.latestAnswer();

          case 6:
            _context.t0 = _context.sent;

          case 7:
            answer = _context.t0;
            _context.next = 10;
            return aggregator.provider.getBlock('latest');

          case 10:
            block = _context.sent;
            _context.next = 13;
            return aggregator.setLatestAnswer(answer, block.timestamp);

          case 13:
          case "end":
            return _context.stop();
        }
      }
    }, _callee);
  }));
  return _updateChainlinkAggregator.apply(this, arguments);
}

function seedAndThawEngine(_x, _x2, _x3) {
  return _seedAndThawEngine.apply(this, arguments);
}

function _seedAndThawEngine() {
  _seedAndThawEngine = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee(provider, engine, amount) {
    return regeneratorRuntime.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            _context.next = 2;
            return engine.payAmguInEther.value(amount).send();

          case 2:
            _context.next = 4;
            return warpEngine(provider, engine);

          case 4:
            _context.next = 6;
            return engine.thaw();

          case 6:
          case "end":
            return _context.stop();
        }
      }
    }, _callee);
  }));
  return _seedAndThawEngine.apply(this, arguments);
}

function warpEngine(_x4, _x5) {
  return _warpEngine.apply(this, arguments);
}

function _warpEngine() {
  _warpEngine = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee2(provider, engine) {
    var delay, warp;
    return regeneratorRuntime.wrap(function _callee2$(_context2) {
      while (1) {
        switch (_context2.prev = _context2.next) {
          case 0:
            _context2.next = 2;
            return engine.getThawDelay();

          case 2:
            delay = _context2.sent;
            warp = delay.add(1).toNumber();
            _context2.next = 6;
            return provider.send('evm_increaseTime', [warp]);

          case 6:
            _context2.next = 8;
            return provider.send('evm_mine', []);

          case 8:
          case "end":
            return _context2.stop();
        }
      }
    }, _callee2);
  }));
  return _warpEngine.apply(this, arguments);
}

function callOnExtension(_x) {
  return _callOnExtension.apply(this, arguments);
}

function _callOnExtension() {
  _callOnExtension = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee(_ref) {
    var comptrollerProxy, extension, actionId, _ref$callArgs, callArgs, signer, callOnExtensionTx;

    return regeneratorRuntime.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            comptrollerProxy = _ref.comptrollerProxy, extension = _ref.extension, actionId = _ref.actionId, _ref$callArgs = _ref.callArgs, callArgs = _ref$callArgs === void 0 ? '0x' : _ref$callArgs, signer = _ref.signer;

            if (signer) {
              callOnExtensionTx = comptrollerProxy.connect(signer).callOnExtension(extension, actionId, callArgs);
            } else {
              callOnExtensionTx = comptrollerProxy.callOnExtension(extension, actionId, callArgs);
            }

            _context.next = 4;
            return expect(callOnExtensionTx).resolves.toBeReceipt();

          case 4:
            return _context.abrupt("return", callOnExtensionTx);

          case 5:
          case "end":
            return _context.stop();
        }
      }
    }, _callee);
  }));
  return _callOnExtension.apply(this, arguments);
}

var feeHooks;

(function (feeHooks) {
  feeHooks[feeHooks["Continuous"] = 0] = "Continuous";
  feeHooks[feeHooks["PreBuyShares"] = 1] = "PreBuyShares";
  feeHooks[feeHooks["PostBuyShares"] = 2] = "PostBuyShares";
  feeHooks[feeHooks["PreRedeemShares"] = 3] = "PreRedeemShares";
})(feeHooks || (feeHooks = {}));

var feeManagerActionIds;

(function (feeManagerActionIds) {
  feeManagerActionIds[feeManagerActionIds["SettleContinuousFees"] = 0] = "SettleContinuousFees";
})(feeManagerActionIds || (feeManagerActionIds = {}));

var feeSettlementTypes;

(function (feeSettlementTypes) {
  feeSettlementTypes[feeSettlementTypes["None"] = 0] = "None";
  feeSettlementTypes[feeSettlementTypes["Direct"] = 1] = "Direct";
  feeSettlementTypes[feeSettlementTypes["Mint"] = 2] = "Mint";
  feeSettlementTypes[feeSettlementTypes["MintSharesOutstanding"] = 3] = "MintSharesOutstanding";
  feeSettlementTypes[feeSettlementTypes["BurnSharesOutstanding"] = 4] = "BurnSharesOutstanding";
})(feeSettlementTypes || (feeSettlementTypes = {}));

function generateFeeManagerConfigWithMockFees(_x) {
  return _generateFeeManagerConfigWithMockFees.apply(this, arguments);
}

function _generateFeeManagerConfigWithMockFees() {
  _generateFeeManagerConfigWithMockFees = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee(_ref) {
    var deployer, feeManager, fees, feeManagerSettingsData;
    return regeneratorRuntime.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            deployer = _ref.deployer, feeManager = _ref.feeManager;
            _context.next = 3;
            return generateRegisteredMockFees({
              deployer: deployer,
              feeManager: feeManager
            });

          case 3:
            fees = _context.sent;
            feeManagerSettingsData = [utils.randomBytes(10), '0x', utils.randomBytes(2)];
            _context.next = 7;
            return encodeArgs(['address[]', 'bytes[]'], [Object.values(fees), feeManagerSettingsData]);

          case 7:
            return _context.abrupt("return", _context.sent);

          case 8:
          case "end":
            return _context.stop();
        }
      }
    }, _callee);
  }));
  return _generateFeeManagerConfigWithMockFees.apply(this, arguments);
}

function generateRegisteredMockFees(_x2) {
  return _generateRegisteredMockFees.apply(this, arguments);
}

function _generateRegisteredMockFees() {
  _generateRegisteredMockFees = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee2(_ref2) {
    var deployer, feeManager, mockContinuousFee1, mockContinuousFee2, mockPostBuySharesFee;
    return regeneratorRuntime.wrap(function _callee2$(_context2) {
      while (1) {
        switch (_context2.prev = _context2.next) {
          case 0:
            deployer = _ref2.deployer, feeManager = _ref2.feeManager;
            _context2.next = 3;
            return IFee.mock(deployer);

          case 3:
            mockContinuousFee1 = _context2.sent;
            _context2.next = 6;
            return IFee.mock(deployer);

          case 6:
            mockContinuousFee2 = _context2.sent;
            _context2.next = 9;
            return IFee.mock(deployer);

          case 9:
            mockPostBuySharesFee = _context2.sent;
            _context2.next = 12;
            return Promise.all([// Continuous fee 1
            mockContinuousFee1.identifier.returns("MOCK_CONTINUOUS_1"), mockContinuousFee1.settle.returns(feeSettlementTypes.None, constants.AddressZero, 0), mockContinuousFee1.payout.returns(false), mockContinuousFee1.addFundSettings.returns(undefined), mockContinuousFee1.activateForFund.returns(undefined), mockContinuousFee1.implementedHooks.returns([feeHooks.Continuous, feeHooks.PreBuyShares, feeHooks.PreRedeemShares]), // Continuous fee 2
            mockContinuousFee2.identifier.returns("MOCK_CONTINUOUS_2"), mockContinuousFee2.settle.returns(feeSettlementTypes.None, constants.AddressZero, 0), mockContinuousFee2.payout.returns(false), mockContinuousFee2.addFundSettings.returns(undefined), mockContinuousFee2.activateForFund.returns(undefined), mockContinuousFee2.implementedHooks.returns([feeHooks.Continuous, feeHooks.PreBuyShares, feeHooks.PreRedeemShares]), // PostBuyShares fee
            mockPostBuySharesFee.identifier.returns("MOCK_POST_BUY_SHARES"), mockPostBuySharesFee.settle.returns(feeSettlementTypes.None, constants.AddressZero, 0), mockPostBuySharesFee.payout.returns(false), mockPostBuySharesFee.addFundSettings.returns(undefined), mockPostBuySharesFee.activateForFund.returns(undefined), mockPostBuySharesFee.implementedHooks.returns([feeHooks.PostBuyShares])]);

          case 12:
            _context2.next = 14;
            return feeManager.registerFees([mockContinuousFee1, mockContinuousFee2, mockPostBuySharesFee]);

          case 14:
            return _context2.abrupt("return", {
              mockContinuousFee1: mockContinuousFee1,
              mockContinuousFee2: mockContinuousFee2,
              mockPostBuySharesFee: mockPostBuySharesFee
            });

          case 15:
          case "end":
            return _context2.stop();
        }
      }
    }, _callee2);
  }));
  return _generateRegisteredMockFees.apply(this, arguments);
}

function settlePreBuySharesArgs(_ref3) {
  var _ref3$buyer = _ref3.buyer,
      buyer = _ref3$buyer === void 0 ? randomAddress() : _ref3$buyer,
      _ref3$investmentAmoun = _ref3.investmentAmount,
      investmentAmount = _ref3$investmentAmoun === void 0 ? utils.parseEther('1') : _ref3$investmentAmoun,
      _ref3$minSharesQuanti = _ref3.minSharesQuantity,
      minSharesQuantity = _ref3$minSharesQuanti === void 0 ? utils.parseEther('1') : _ref3$minSharesQuanti,
      _ref3$gav = _ref3.gav,
      gav = _ref3$gav === void 0 ? 0 : _ref3$gav;
  return encodeArgs(['address', 'uint256', 'uint256', 'uint256'], [buyer, investmentAmount, minSharesQuantity, gav]);
}
function settlePostBuySharesArgs(_ref4) {
  var _ref4$buyer = _ref4.buyer,
      buyer = _ref4$buyer === void 0 ? randomAddress() : _ref4$buyer,
      _ref4$investmentAmoun = _ref4.investmentAmount,
      investmentAmount = _ref4$investmentAmoun === void 0 ? utils.parseEther('1') : _ref4$investmentAmoun,
      _ref4$sharesBought = _ref4.sharesBought,
      sharesBought = _ref4$sharesBought === void 0 ? utils.parseEther('1') : _ref4$sharesBought;
  return encodeArgs(['address', 'uint256', 'uint256'], [buyer, investmentAmount, sharesBought]);
}
function sharesDueWithInflation(_ref5) {
  var rawSharesDue = _ref5.rawSharesDue,
      sharesSupply = _ref5.sharesSupply;

  if (rawSharesDue == BigNumber.from(0) || sharesSupply == BigNumber.from(0)) {
    return 0;
  }

  return rawSharesDue.mul(sharesSupply).div(sharesSupply.sub(rawSharesDue));
}
var settleContinuousFeesFragment = utils.FunctionFragment.fromString('settleContinuousFees(address,bytes)');
var settleContinuousFeesSelector = sighash(settleContinuousFeesFragment);

function entranceRateFeeConfigArgs(_x) {
  return _entranceRateFeeConfigArgs.apply(this, arguments);
}

function _entranceRateFeeConfigArgs() {
  _entranceRateFeeConfigArgs = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee(rate) {
    return regeneratorRuntime.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            return _context.abrupt("return", encodeArgs(['uint256'], [rate]));

          case 1:
          case "end":
            return _context.stop();
        }
      }
    }, _callee);
  }));
  return _entranceRateFeeConfigArgs.apply(this, arguments);
}

function entranceRateFeeSharesDue(_ref) {
  var rate = _ref.rate,
      sharesBought = _ref.sharesBought;
  return BigNumber.from(sharesBought).mul(rate).div(utils.parseEther('1'));
}

function managementFeeConfigArgs(_x) {
  return _managementFeeConfigArgs.apply(this, arguments);
}

function _managementFeeConfigArgs() {
  _managementFeeConfigArgs = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee(rate) {
    return regeneratorRuntime.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            return _context.abrupt("return", encodeArgs(['uint256'], [rate]));

          case 1:
          case "end":
            return _context.stop();
        }
      }
    }, _callee);
  }));
  return _managementFeeConfigArgs.apply(this, arguments);
}

function managementFeeSharesDue(_ref) {
  var rate = _ref.rate,
      sharesSupply = _ref.sharesSupply,
      secondsSinceLastSettled = _ref.secondsSinceLastSettled;
  var yearlyRawSharesDue = BigNumber.from(sharesSupply).mul(rate).div(utils.parseEther('1'));
  var rawSharesDue = yearlyRawSharesDue.mul(secondsSinceLastSettled).div(60 * 60 * 24 * 365);
  return sharesDueWithInflation({
    rawSharesDue: rawSharesDue,
    sharesSupply: sharesSupply
  });
}

function performanceFeeConfigArgs(_x) {
  return _performanceFeeConfigArgs.apply(this, arguments);
}

function _performanceFeeConfigArgs() {
  _performanceFeeConfigArgs = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee(_ref) {
    var rate, period;
    return regeneratorRuntime.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            rate = _ref.rate, period = _ref.period;
            return _context.abrupt("return", encodeArgs(['uint256', 'uint256'], [rate, period]));

          case 2:
          case "end":
            return _context.stop();
        }
      }
    }, _callee);
  }));
  return _performanceFeeConfigArgs.apply(this, arguments);
}

function performanceFeeSharesDue(_ref2) {
  var rate = _ref2.rate,
      totalSharesSupply = _ref2.totalSharesSupply,
      sharesOutstanding = _ref2.sharesOutstanding,
      gav = _ref2.gav,
      highWaterMark = _ref2.highWaterMark,
      prevSharePrice = _ref2.prevSharePrice,
      prevAggregateValueDue = _ref2.prevAggregateValueDue,
      _ref2$denominationAss = _ref2.denominationAssetDecimals,
      denominationAssetDecimals = _ref2$denominationAss === void 0 ? 18 : _ref2$denominationAss,
      _ref2$feeHook = _ref2.feeHook,
      feeHook = _ref2$feeHook === void 0 ? feeHooks.Continuous : _ref2$feeHook,
      settlementInfo = _ref2.settlementInfo;
  var rateDivisor = utils.parseEther('1');
  var shareUnit = utils.parseEther('1');
  var netSharesSupply = BigNumber.from(totalSharesSupply).sub(sharesOutstanding);
  var sharePriceWithoutPerformance = BigNumber.from(gav).mul(shareUnit).div(netSharesSupply); // Accrued value

  var superHWMValueSinceLastSettled = bigNumberMax([highWaterMark, sharePriceWithoutPerformance]).sub(bigNumberMax([highWaterMark, prevSharePrice])).mul(netSharesSupply).div(shareUnit);
  var valueDueSinceLastSettled = superHWMValueSinceLastSettled.mul(rate).div(rateDivisor);
  var nextAggregateValueDue = bigNumberMax([0, valueDueSinceLastSettled.add(prevAggregateValueDue)]); // Shares due

  var sharesDueForAggregateValueDue = sharesDueWithInflation({
    rawSharesDue: nextAggregateValueDue.mul(netSharesSupply).div(gav),
    sharesSupply: netSharesSupply
  });
  var sharesDue = BigNumber.from(sharesDueForAggregateValueDue).sub(sharesOutstanding); // Next share price

  var nextSharePrice = BigNumber.from(0);

  if (feeHook == feeHooks.Continuous) {
    nextSharePrice = sharePriceWithoutPerformance;
  } else {
    var sharesSupplyWithSharesDue = sharesDue.add(totalSharesSupply);
    var denominationAssetUnit = BigNumber.from(10).pow(denominationAssetDecimals);
    var nextNetSharesSupply = BigNumber.from(0);
    var nextGav = BigNumber.from(0);

    if (feeHook == feeHooks.PreBuyShares) {
      var gavIncrease = settlementInfo.buySharesInvestmentAmount;
      nextGav = BigNumber.from(gav).add(gavIncrease);
      var sharesIncrease = BigNumber.from(gavIncrease).mul(denominationAssetUnit).mul(sharesSupplyWithSharesDue).div(gav).div(shareUnit);
      nextNetSharesSupply = netSharesSupply.add(sharesIncrease);
    } else if (feeHook == feeHooks.PreRedeemShares) {
      var sharesDecrease = settlementInfo.redeemSharesSharesAmount;
      nextNetSharesSupply = netSharesSupply.sub(sharesDecrease);
      var gavDecrease = BigNumber.from(sharesDecrease).mul(gav).mul(shareUnit).div(sharesSupplyWithSharesDue).div(denominationAssetUnit);
      nextGav = BigNumber.from(gav).sub(gavDecrease);
    } else {
      throw 'No valid feeHook passed';
    }

    nextSharePrice = nextGav.mul(shareUnit).div(nextNetSharesSupply);
  }

  return {
    sharesDue: sharesDue,
    nextAggregateValueDue: nextAggregateValueDue,
    nextSharePrice: nextSharePrice
  };
}

var integrationManagerActionIds;

(function (integrationManagerActionIds) {
  integrationManagerActionIds[integrationManagerActionIds["CallOnIntegration"] = 0] = "CallOnIntegration";
})(integrationManagerActionIds || (integrationManagerActionIds = {}));

var spendAssetsHandleTypes; // prettier-ignore

(function (spendAssetsHandleTypes) {
  spendAssetsHandleTypes[spendAssetsHandleTypes["None"] = 0] = "None";
  spendAssetsHandleTypes[spendAssetsHandleTypes["Approve"] = 1] = "Approve";
  spendAssetsHandleTypes[spendAssetsHandleTypes["Transfer"] = 2] = "Transfer";
})(spendAssetsHandleTypes || (spendAssetsHandleTypes = {}));

var callOnIntegrationFragment = utils.FunctionFragment.fromString('callOnIntegration(address,bytes)');
var addTrackedAssetsFragment = utils.FunctionFragment.fromString('addTrackedAssets(address,bytes,bytes)');
var lendFragment = utils.FunctionFragment.fromString('lend(address,bytes,bytes)');
var redeemFragment = utils.FunctionFragment.fromString('redeem(address,bytes,bytes)');
var takeOrderFragment = utils.FunctionFragment.fromString('takeOrder(address,bytes,bytes)');
var callOnIntegrationSelector = sighash(callOnIntegrationFragment);
var addTrackedAssetsSelector = sighash(addTrackedAssetsFragment);
var takeOrderSelector = sighash(takeOrderFragment);
var redeemSelector = sighash(redeemFragment);
var lendSelector = sighash(lendFragment);
function assetTransferArgs(_x) {
  return _assetTransferArgs.apply(this, arguments);
}

function _assetTransferArgs() {
  _assetTransferArgs = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee(_ref) {
    var adapter, selector, encodedCallArgs, _yield$adapter$parseA, spendAssets_, spendAssetAmounts_, incomingAssets_;

    return regeneratorRuntime.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            adapter = _ref.adapter, selector = _ref.selector, encodedCallArgs = _ref.encodedCallArgs;
            _context.next = 3;
            return adapter.parseAssetsForMethod(selector, encodedCallArgs);

          case 3:
            _yield$adapter$parseA = _context.sent;
            spendAssets_ = _yield$adapter$parseA.spendAssets_;
            spendAssetAmounts_ = _yield$adapter$parseA.spendAssetAmounts_;
            incomingAssets_ = _yield$adapter$parseA.incomingAssets_;
            return _context.abrupt("return", encodeArgs(['address[]', 'uint[]', 'address[]'], [spendAssets_, spendAssetAmounts_, incomingAssets_]));

          case 8:
          case "end":
            return _context.stop();
        }
      }
    }, _callee);
  }));
  return _assetTransferArgs.apply(this, arguments);
}

function callOnIntegrationArgs(_ref2) {
  var adapter = _ref2.adapter,
      selector = _ref2.selector,
      encodedCallArgs = _ref2.encodedCallArgs;
  return encodeArgs(['address', 'bytes4', 'bytes'], [adapter, selector, encodedCallArgs]);
}

function chaiLendArgs(_x) {
  return _chaiLendArgs.apply(this, arguments);
}

function _chaiLendArgs() {
  _chaiLendArgs = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee(_ref) {
    var outgoingDaiAmount, expectedIncomingChaiAmount;
    return regeneratorRuntime.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            outgoingDaiAmount = _ref.outgoingDaiAmount, expectedIncomingChaiAmount = _ref.expectedIncomingChaiAmount;
            return _context.abrupt("return", encodeArgs(['uint256', 'uint256'], [outgoingDaiAmount, expectedIncomingChaiAmount]));

          case 2:
          case "end":
            return _context.stop();
        }
      }
    }, _callee);
  }));
  return _chaiLendArgs.apply(this, arguments);
}

function chaiRedeemArgs(_x2) {
  return _chaiRedeemArgs.apply(this, arguments);
}

function _chaiRedeemArgs() {
  _chaiRedeemArgs = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee2(_ref2) {
    var outgoingChaiAmount, expectedIncomingDaiAmount;
    return regeneratorRuntime.wrap(function _callee2$(_context2) {
      while (1) {
        switch (_context2.prev = _context2.next) {
          case 0:
            outgoingChaiAmount = _ref2.outgoingChaiAmount, expectedIncomingDaiAmount = _ref2.expectedIncomingDaiAmount;
            return _context2.abrupt("return", encodeArgs(['uint256', 'uint256'], [outgoingChaiAmount, expectedIncomingDaiAmount]));

          case 2:
          case "end":
            return _context2.stop();
        }
      }
    }, _callee2);
  }));
  return _chaiRedeemArgs.apply(this, arguments);
}

function chaiLend(_x3) {
  return _chaiLend.apply(this, arguments);
}

function _chaiLend() {
  _chaiLend = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee3(_ref3) {
    var comptrollerProxy, vaultProxy, integrationManager, fundOwner, chaiAdapter, dai, _ref3$daiAmount, daiAmount, _ref3$minChaiAmount, minChaiAmount, _ref3$seedFund, seedFund, lendArgs, callArgs, lendTx;

    return regeneratorRuntime.wrap(function _callee3$(_context3) {
      while (1) {
        switch (_context3.prev = _context3.next) {
          case 0:
            comptrollerProxy = _ref3.comptrollerProxy, vaultProxy = _ref3.vaultProxy, integrationManager = _ref3.integrationManager, fundOwner = _ref3.fundOwner, chaiAdapter = _ref3.chaiAdapter, dai = _ref3.dai, _ref3$daiAmount = _ref3.daiAmount, daiAmount = _ref3$daiAmount === void 0 ? utils.parseEther('1') : _ref3$daiAmount, _ref3$minChaiAmount = _ref3.minChaiAmount, minChaiAmount = _ref3$minChaiAmount === void 0 ? utils.parseEther('1') : _ref3$minChaiAmount, _ref3$seedFund = _ref3.seedFund, seedFund = _ref3$seedFund === void 0 ? false : _ref3$seedFund;

            if (!seedFund) {
              _context3.next = 4;
              break;
            }

            _context3.next = 4;
            return dai.transfer(vaultProxy, daiAmount);

          case 4:
            _context3.next = 6;
            return chaiLendArgs({
              outgoingDaiAmount: daiAmount,
              expectedIncomingChaiAmount: minChaiAmount
            });

          case 6:
            lendArgs = _context3.sent;
            _context3.next = 9;
            return callOnIntegrationArgs({
              adapter: chaiAdapter,
              selector: lendSelector,
              encodedCallArgs: lendArgs
            });

          case 9:
            callArgs = _context3.sent;
            lendTx = comptrollerProxy.connect(fundOwner).callOnExtension(integrationManager, integrationManagerActionIds.CallOnIntegration, callArgs);
            _context3.next = 13;
            return expect(lendTx).resolves.toBeReceipt();

          case 13:
            return _context3.abrupt("return", lendTx);

          case 14:
          case "end":
            return _context3.stop();
        }
      }
    }, _callee3);
  }));
  return _chaiLend.apply(this, arguments);
}

function chaiRedeem(_x4) {
  return _chaiRedeem.apply(this, arguments);
}

function _chaiRedeem() {
  _chaiRedeem = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee4(_ref4) {
    var comptrollerProxy, vaultProxy, integrationManager, fundOwner, chaiAdapter, chai, _ref4$chaiAmount, chaiAmount, _ref4$minDaiAmount, minDaiAmount, _ref4$seedFund, seedFund, redeemArgs, callArgs, redeemTx;

    return regeneratorRuntime.wrap(function _callee4$(_context4) {
      while (1) {
        switch (_context4.prev = _context4.next) {
          case 0:
            comptrollerProxy = _ref4.comptrollerProxy, vaultProxy = _ref4.vaultProxy, integrationManager = _ref4.integrationManager, fundOwner = _ref4.fundOwner, chaiAdapter = _ref4.chaiAdapter, chai = _ref4.chai, _ref4$chaiAmount = _ref4.chaiAmount, chaiAmount = _ref4$chaiAmount === void 0 ? utils.parseEther('1') : _ref4$chaiAmount, _ref4$minDaiAmount = _ref4.minDaiAmount, minDaiAmount = _ref4$minDaiAmount === void 0 ? utils.parseEther('1') : _ref4$minDaiAmount, _ref4$seedFund = _ref4.seedFund, seedFund = _ref4$seedFund === void 0 ? false : _ref4$seedFund;

            if (!seedFund) {
              _context4.next = 4;
              break;
            }

            _context4.next = 4;
            return chai.transfer(vaultProxy, chaiAmount);

          case 4:
            _context4.next = 6;
            return chaiRedeemArgs({
              outgoingChaiAmount: chaiAmount,
              expectedIncomingDaiAmount: minDaiAmount
            });

          case 6:
            redeemArgs = _context4.sent;
            _context4.next = 9;
            return callOnIntegrationArgs({
              adapter: chaiAdapter,
              selector: redeemSelector,
              encodedCallArgs: redeemArgs
            });

          case 9:
            callArgs = _context4.sent;
            redeemTx = comptrollerProxy.connect(fundOwner).callOnExtension(integrationManager, integrationManagerActionIds.CallOnIntegration, callArgs);
            _context4.next = 13;
            return expect(redeemTx).resolves.toBeReceipt();

          case 13:
            return _context4.abrupt("return", redeemTx);

          case 14:
          case "end":
            return _context4.stop();
        }
      }
    }, _callee4);
  }));
  return _chaiRedeem.apply(this, arguments);
}

function engineTakeOrderArgs(_x5, _x6) {
  return _engineTakeOrderArgs.apply(this, arguments);
}

function _engineTakeOrderArgs() {
  _engineTakeOrderArgs = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee5(minNativeAssetAmount, mlnTokenAmount) {
    return regeneratorRuntime.wrap(function _callee5$(_context5) {
      while (1) {
        switch (_context5.prev = _context5.next) {
          case 0:
            return _context5.abrupt("return", encodeArgs(['uint256', 'uint256'], [minNativeAssetAmount, mlnTokenAmount]));

          case 1:
          case "end":
            return _context5.stop();
        }
      }
    }, _callee5);
  }));
  return _engineTakeOrderArgs.apply(this, arguments);
}

function engineAdapterTakeOrderArgs(_x) {
  return _engineAdapterTakeOrderArgs.apply(this, arguments);
}

function _engineAdapterTakeOrderArgs() {
  _engineAdapterTakeOrderArgs = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee(_ref) {
    var minWethAmount, mlnAmount;
    return regeneratorRuntime.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            minWethAmount = _ref.minWethAmount, mlnAmount = _ref.mlnAmount;
            return _context.abrupt("return", encodeArgs(['uint256', 'uint256'], [minWethAmount, mlnAmount]));

          case 2:
          case "end":
            return _context.stop();
        }
      }
    }, _callee);
  }));
  return _engineAdapterTakeOrderArgs.apply(this, arguments);
}

function engineAdapterTakeOrder(_x2) {
  return _engineAdapterTakeOrder.apply(this, arguments);
}

function _engineAdapterTakeOrder() {
  _engineAdapterTakeOrder = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee2(_ref2) {
    var comptrollerProxy, vaultProxy, integrationManager, fundOwner, engineAdapter, mln, _ref2$mlnAmount, mlnAmount, _ref2$minWethAmount, minWethAmount, _ref2$seedFund, seedFund, takeOrderArgs, callArgs, takeOrderTx;

    return regeneratorRuntime.wrap(function _callee2$(_context2) {
      while (1) {
        switch (_context2.prev = _context2.next) {
          case 0:
            comptrollerProxy = _ref2.comptrollerProxy, vaultProxy = _ref2.vaultProxy, integrationManager = _ref2.integrationManager, fundOwner = _ref2.fundOwner, engineAdapter = _ref2.engineAdapter, mln = _ref2.mln, _ref2$mlnAmount = _ref2.mlnAmount, mlnAmount = _ref2$mlnAmount === void 0 ? utils.parseEther('1') : _ref2$mlnAmount, _ref2$minWethAmount = _ref2.minWethAmount, minWethAmount = _ref2$minWethAmount === void 0 ? utils.parseEther('1') : _ref2$minWethAmount, _ref2$seedFund = _ref2.seedFund, seedFund = _ref2$seedFund === void 0 ? false : _ref2$seedFund;

            if (!seedFund) {
              _context2.next = 4;
              break;
            }

            _context2.next = 4;
            return mln.transfer(vaultProxy, mlnAmount);

          case 4:
            _context2.next = 6;
            return engineAdapterTakeOrderArgs({
              minWethAmount: minWethAmount,
              mlnAmount: mlnAmount
            });

          case 6:
            takeOrderArgs = _context2.sent;
            _context2.next = 9;
            return callOnIntegrationArgs({
              adapter: engineAdapter,
              selector: takeOrderSelector,
              encodedCallArgs: takeOrderArgs
            });

          case 9:
            callArgs = _context2.sent;
            takeOrderTx = comptrollerProxy.connect(fundOwner).callOnExtension(integrationManager, integrationManagerActionIds.CallOnIntegration, callArgs);
            _context2.next = 13;
            return expect(takeOrderTx).resolves.toBeReceipt();

          case 13:
            return _context2.abrupt("return", takeOrderTx);

          case 14:
          case "end":
            return _context2.stop();
        }
      }
    }, _callee2);
  }));
  return _engineAdapterTakeOrder.apply(this, arguments);
}

function _taggedTemplateLiteral(strings, raw) {
  if (!raw) {
    raw = strings.slice(0);
  }

  return Object.freeze(Object.defineProperties(strings, {
    raw: {
      value: Object.freeze(raw)
    }
  }));
}

function _templateObject() {
  var data = _taggedTemplateLiteral(["\n  function getExpectedRate(address src, address dest, uint256 srcQty) view returns (uint256 expectedRate, uint256 worstRate)\n"]);

  _templateObject = function _templateObject() {
    return data;
  };

  return data;
}

var IKyberNetworkProxy = contract()(_templateObject());
function kyberTakeOrderArgs(_x) {
  return _kyberTakeOrderArgs.apply(this, arguments);
}

function _kyberTakeOrderArgs() {
  _kyberTakeOrderArgs = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee(_ref) {
    var incomingAsset, minIncomingAssetAmount, outgoingAsset, outgoingAssetAmount;
    return regeneratorRuntime.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            incomingAsset = _ref.incomingAsset, minIncomingAssetAmount = _ref.minIncomingAssetAmount, outgoingAsset = _ref.outgoingAsset, outgoingAssetAmount = _ref.outgoingAssetAmount;
            return _context.abrupt("return", encodeArgs(['address', 'uint256', 'address', 'uint256'], [incomingAsset, minIncomingAssetAmount, outgoingAsset, outgoingAssetAmount]));

          case 2:
          case "end":
            return _context.stop();
        }
      }
    }, _callee);
  }));
  return _kyberTakeOrderArgs.apply(this, arguments);
}

function kyberTakeOrder(_x2) {
  return _kyberTakeOrder.apply(this, arguments);
}

function _kyberTakeOrder() {
  _kyberTakeOrder = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee2(_ref2) {
    var comptrollerProxy, vaultProxy, integrationManager, fundOwner, kyberAdapter, outgoingAsset, _ref2$outgoingAssetAm, outgoingAssetAmount, incomingAsset, _ref2$minIncomingAsse, minIncomingAssetAmount, _ref2$seedFund, seedFund, takeOrderArgs, callArgs, takeOrderTx;

    return regeneratorRuntime.wrap(function _callee2$(_context2) {
      while (1) {
        switch (_context2.prev = _context2.next) {
          case 0:
            comptrollerProxy = _ref2.comptrollerProxy, vaultProxy = _ref2.vaultProxy, integrationManager = _ref2.integrationManager, fundOwner = _ref2.fundOwner, kyberAdapter = _ref2.kyberAdapter, outgoingAsset = _ref2.outgoingAsset, _ref2$outgoingAssetAm = _ref2.outgoingAssetAmount, outgoingAssetAmount = _ref2$outgoingAssetAm === void 0 ? utils.parseEther('1') : _ref2$outgoingAssetAm, incomingAsset = _ref2.incomingAsset, _ref2$minIncomingAsse = _ref2.minIncomingAssetAmount, minIncomingAssetAmount = _ref2$minIncomingAsse === void 0 ? utils.parseEther('1') : _ref2$minIncomingAsse, _ref2$seedFund = _ref2.seedFund, seedFund = _ref2$seedFund === void 0 ? false : _ref2$seedFund;

            if (!seedFund) {
              _context2.next = 4;
              break;
            }

            _context2.next = 4;
            return outgoingAsset.transfer(vaultProxy, outgoingAssetAmount);

          case 4:
            _context2.next = 6;
            return kyberTakeOrderArgs({
              incomingAsset: incomingAsset,
              minIncomingAssetAmount: minIncomingAssetAmount,
              outgoingAsset: outgoingAsset,
              outgoingAssetAmount: outgoingAssetAmount
            });

          case 6:
            takeOrderArgs = _context2.sent;
            _context2.next = 9;
            return callOnIntegrationArgs({
              adapter: kyberAdapter,
              selector: takeOrderSelector,
              encodedCallArgs: takeOrderArgs
            });

          case 9:
            callArgs = _context2.sent;
            takeOrderTx = comptrollerProxy.connect(fundOwner).callOnExtension(integrationManager, integrationManagerActionIds.CallOnIntegration, callArgs);
            _context2.next = 13;
            return expect(takeOrderTx).resolves.toBeReceipt();

          case 13:
            return _context2.abrupt("return", takeOrderTx);

          case 14:
          case "end":
            return _context2.stop();
        }
      }
    }, _callee2);
  }));
  return _kyberTakeOrder.apply(this, arguments);
}

var mockGenericSwapASelector = sighash(utils.FunctionFragment.fromString('swapA(address,bytes,bytes)'));
var mockGenericSwapBSelector = sighash(utils.FunctionFragment.fromString('swapB(address,bytes,bytes)'));
var mockGenericSwapCSelector = sighash(utils.FunctionFragment.fromString('swapC(address,bytes,bytes)'));
function mockGenericSwapArgs(_x) {
  return _mockGenericSwapArgs.apply(this, arguments);
}

function _mockGenericSwapArgs() {
  _mockGenericSwapArgs = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee(_ref) {
    var spendAssets, spendAssetAmounts, incomingAssets, minIncomingAssetAmounts, incomingAssetAmounts;
    return regeneratorRuntime.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            spendAssets = _ref.spendAssets, spendAssetAmounts = _ref.spendAssetAmounts, incomingAssets = _ref.incomingAssets, minIncomingAssetAmounts = _ref.minIncomingAssetAmounts, incomingAssetAmounts = _ref.incomingAssetAmounts;
            return _context.abrupt("return", encodeArgs(['address[]', 'uint256[]', 'address[]', 'uint256[]', 'uint256[]'], [spendAssets, spendAssetAmounts, incomingAssets, minIncomingAssetAmounts, incomingAssetAmounts]));

          case 2:
          case "end":
            return _context.stop();
        }
      }
    }, _callee);
  }));
  return _mockGenericSwapArgs.apply(this, arguments);
}

function mockGenericSwap(_x2) {
  return _mockGenericSwap.apply(this, arguments);
}

function _mockGenericSwap() {
  _mockGenericSwap = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee2(_ref2) {
    var comptrollerProxy, vaultProxy, integrationManager, fundOwner, mockGenericAdapter, _ref2$selector, selector, _ref2$spendAssets, spendAssets, _ref2$spendAssetAmoun, spendAssetAmounts, _ref2$incomingAssets, incomingAssets, _ref2$minIncomingAsse, minIncomingAssetAmounts, _ref2$actualIncomingA, actualIncomingAssetAmounts, _ref2$seedFund, seedFund, key, swapArgs, callArgs, swapTx;

    return regeneratorRuntime.wrap(function _callee2$(_context2) {
      while (1) {
        switch (_context2.prev = _context2.next) {
          case 0:
            comptrollerProxy = _ref2.comptrollerProxy, vaultProxy = _ref2.vaultProxy, integrationManager = _ref2.integrationManager, fundOwner = _ref2.fundOwner, mockGenericAdapter = _ref2.mockGenericAdapter, _ref2$selector = _ref2.selector, selector = _ref2$selector === void 0 ? mockGenericSwapASelector : _ref2$selector, _ref2$spendAssets = _ref2.spendAssets, spendAssets = _ref2$spendAssets === void 0 ? [] : _ref2$spendAssets, _ref2$spendAssetAmoun = _ref2.spendAssetAmounts, spendAssetAmounts = _ref2$spendAssetAmoun === void 0 ? [] : _ref2$spendAssetAmoun, _ref2$incomingAssets = _ref2.incomingAssets, incomingAssets = _ref2$incomingAssets === void 0 ? [] : _ref2$incomingAssets, _ref2$minIncomingAsse = _ref2.minIncomingAssetAmounts, minIncomingAssetAmounts = _ref2$minIncomingAsse === void 0 ? [] : _ref2$minIncomingAsse, _ref2$actualIncomingA = _ref2.actualIncomingAssetAmounts, actualIncomingAssetAmounts = _ref2$actualIncomingA === void 0 ? [] : _ref2$actualIncomingA, _ref2$seedFund = _ref2.seedFund, seedFund = _ref2$seedFund === void 0 ? false : _ref2$seedFund;

            if (!seedFund) {
              _context2.next = 9;
              break;
            }

            _context2.t0 = regeneratorRuntime.keys(spendAssets);

          case 3:
            if ((_context2.t1 = _context2.t0()).done) {
              _context2.next = 9;
              break;
            }

            key = _context2.t1.value;
            _context2.next = 7;
            return spendAssets[key].transfer(vaultProxy, spendAssetAmounts[key]);

          case 7:
            _context2.next = 3;
            break;

          case 9:
            _context2.next = 11;
            return mockGenericSwapArgs({
              spendAssets: spendAssets,
              spendAssetAmounts: spendAssetAmounts,
              incomingAssets: incomingAssets,
              minIncomingAssetAmounts: minIncomingAssetAmounts,
              incomingAssetAmounts: actualIncomingAssetAmounts
            });

          case 11:
            swapArgs = _context2.sent;
            _context2.next = 14;
            return callOnIntegrationArgs({
              adapter: mockGenericAdapter,
              selector: selector,
              encodedCallArgs: swapArgs
            });

          case 14:
            callArgs = _context2.sent;
            swapTx = comptrollerProxy.connect(fundOwner).callOnExtension(integrationManager, integrationManagerActionIds.CallOnIntegration, callArgs);
            _context2.next = 18;
            return expect(swapTx).resolves.toBeReceipt();

          case 18:
            return _context2.abrupt("return", swapTx);

          case 19:
          case "end":
            return _context2.stop();
        }
      }
    }, _callee2);
  }));
  return _mockGenericSwap.apply(this, arguments);
}

function addTrackedAssetsArgs(_x) {
  return _addTrackedAssetsArgs.apply(this, arguments);
}

function _addTrackedAssetsArgs() {
  _addTrackedAssetsArgs = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee(_ref) {
    var incomingAssets;
    return regeneratorRuntime.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            incomingAssets = _ref.incomingAssets;
            return _context.abrupt("return", encodeArgs(['address[]'], [incomingAssets]));

          case 2:
          case "end":
            return _context.stop();
        }
      }
    }, _callee);
  }));
  return _addTrackedAssetsArgs.apply(this, arguments);
}

function addTrackedAssets(_x2) {
  return _addTrackedAssets.apply(this, arguments);
}

function _addTrackedAssets() {
  _addTrackedAssets = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee2(_ref2) {
    var comptrollerProxy, integrationManager, fundOwner, trackedAssetsAdapter, incomingAssets, args, callArgs, addTrackedAssetsTx;
    return regeneratorRuntime.wrap(function _callee2$(_context2) {
      while (1) {
        switch (_context2.prev = _context2.next) {
          case 0:
            comptrollerProxy = _ref2.comptrollerProxy, integrationManager = _ref2.integrationManager, fundOwner = _ref2.fundOwner, trackedAssetsAdapter = _ref2.trackedAssetsAdapter, incomingAssets = _ref2.incomingAssets;
            _context2.next = 3;
            return addTrackedAssetsArgs({
              incomingAssets: incomingAssets
            });

          case 3:
            args = _context2.sent;
            _context2.next = 6;
            return callOnIntegrationArgs({
              adapter: trackedAssetsAdapter,
              selector: addTrackedAssetsSelector,
              encodedCallArgs: args
            });

          case 6:
            callArgs = _context2.sent;
            addTrackedAssetsTx = comptrollerProxy.connect(fundOwner).callOnExtension(integrationManager, integrationManagerActionIds.CallOnIntegration, callArgs);
            _context2.next = 10;
            return expect(addTrackedAssetsTx).resolves.toBeReceipt();

          case 10:
            return _context2.abrupt("return", addTrackedAssetsTx);

          case 11:
          case "end":
            return _context2.stop();
        }
      }
    }, _callee2);
  }));
  return _addTrackedAssets.apply(this, arguments);
}

function zeroExV2TakeOrder(_x) {
  return _zeroExV2TakeOrder.apply(this, arguments);
}

function _zeroExV2TakeOrder() {
  _zeroExV2TakeOrder = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee(_ref) {
    var comptrollerProxy, integrationManager, fundOwner, zeroExV2Adapter, signedOrder, takerAssetFillAmount, takeOrderArgs, callArgs, takeOrderTx;
    return regeneratorRuntime.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            comptrollerProxy = _ref.comptrollerProxy, integrationManager = _ref.integrationManager, fundOwner = _ref.fundOwner, zeroExV2Adapter = _ref.zeroExV2Adapter, signedOrder = _ref.signedOrder, takerAssetFillAmount = _ref.takerAssetFillAmount;
            _context.next = 3;
            return zeroExV2TakeOrderArgs(signedOrder, takerAssetFillAmount);

          case 3:
            takeOrderArgs = _context.sent;
            _context.next = 6;
            return callOnIntegrationArgs({
              adapter: zeroExV2Adapter,
              selector: takeOrderSelector,
              encodedCallArgs: takeOrderArgs
            });

          case 6:
            callArgs = _context.sent;
            takeOrderTx = comptrollerProxy.connect(fundOwner).callOnExtension(integrationManager, integrationManagerActionIds.CallOnIntegration, callArgs);
            _context.next = 10;
            return expect(takeOrderTx).resolves.toBeReceipt();

          case 10:
            return _context.abrupt("return", takeOrderTx);

          case 11:
          case "end":
            return _context.stop();
        }
      }
    }, _callee);
  }));
  return _zeroExV2TakeOrder.apply(this, arguments);
}

var policyHooks;

(function (policyHooks) {
  policyHooks[policyHooks["PreBuyShares"] = 0] = "PreBuyShares";
  policyHooks[policyHooks["PostBuyShares"] = 1] = "PostBuyShares";
  policyHooks[policyHooks["PreCallOnIntegration"] = 2] = "PreCallOnIntegration";
  policyHooks[policyHooks["PostCallOnIntegration"] = 3] = "PostCallOnIntegration";
})(policyHooks || (policyHooks = {}));

function generatePolicyManagerConfigWithMockPolicies(_x) {
  return _generatePolicyManagerConfigWithMockPolicies.apply(this, arguments);
}

function _generatePolicyManagerConfigWithMockPolicies() {
  _generatePolicyManagerConfigWithMockPolicies = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee(_ref) {
    var deployer, policyManager, policies, policiesSettingsData;
    return regeneratorRuntime.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            deployer = _ref.deployer, policyManager = _ref.policyManager;
            _context.next = 3;
            return generateRegisteredMockPolicies({
              deployer: deployer,
              policyManager: policyManager
            });

          case 3:
            policies = _context.sent;
            policiesSettingsData = [utils.randomBytes(10), constants.HashZero, constants.HashZero, utils.randomBytes(2)];
            return _context.abrupt("return", encodeArgs(['address[]', 'bytes[]'], [Object.values(policies), policiesSettingsData]));

          case 6:
          case "end":
            return _context.stop();
        }
      }
    }, _callee);
  }));
  return _generatePolicyManagerConfigWithMockPolicies.apply(this, arguments);
}

function generateRegisteredMockPolicies(_x2) {
  return _generateRegisteredMockPolicies.apply(this, arguments);
}

function _generateRegisteredMockPolicies() {
  _generateRegisteredMockPolicies = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee2(_ref2) {
    var deployer, policyManager, mockPreBuySharesPolicy, mockPostBuySharesPolicy, mockPreCoIPolicy, mockPostCoIPolicy;
    return regeneratorRuntime.wrap(function _callee2$(_context2) {
      while (1) {
        switch (_context2.prev = _context2.next) {
          case 0:
            deployer = _ref2.deployer, policyManager = _ref2.policyManager;
            _context2.next = 3;
            return IPolicy.mock(deployer);

          case 3:
            mockPreBuySharesPolicy = _context2.sent;
            _context2.next = 6;
            return IPolicy.mock(deployer);

          case 6:
            mockPostBuySharesPolicy = _context2.sent;
            _context2.next = 9;
            return IPolicy.mock(deployer);

          case 9:
            mockPreCoIPolicy = _context2.sent;
            _context2.next = 12;
            return IPolicy.mock(deployer);

          case 12:
            mockPostCoIPolicy = _context2.sent;
            _context2.next = 15;
            return Promise.all([// PreBuyShares
            mockPreBuySharesPolicy.identifier.returns("MOCK_PRE_BUY_SHARES"), mockPreBuySharesPolicy.addFundSettings.returns(undefined), mockPreBuySharesPolicy.activateForFund.returns(undefined), mockPreBuySharesPolicy.validateRule.returns(true), mockPreBuySharesPolicy.implementedHooks.returns([policyHooks.PreBuyShares]), // PostBuyShares
            mockPostBuySharesPolicy.identifier.returns("MOCK_POST_BUY_SHARES"), mockPostBuySharesPolicy.addFundSettings.returns(undefined), mockPostBuySharesPolicy.activateForFund.returns(undefined), mockPostBuySharesPolicy.validateRule.returns(true), mockPostBuySharesPolicy.implementedHooks.returns([policyHooks.PostBuyShares]), // PreCallOnIntegration
            mockPreCoIPolicy.identifier.returns("MOCK_PRE_CALL_ON_INTEGRATION"), mockPreCoIPolicy.addFundSettings.returns(undefined), mockPreCoIPolicy.activateForFund.returns(undefined), mockPreCoIPolicy.validateRule.returns(true), mockPreCoIPolicy.implementedHooks.returns([policyHooks.PreCallOnIntegration]), // PostCallOnIntegration
            mockPostCoIPolicy.identifier.returns("MOCK_POST_CALL_ON_INTEGRATION"), mockPostCoIPolicy.addFundSettings.returns(undefined), mockPostCoIPolicy.activateForFund.returns(undefined), mockPostCoIPolicy.validateRule.returns(true), mockPostCoIPolicy.implementedHooks.returns([policyHooks.PostCallOnIntegration])]);

          case 15:
            _context2.next = 17;
            return policyManager.registerPolicies([mockPreBuySharesPolicy, mockPostBuySharesPolicy, mockPreCoIPolicy, mockPostCoIPolicy]);

          case 17:
            return _context2.abrupt("return", {
              mockPreBuySharesPolicy: mockPreBuySharesPolicy,
              mockPostBuySharesPolicy: mockPostBuySharesPolicy,
              mockPreCoIPolicy: mockPreCoIPolicy,
              mockPostCoIPolicy: mockPostCoIPolicy
            });

          case 18:
          case "end":
            return _context2.stop();
        }
      }
    }, _callee2);
  }));
  return _generateRegisteredMockPolicies.apply(this, arguments);
}

function policyManagerConfigArgs(_x3, _x4) {
  return _policyManagerConfigArgs.apply(this, arguments);
}

function _policyManagerConfigArgs() {
  _policyManagerConfigArgs = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee3(policies, settingsData) {
    return regeneratorRuntime.wrap(function _callee3$(_context3) {
      while (1) {
        switch (_context3.prev = _context3.next) {
          case 0:
            return _context3.abrupt("return", encodeArgs(['address[]', 'bytes[]'], [policies, settingsData]));

          case 1:
          case "end":
            return _context3.stop();
        }
      }
    }, _callee3);
  }));
  return _policyManagerConfigArgs.apply(this, arguments);
}

function validateRulePreBuySharesArgs(_x5) {
  return _validateRulePreBuySharesArgs.apply(this, arguments);
}

function _validateRulePreBuySharesArgs() {
  _validateRulePreBuySharesArgs = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee4(_ref3) {
    var _ref3$buyer, buyer, _ref3$investmentAmoun, investmentAmount, _ref3$minSharesQuanti, minSharesQuantity, _ref3$gav, gav;

    return regeneratorRuntime.wrap(function _callee4$(_context4) {
      while (1) {
        switch (_context4.prev = _context4.next) {
          case 0:
            _ref3$buyer = _ref3.buyer, buyer = _ref3$buyer === void 0 ? randomAddress() : _ref3$buyer, _ref3$investmentAmoun = _ref3.investmentAmount, investmentAmount = _ref3$investmentAmoun === void 0 ? utils.parseEther('1') : _ref3$investmentAmoun, _ref3$minSharesQuanti = _ref3.minSharesQuantity, minSharesQuantity = _ref3$minSharesQuanti === void 0 ? utils.parseEther('1') : _ref3$minSharesQuanti, _ref3$gav = _ref3.gav, gav = _ref3$gav === void 0 ? 0 : _ref3$gav;
            return _context4.abrupt("return", encodeArgs(['address', 'uint256', 'uint256', 'uint256'], [buyer, investmentAmount, minSharesQuantity, gav]));

          case 2:
          case "end":
            return _context4.stop();
        }
      }
    }, _callee4);
  }));
  return _validateRulePreBuySharesArgs.apply(this, arguments);
}

function validateRulePostBuySharesArgs(buyer, investmentAmount, sharesBought) {
  return encodeArgs(['address', 'uint256', 'uint256'], [buyer, investmentAmount, sharesBought]);
}
function validateRulePreCoIArgs(adapter, selector) {
  return encodeArgs(['address', 'bytes4'], [adapter, selector]);
}
function validateRulePostCoIArgs(adapter, selector, incomingAssets, incomingAssetAmounts, outgoingAssets, outgoingAssetAmounts) {
  return encodeArgs(['address', 'bytes4', 'address[]', 'uint256[]', 'address[]', 'uint256[]'], [adapter, selector, incomingAssets, incomingAssetAmounts, outgoingAssets, outgoingAssetAmounts]);
} // Policies

function adapterBlacklistArgs(_x6) {
  return _adapterBlacklistArgs.apply(this, arguments);
}

function _adapterBlacklistArgs() {
  _adapterBlacklistArgs = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee5(adapters) {
    return regeneratorRuntime.wrap(function _callee5$(_context5) {
      while (1) {
        switch (_context5.prev = _context5.next) {
          case 0:
            return _context5.abrupt("return", encodeArgs(['address[]'], [adapters]));

          case 1:
          case "end":
            return _context5.stop();
        }
      }
    }, _callee5);
  }));
  return _adapterBlacklistArgs.apply(this, arguments);
}

function adapterWhitelistArgs(_x7) {
  return _adapterWhitelistArgs.apply(this, arguments);
}

function _adapterWhitelistArgs() {
  _adapterWhitelistArgs = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee6(adapters) {
    return regeneratorRuntime.wrap(function _callee6$(_context6) {
      while (1) {
        switch (_context6.prev = _context6.next) {
          case 0:
            return _context6.abrupt("return", encodeArgs(['address[]'], [adapters]));

          case 1:
          case "end":
            return _context6.stop();
        }
      }
    }, _callee6);
  }));
  return _adapterWhitelistArgs.apply(this, arguments);
}

function assetBlacklistArgs(_x8) {
  return _assetBlacklistArgs.apply(this, arguments);
}

function _assetBlacklistArgs() {
  _assetBlacklistArgs = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee7(assets) {
    return regeneratorRuntime.wrap(function _callee7$(_context7) {
      while (1) {
        switch (_context7.prev = _context7.next) {
          case 0:
            return _context7.abrupt("return", encodeArgs(['address[]'], [assets]));

          case 1:
          case "end":
            return _context7.stop();
        }
      }
    }, _callee7);
  }));
  return _assetBlacklistArgs.apply(this, arguments);
}

function assetWhitelistArgs(_x9) {
  return _assetWhitelistArgs.apply(this, arguments);
}

function _assetWhitelistArgs() {
  _assetWhitelistArgs = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee8(assets) {
    return regeneratorRuntime.wrap(function _callee8$(_context8) {
      while (1) {
        switch (_context8.prev = _context8.next) {
          case 0:
            return _context8.abrupt("return", encodeArgs(['address[]'], [assets]));

          case 1:
          case "end":
            return _context8.stop();
        }
      }
    }, _callee8);
  }));
  return _assetWhitelistArgs.apply(this, arguments);
}

function buySharesPriceFeedToleranceArgs(_x10) {
  return _buySharesPriceFeedToleranceArgs.apply(this, arguments);
}

function _buySharesPriceFeedToleranceArgs() {
  _buySharesPriceFeedToleranceArgs = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee9(tolerance) {
    return regeneratorRuntime.wrap(function _callee9$(_context9) {
      while (1) {
        switch (_context9.prev = _context9.next) {
          case 0:
            return _context9.abrupt("return", encodeArgs(['uint256'], [tolerance]));

          case 1:
          case "end":
            return _context9.stop();
        }
      }
    }, _callee9);
  }));
  return _buySharesPriceFeedToleranceArgs.apply(this, arguments);
}

function investorWhitelistArgs(_x11) {
  return _investorWhitelistArgs.apply(this, arguments);
}

function _investorWhitelistArgs() {
  _investorWhitelistArgs = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee10(_ref4) {
    var _ref4$investorsToAdd, investorsToAdd, _ref4$investorsToRemo, investorsToRemove;

    return regeneratorRuntime.wrap(function _callee10$(_context10) {
      while (1) {
        switch (_context10.prev = _context10.next) {
          case 0:
            _ref4$investorsToAdd = _ref4.investorsToAdd, investorsToAdd = _ref4$investorsToAdd === void 0 ? [] : _ref4$investorsToAdd, _ref4$investorsToRemo = _ref4.investorsToRemove, investorsToRemove = _ref4$investorsToRemo === void 0 ? [] : _ref4$investorsToRemo;
            return _context10.abrupt("return", encodeArgs(['address[]', 'address[]'], [investorsToAdd, investorsToRemove]));

          case 2:
          case "end":
            return _context10.stop();
        }
      }
    }, _callee10);
  }));
  return _investorWhitelistArgs.apply(this, arguments);
}

function maxConcentrationArgs(_x12) {
  return _maxConcentrationArgs.apply(this, arguments);
}

function _maxConcentrationArgs() {
  _maxConcentrationArgs = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee11(maxConcentration) {
    return regeneratorRuntime.wrap(function _callee11$(_context11) {
      while (1) {
        switch (_context11.prev = _context11.next) {
          case 0:
            return _context11.abrupt("return", encodeArgs(['uint256'], [maxConcentration]));

          case 1:
          case "end":
            return _context11.stop();
        }
      }
    }, _callee11);
  }));
  return _maxConcentrationArgs.apply(this, arguments);
}

function buyShares(_x) {
  return _buyShares.apply(this, arguments);
}

function _buyShares() {
  _buyShares = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee(_ref) {
    var comptrollerProxy, signer, buyer, denominationAsset, _ref$amguValue, amguValue, _ref$investmentAmount, investmentAmount, _ref$minSharesAmount, minSharesAmount, callerDenominationAsset, callerComptrollerProxy;

    return regeneratorRuntime.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            comptrollerProxy = _ref.comptrollerProxy, signer = _ref.signer, buyer = _ref.buyer, denominationAsset = _ref.denominationAsset, _ref$amguValue = _ref.amguValue, amguValue = _ref$amguValue === void 0 ? utils.parseEther('1') : _ref$amguValue, _ref$investmentAmount = _ref.investmentAmount, investmentAmount = _ref$investmentAmount === void 0 ? utils.parseEther('1') : _ref$investmentAmount, _ref$minSharesAmount = _ref.minSharesAmount, minSharesAmount = _ref$minSharesAmount === void 0 ? investmentAmount : _ref$minSharesAmount;
            callerDenominationAsset = denominationAsset.connect(signer);
            _context.next = 4;
            return callerDenominationAsset.approve(comptrollerProxy, investmentAmount);

          case 4:
            callerComptrollerProxy = comptrollerProxy.connect(signer);
            return _context.abrupt("return", callerComptrollerProxy.buyShares.args(buyer, investmentAmount, minSharesAmount).value(amguValue).send());

          case 6:
          case "end":
            return _context.stop();
        }
      }
    }, _callee);
  }));
  return _buyShares.apply(this, arguments);
}

function redeemShares(_x2) {
  return _redeemShares.apply(this, arguments);
}

function _redeemShares() {
  _redeemShares = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee2(_ref2) {
    var comptrollerProxy, signer, quantity, _ref2$additionalAsset, additionalAssets, _ref2$assetsToSkip, assetsToSkip;

    return regeneratorRuntime.wrap(function _callee2$(_context2) {
      while (1) {
        switch (_context2.prev = _context2.next) {
          case 0:
            comptrollerProxy = _ref2.comptrollerProxy, signer = _ref2.signer, quantity = _ref2.quantity, _ref2$additionalAsset = _ref2.additionalAssets, additionalAssets = _ref2$additionalAsset === void 0 ? [] : _ref2$additionalAsset, _ref2$assetsToSkip = _ref2.assetsToSkip, assetsToSkip = _ref2$assetsToSkip === void 0 ? [] : _ref2$assetsToSkip;

            if (!(quantity == undefined)) {
              _context2.next = 7;
              break;
            }

            if (!(additionalAssets.length > 0 || assetsToSkip.length > 0)) {
              _context2.next = 4;
              break;
            }

            throw 'Must specify shares quantity if specifying additional assets or assets to skip';

          case 4:
            return _context2.abrupt("return", comptrollerProxy.connect(signer).redeemShares());

          case 7:
            return _context2.abrupt("return", comptrollerProxy.connect(signer).redeemSharesDetailed(quantity, additionalAssets, assetsToSkip));

          case 8:
          case "end":
            return _context2.stop();
        }
      }
    }, _callee2);
  }));
  return _redeemShares.apply(this, arguments);
}

function createComptrollerProxy(_x) {
  return _createComptrollerProxy.apply(this, arguments);
}

function _createComptrollerProxy() {
  _createComptrollerProxy = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee(_ref) {
    var signer, comptrollerLib, denominationAsset, _ref$sharesActionTime, sharesActionTimelock, _ref$allowedBuyShares, allowedBuySharesCallers, _ref$feeManagerConfig, feeManagerConfigData, _ref$policyManagerCon, policyManagerConfigData, constructData, comptrollerProxyContract, deployComptrollerProxyReceipt;

    return regeneratorRuntime.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            signer = _ref.signer, comptrollerLib = _ref.comptrollerLib, denominationAsset = _ref.denominationAsset, _ref$sharesActionTime = _ref.sharesActionTimelock, sharesActionTimelock = _ref$sharesActionTime === void 0 ? 0 : _ref$sharesActionTime, _ref$allowedBuyShares = _ref.allowedBuySharesCallers, allowedBuySharesCallers = _ref$allowedBuyShares === void 0 ? [] : _ref$allowedBuyShares, _ref$feeManagerConfig = _ref.feeManagerConfigData, feeManagerConfigData = _ref$feeManagerConfig === void 0 ? '0x' : _ref$feeManagerConfig, _ref$policyManagerCon = _ref.policyManagerConfigData, policyManagerConfigData = _ref$policyManagerCon === void 0 ? '0x' : _ref$policyManagerCon;
            constructData = comptrollerLib.abi.encodeFunctionData(comptrollerLib.init.fragment, [denominationAsset, sharesActionTimelock, allowedBuySharesCallers, feeManagerConfigData, policyManagerConfigData]);
            _context.next = 4;
            return ComptrollerProxy.deploy(signer, constructData, comptrollerLib);

          case 4:
            comptrollerProxyContract = _context.sent;
            deployComptrollerProxyReceipt = comptrollerProxyContract.deployment;
            return _context.abrupt("return", {
              comptrollerProxy: new ComptrollerLib(comptrollerProxyContract.address, signer),
              deployComptrollerProxyReceipt: deployComptrollerProxyReceipt
            });

          case 7:
          case "end":
            return _context.stop();
        }
      }
    }, _callee);
  }));
  return _createComptrollerProxy.apply(this, arguments);
}

function createMigratedFundConfig(_x2) {
  return _createMigratedFundConfig.apply(this, arguments);
} // TODO: should we pass in the fundOwner as a signer also so we can connect comptroller proxy and vault proxy to that acct instead?

function _createMigratedFundConfig() {
  _createMigratedFundConfig = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee2(_ref2) {
    var signer, fundDeployer, denominationAsset, _ref2$sharesActionTim, sharesActionTimelock, _ref2$allowedBuyShare, allowedBuySharesCallers, _ref2$feeManagerConfi, feeManagerConfigData, _ref2$policyManagerCo, policyManagerConfigData, newFundConfigTx, signerAddress, denominationAssetAddress, allowedBuySharesCallersAddresses, comptrollerDeployedArgs;

    return regeneratorRuntime.wrap(function _callee2$(_context2) {
      while (1) {
        switch (_context2.prev = _context2.next) {
          case 0:
            signer = _ref2.signer, fundDeployer = _ref2.fundDeployer, denominationAsset = _ref2.denominationAsset, _ref2$sharesActionTim = _ref2.sharesActionTimelock, sharesActionTimelock = _ref2$sharesActionTim === void 0 ? 0 : _ref2$sharesActionTim, _ref2$allowedBuyShare = _ref2.allowedBuySharesCallers, allowedBuySharesCallers = _ref2$allowedBuyShare === void 0 ? [] : _ref2$allowedBuyShare, _ref2$feeManagerConfi = _ref2.feeManagerConfigData, feeManagerConfigData = _ref2$feeManagerConfi === void 0 ? '0x' : _ref2$feeManagerConfi, _ref2$policyManagerCo = _ref2.policyManagerConfigData, policyManagerConfigData = _ref2$policyManagerCo === void 0 ? '0x' : _ref2$policyManagerCo;
            newFundConfigTx = fundDeployer.connect(signer).createMigratedFundConfig(denominationAsset, sharesActionTimelock, allowedBuySharesCallers, feeManagerConfigData, policyManagerConfigData);
            _context2.next = 4;
            return expect(newFundConfigTx).resolves.toBeReceipt();

          case 4:
            _context2.next = 6;
            return resolveAddress(signer);

          case 6:
            signerAddress = _context2.sent;
            _context2.next = 9;
            return resolveAddress(denominationAsset);

          case 9:
            denominationAssetAddress = _context2.sent;
            allowedBuySharesCallersAddresses = allowedBuySharesCallers.map(function (caller) {
              return resolveAddress(caller);
            });
            _context2.next = 13;
            return assertEvent(newFundConfigTx, 'ComptrollerProxyDeployed', {
              creator: signerAddress,
              comptrollerProxy: expect.any(String),
              denominationAsset: denominationAssetAddress,
              sharesActionTimelock: BigNumber.from(sharesActionTimelock),
              allowedBuySharesCallers: allowedBuySharesCallersAddresses,
              feeManagerConfigData: utils.hexlify(feeManagerConfigData),
              policyManagerConfigData: utils.hexlify(policyManagerConfigData),
              forMigration: true
            });

          case 13:
            comptrollerDeployedArgs = _context2.sent;
            return _context2.abrupt("return", {
              comptrollerProxy: new ComptrollerLib(comptrollerDeployedArgs.comptrollerProxy, signer),
              newFundConfigTx: newFundConfigTx
            });

          case 15:
          case "end":
            return _context2.stop();
        }
      }
    }, _callee2);
  }));
  return _createMigratedFundConfig.apply(this, arguments);
}

function createNewFund(_x3) {
  return _createNewFund.apply(this, arguments);
}

function _createNewFund() {
  _createNewFund = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee3(_ref3) {
    var signer, fundDeployer, denominationAsset, _ref3$sharesActionTim, sharesActionTimelock, _ref3$allowedBuyShare, allowedBuySharesCallers, _ref3$fundOwner, fundOwner, _ref3$fundName, fundName, _ref3$feeManagerConfi, feeManagerConfig, _ref3$policyManagerCo, policyManagerConfig, investment, newFundTx, creator, denominationAssetAddress, allowedBuySharesCallersAddresses, comptrollerDeployedArgs, comptrollerProxy, fundOwnerAddress, newFundDeployedArgs, vaultProxy;

    return regeneratorRuntime.wrap(function _callee3$(_context3) {
      while (1) {
        switch (_context3.prev = _context3.next) {
          case 0:
            signer = _ref3.signer, fundDeployer = _ref3.fundDeployer, denominationAsset = _ref3.denominationAsset, _ref3$sharesActionTim = _ref3.sharesActionTimelock, sharesActionTimelock = _ref3$sharesActionTim === void 0 ? 0 : _ref3$sharesActionTim, _ref3$allowedBuyShare = _ref3.allowedBuySharesCallers, allowedBuySharesCallers = _ref3$allowedBuyShare === void 0 ? [] : _ref3$allowedBuyShare, _ref3$fundOwner = _ref3.fundOwner, fundOwner = _ref3$fundOwner === void 0 ? randomAddress() : _ref3$fundOwner, _ref3$fundName = _ref3.fundName, fundName = _ref3$fundName === void 0 ? 'My Fund' : _ref3$fundName, _ref3$feeManagerConfi = _ref3.feeManagerConfig, feeManagerConfig = _ref3$feeManagerConfi === void 0 ? '0x' : _ref3$feeManagerConfi, _ref3$policyManagerCo = _ref3.policyManagerConfig, policyManagerConfig = _ref3$policyManagerCo === void 0 ? '0x' : _ref3$policyManagerCo, investment = _ref3.investment;
            newFundTx = fundDeployer.connect(signer).createNewFund(fundOwner, fundName, denominationAsset, sharesActionTimelock, allowedBuySharesCallers, feeManagerConfig, policyManagerConfig);
            _context3.next = 4;
            return expect(newFundTx).resolves.toBeReceipt();

          case 4:
            _context3.next = 6;
            return resolveAddress(signer);

          case 6:
            creator = _context3.sent;
            _context3.next = 9;
            return resolveAddress(denominationAsset);

          case 9:
            denominationAssetAddress = _context3.sent;
            allowedBuySharesCallersAddresses = allowedBuySharesCallers.map(function (caller) {
              return resolveAddress(caller);
            });
            _context3.next = 13;
            return assertEvent(newFundTx, 'ComptrollerProxyDeployed', {
              creator: creator,
              comptrollerProxy: expect.any(String),
              denominationAsset: denominationAssetAddress,
              sharesActionTimelock: BigNumber.from(sharesActionTimelock),
              allowedBuySharesCallers: allowedBuySharesCallersAddresses,
              feeManagerConfigData: utils.hexlify(feeManagerConfig),
              policyManagerConfigData: utils.hexlify(policyManagerConfig),
              forMigration: false
            });

          case 13:
            comptrollerDeployedArgs = _context3.sent;
            comptrollerProxy = new ComptrollerLib(comptrollerDeployedArgs.comptrollerProxy, signer);
            _context3.next = 17;
            return resolveAddress(fundOwner);

          case 17:
            fundOwnerAddress = _context3.sent;
            _context3.next = 20;
            return assertEvent(newFundTx, 'NewFundCreated', {
              creator: creator,
              comptrollerProxy: comptrollerProxy.address,
              vaultProxy: expect.any(String),
              fundOwner: fundOwnerAddress,
              fundName: fundName,
              denominationAsset: denominationAssetAddress,
              sharesActionTimelock: BigNumber.from(sharesActionTimelock),
              allowedBuySharesCallers: allowedBuySharesCallersAddresses,
              feeManagerConfigData: utils.hexlify(feeManagerConfig),
              policyManagerConfigData: utils.hexlify(policyManagerConfig)
            });

          case 20:
            newFundDeployedArgs = _context3.sent;
            vaultProxy = new VaultLib(newFundDeployedArgs.vaultProxy, signer);

            if (!(investment != null)) {
              _context3.next = 25;
              break;
            }

            _context3.next = 25;
            return buyShares(_objectSpread2({
              comptrollerProxy: comptrollerProxy,
              denominationAsset: denominationAsset
            }, investment));

          case 25:
            return _context3.abrupt("return", {
              comptrollerProxy: comptrollerProxy,
              newFundTx: newFundTx,
              vaultProxy: vaultProxy
            });

          case 26:
          case "end":
            return _context3.stop();
        }
      }
    }, _callee3);
  }));
  return _createNewFund.apply(this, arguments);
}

var releaseStatusTypes;

(function (releaseStatusTypes) {
  releaseStatusTypes[releaseStatusTypes["PreLaunch"] = 0] = "PreLaunch";
  releaseStatusTypes[releaseStatusTypes["Live"] = 1] = "Live";
  releaseStatusTypes[releaseStatusTypes["Paused"] = 2] = "Paused";
})(releaseStatusTypes || (releaseStatusTypes = {}));

export { IKyberNetworkProxy, adapterBlacklistArgs, adapterWhitelistArgs, addTrackedAssets, addTrackedAssetsArgs, addTrackedAssetsFragment, addTrackedAssetsSelector, assertEvent, assertNoEvent, assetBlacklistArgs, assetTransferArgs, assetWhitelistArgs, bigNumberMax, buyShares, buySharesPriceFeedToleranceArgs, callOnExtension, callOnIntegrationArgs, callOnIntegrationFragment, callOnIntegrationSelector, chaiLend, chaiLendArgs, chaiRedeem, chaiRedeemArgs, configureMockRelease, createComptrollerProxy, createDeploymentProxy, createMigratedFundConfig, createNewFund, createUnsignedZeroExV2Order, createZeroExV2OrderTypedData, defaultForkDeployment, defaultPersistetTestDeployment, defaultTestDeployment, deployMocks, deployPersistent, deployRelease, describeDeployment, encodeArgs, encodeArgsSync, encodeFunctionData, encodeZeroExV2AssetData, encodeZeroExV2Order, engineAdapterTakeOrder, engineAdapterTakeOrderArgs, engineTakeOrderArgs, entranceRateFeeConfigArgs, entranceRateFeeSharesDue, feeHooks, feeManagerActionIds, feeSettlementTypes, generateFeeManagerConfigWithMockFees, generatePolicyManagerConfigWithMockPolicies, generatePseudoRandomZeroExV2Salt, generateRegisteredMockFees, generateRegisteredMockPolicies, getAssetBalances, integrationManagerActionIds, investorWhitelistArgs, kyberTakeOrder, kyberTakeOrderArgs, lendFragment, lendSelector, makeEthRich, makeTokenRich, makeWethRich, managementFeeConfigArgs, managementFeeSharesDue, maxConcentrationArgs, mockGenericSwap, mockGenericSwapASelector, mockGenericSwapArgs, mockGenericSwapBSelector, mockGenericSwapCSelector, performanceFeeConfigArgs, performanceFeeSharesDue, policyHooks, policyManagerConfigArgs, redeemFragment, redeemSelector, redeemShares, releaseStatusTypes, resolveDeploymentProxy, seedAndThawEngine, settleContinuousFeesFragment, settleContinuousFeesSelector, settlePostBuySharesArgs, settlePreBuySharesArgs, sharesDueWithInflation, sighash, signZeroExV2Order, spendAssetsHandleTypes, takeOrderFragment, takeOrderSelector, updateChainlinkAggregator, validateRulePostBuySharesArgs, validateRulePostCoIArgs, validateRulePreBuySharesArgs, validateRulePreCoIArgs, warpEngine, zeroExV2AssetFragment, zeroExV2TakeOrder, zeroExV2TakeOrderArgs };
